geometry = examples/saw_3d.geo
mesh = examples/saw_3d.vol

// lam = 8
// omega = 2 Pi / lam  = 0.78

define coefficient coef_lam
1, 1, 1,
define coefficient coef_mass
1e5, 1e5, (-0.617),

define coefficient absorb
0, 0, 0.7854, 0, 0, 
0.7854, 0, 0.7854, 0, 0,
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0,

define coefficient absorb2
0, 0, (-0.6366), 0, 0, 
(-0.6366), 0, (-0.6366), 0, 0,
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0,

define coefficient coef_source
1e5, (-1e5), 0,

define fespace v -order=1 -complex

define gridfunction u -fespace=v -nested

define bilinearform a -fespace=v
laplace coef_lam
robin absorb -imag
mass coef_mass
laplaceboundary absorb2 -imag

define linearform f -fespace=v
source coef_source

# define preconditioner c -type=local -bilinearform=a -smoothingsteps=2

define preconditioner c -type=multigrid -bilinearform=a -coarsetype=exact -coarsesmoothingsteps=1 -smoothingsteps=2 -cylce=1
numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -qmr -maxsteps=5000

# numproc setvisual npv -scalfunction=u_1


