geometry = examples/coilshield.geo
mesh = examples/coilshield.vol

define coefficient nu
1e-3, 1, 1

define coefficient kappa
1e-5, 1e-5, 1e-5

define coefficient cs1
0, ( x2 ), 0
define coefficient cs2
0, ( -x1 ), 0
define coefficient cs3
0, 0, 0

define coefficient penalty
1, 0, 0, 0, 0, 0


define fespace v -hcurl
define fespace v2 -hcurl -order=2
define fespace vp -l2 -dim=3 -order=1
define fespace vpn -order=2 -dim=3

define gridfunction u2 -fespace=v2
define gridfunction b -fespace=vp
define gridfunction bnodal -fespace=vpn

define bilinearform a -fespace=v
  rotrotedge nu
  massedge kappa
  robinedge penalty

define bilinearform a2 -fespace=v2
  rotrotedge nu
  massedge kappa
  robinedge penalty

define linearform f2 -fespace=v2
  sourceedge cs1 cs2 cs3

define preconditioner c -type=multigrid -bilinearform=a -smoother=maxwell
define preconditioner c2 -type=twolevel -bilinearform=a2 -coarsepreconditioner=c
# define preconditioner c2 -type=local

numproc bvp np1 -bilinearform=a2 -linearform=f2 -gridfunction=u2 -preconditioner=c2 -maxsteps=20
numproc calcflux np2 -bilinearform=a2 -solution=u2 -flux=b
numproc zzerrorestimator np3 -bilinearform=a2 -linearform=f2 -flux=b -nodalflux=bnodal -minlevel=1 




