geometry = examples/shaft.geo
mesh = ngsolve/pde_tutorial/shaft.vol

define coefficient E
1, 

define coefficient nu
0.2, 

define coefficient penalty1
1e6, 0, 0, 0, 0, 0, 0

define coefficient penalty2
0, 0, 0.01, 0, 0, 0, 0

define coefficient forcez
0, 1, 0, 0, 

define fespace v -dim=3 -order=2
define fespace vlin -dim=3 -order=1
define fespace vp -dim=6 

define gridfunction u -fespace=v
define gridfunction p -fespace=vp

define bilinearform a -fespace=v 
elasticity E nu
robin penalty1 -normal
robin penalty2

define bilinearform alin -fespace=vlin
elasticity E nu
robin penalty1 -normal
robin penalty2

define linearform f -fespace=v
neumann forcez -comp=3


define preconditioner clin -type=multigrid -bilinearform=alin
define preconditioner c -type=twolevel -bilinearform=a -coarsepreconditioner=clin


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c
numproc calcflux np2 -bilinearform=a -solution=u -flux=p 
numproc zzerrorestimator np3 -bilinearform=a -linearform=f -flux=p -solution=u

