geometry = ngsolve/mechsolve/balken.geo
mesh = ngsolve/mechsolve/balkenc.vol

define coefficient e
1e11,

define coefficient e2
2e11,

define coefficient nu
0,

define coefficient penalty
1e30, 0, 0, 

define coefficient coef_force_z
0, 10e6, 0,

define coefficient rho
1500,

define fespace v -h1ho -order=3 -dim=3
define gridfunction u -fespace=v -nested

define fespace vstress -h1ho -order=1 -dim=6
define gridfunction stress -fespace=vstress

define bilinearform alin -fespace=v -symmetric
elasticity e nu
robin penalty -comp=1
robin penalty -comp=2
robin penalty -comp=3

define bilinearform a -fespace=v -symmetric
nonlinmech e2 nu
robin penalty -comp=1
robin penalty -comp=2
robin penalty -comp=3

define bilinearform m -fespace=v -symmetric
mass rho -comp=1
mass rho -comp=2
mass rho -comp=3

define linearform f -fespace=v
neumann coef_force_z -comp=3

define preconditioner c -type=direct -bilinearform=alin

# numproc bvp np1 -bilinearform=alin -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000 -print

numproc lindyna np1 -bfa=alin -bfm=m -linearform=f -gridfunction=u -preconditioner=c -timesteps=50000 -tau=0.0002 


numproc drawflux np2 -bilinearform=a -solution=u -label=elstress
# numproc calcflux np3 -bilinearform=a -solution=u -flux=stress