geometry = ngsolve/mechsolve/balken.geo

mesh = ngsolve/mechsolve/balken.vol


define constant geometryorder = 1

define coefficient e
1e11,

define coefficient e2
2e11,

define coefficient nu

0.2,


define coefficient penalty
1e30, 0, 0,

define coefficient coef_force_z

0, 3e9, 0,


define fespace v -h1ho -order=3 -dim=3
define gridfunction u -fespace=v -nested

define fespace vstress -h1ho -order=3 -dim=6
define gridfunction stress -fespace=vstress

define bilinearform alin -fespace=v -symmetric
elasticity e2 nu
robin penalty -comp=1
robin penalty -comp=2
robin penalty -comp=3

define bilinearform a -fespace=v -symmetric
nonlinmech e2 nu
robin penalty -comp=1
robin penalty -comp=2
robin penalty -comp=3

define linearform f -fespace=v
neumann coef_force_z -comp=3
neumann coef_force_x -comp=1

define preconditioner c -type=direct -bilinearform=alin


# numproc bvp np1lin -bilinearform=alin -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000 -print
# numproc bvp np1 -bilinearform=alin -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000 -noprint



numproc nonlinelast np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=50






numproc drawflux np2 -bilinearform=alin -solution=u -label=elstress
numproc calcflux np3 -bilinearform=alin -solution=u -flux=stress
