geometry = spheres.geo
mesh = spheres.vol
# overlap = 1

define constant heapsize = 60000000

define constant geometryorder = 2
# define constant rationalgeometry = 2
define constant k = 50

define coefficient mu_real
1, 1, 1

define coefficient omega
(k), (k), (k)

define coefficient eps_real
1, 1, 1

define coefficient source_j
0, 10

define coefficient cplot
1, 0

#define coefficient crobin bcnames
#	internal 0
#	cut 0
#	external -1
 
define coefficient crobin
-1 0 0

define coefficient zero 
0, 0, 0, 0, 

define fespace v -type=hybridmaxwell -order=1 -complex -eliminate_internal

define gridfunction u -fespace=v

define linearform f -fespace=v
sourceedge source_j zero zero -comp=2

define bilinearform a -fespace=v -eliminate_internal -linearform=f -nosymmetric
hybridmaxwellreal omega eps_real mu_real   
hybridmaxwellfacet
robinvectorfacet crobin -comp=3



#define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
# define preconditioner c -type=multigrid -bilinearform=a -smoother=block -blocktype=1 -coarsetype=smoothing -inverse=sparsecholesky -coarsesmoothingsteps=1 -notest
 define preconditioner c -type=local -block  -smoother=block  -bilinearform=a -blocktype=1  -noinverse=sparsecholesky 


numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f 
	-gridfunction=u  -maxsteps=500 -prec=1e-10

define bilinearform aE -fespace=v -nonassemble
massedge cplot  -comp=1
robinedge crobin -comp=1

define bilinearform aH -fespace=v -nonassemble
massedge cplot -comp=2
robinedge crobin -comp=2

define bilinearform aEf -fespace=v -nonassemble
massvectorfacet cplot -comp=3
robinedge crobin -comp=3

define bilinearform aHf -fespace=v -nonassemble
massvectorfacet cplot -comp=4
robinedge crobin -comp=4

numproc drawflux df1a -bilinearform=aE -solution=u -label=E -applyd -useall
numproc drawflux df1b -bilinearform=aH -solution=u -label=H -applyd -useall
numproc drawflux drawu -bilinearform=aEf -solution=u -label=E_F -applyd -useall
numproc drawflux df1a1 -bilinearform=aHf -solution=u -label=H_F -applyd  -useall

numproc visualization vis -scalarfunction=E -subdivision=3 -nolineartexture -nminval=10 -nmaxval=150 -clipvec=[1,0,0] -clipsolution=scalar

