geometry = ngsolve/ngsusers/astrid/helmholtz/circles_hole.in2d
mesh = ngsolve/ngsusers/astrid/helmholtz/circles_hole.vol

#geometry = ngsolve/ngsusers/astrid/examples/square.in2d
#mesh = ngsolve/ngsusers/astrid/examples/square.vol
overlap = 1

define constant heapsize = 60000000

define constant geometryorder = 1
define constant k = 10

define coefficient kappa
(k) (k) (k)

define coefficient eta 
1  1  1  

define coefficient one
0, 1

define coefficient source_j
10

define coefficient cplot
1, 1

define coefficient crobin
1e10, 1e10 1e10 , 0,

define coefficient crobin_dual
1e10, 0, 0

define coefficient q
-0, 0


##################################
#  hybrid problem
##################################

define fespace v -type=uwvf -waveorder=9 -polyorder=3 -complex -dist=0.002

define fespace vl2 -type=l2 -order=0 -complex

define gridfunction u -fespace=v

define gridfunction ul2 -fespace=vl2

define linearform f -fespace=v # -printelvec
helmholtzuwvf_neumann one kappa eta

define bilinearform a -fespace=v -printelmat 
helmholtzuwvf kappa eta q

define bilinearform avis -fespace=v -nonassemble
helmholtzvis one

define bilinearform avissig -fespace=v -nonassemble
helmholtzvissigma one

# define preconditioner c -type=direct -inverse=pardiso -bilinearform=a

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -nopreconditioner=c -solver=bicgstab -maxsteps=600 # -print


numproc drawflux df1a -bilinearform=avis -solution=u -label=U
numproc drawflux df1a -bilinearform=avissig -solution=u -label=sigma
numproc calcflux df2a -bilinearform=a -solution=u -flux=ul2

numproc visualization vis -scalarfunction=U -comp=1 -nolineartexture -subdivision=2
