#geometry = squarenew.in2d
#mesh = squarenew.vol
geometry = beam.in2d
mesh = beam.vol

define constant heapsize = 1000000000
define constant geometryorder = 1

define coefficient e
10 100

define coefficient nu
0.4 0.4

define coefficient zero
0 0 0 0 0 0 0 0 0 0

define coefficient penaltyun
0 0 0 -1e15 0  0 0 0 0 0


define coefficient penaltyrhsun
0 -1e14 0  0  0 0 0 0 0

define coefficient penaltyutau
0 0 0  -1e14   0 0 0 0 0 0 0 0 0

define coefficient penaltyrhsutau
0 0  0 0 0 0 0 0 0 0 0

define coefficient sigmann
0 (0) 0 0 , 0, 0  0 0 0 0

define coefficient sigmantau
0 -0.0001 0 0 , 0, 0  0 0 0 0

define coefficient reg
1e-10  1e-10

define coefficient lam
1 1 1 

define coefficient sy 
1


define coefficient one
1  1   1  1  1 1
define coefficient one3
0 1 0  0  1 1 1 1 

define fespace v -mixedmechhybrid -eliminate_internal -order=5 -facetorder=5  -orderz=6
	-curlorder=5 -curlorderz=5
	-lagrangeorder=5 -lagrangeorderz=6
	-alternative=0

define gridfunction u -fespace=v 


define linearform f -fespace=v 
mixedmechsource zero sy one  -order=6
#neumannhybrid sigmann -comp=3 -order=9
#neumannhybrid penaltyrhsun -comp=3 -order=9
#neumannedge zero sigmantau   -comp=2 -order=16
#sourcehdivsym one one one -comp=1
# sourceedge sigmann sigmann -comp=2

define linearform f2 -fespace=v 
#mixedmechsource zero  sy one  -order=9
#neumannhybrid one3 -comp=3 -order=9
neumannedge zero one3   -comp=2 -order=6
#sourcehdivsym one one one -comp=1
# sourceedge sigmann sigmann -comp=2


define bilinearform a -fespace=v -symmetric -eliminate_internal -linearform=f 
  mixedmechh e nu reg one  -order=12
  robinedge penaltyutau -comp=2         -order=12
  robinhybrid penaltyun -comp=3 -order=12
#divdivhdivsym hsqr -comp=1
#masshdivsym one -order=12 -comp=1
# mixedmechhybridmass one -order=12 -comp=1
#mixedmechhybridmass one -order=12 -comp=3

define preconditioner c1 -type=direct -bilinearform=a -inverse=sparsecholesky
#define preconditioner c1 -type=multigrid   -smoother=block  -blocktype=7 -bilinearform=a -coarsetype=smoothing -ds_cluster=2

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c1 -maxsteps=1000  -prec=1e-12 -print

define bilinearform adiv -fespace=v -nonassemble
divdivhdivsym lam -comp=1

define bilinearform adisp -fespace=v -nonassemble
massedge one -comp=2 -order=6

define bilinearform acurldisp -fespace=v -nonassemble
curlcurledge one -comp=2

define bilinearform amasshdiv -fespace=v -nonassemble
masshdivsym one -comp=1



numproc drawflux np2 -bilinearform=amasshdiv -solution=u -label=sigma
numproc drawflux np3 -bilinearform=adiv -solution=u -label=div_sigma
numproc drawflux np4 -bilinearform=adisp -solution=u -label=disp
numproc drawflux np5 -bilinearform=acurldisp -solution=u -label=curl


#define bilinearform adifference -fespace=v -nonassemble
#masshdivsym zero -comp=1
#massedge zero -comp=2

#define gridfunction d1 -fespace=v
#numproc difference npd1 -bilinearform=adifference -solution1=u -solution2=u1 -diff=d1
#define gridfunction d2 -fespace=v
#numproc difference npd2 -bilinearform=adifference -solution1=u -solution2=u2 -diff=d2

numproc evaluate npev -linearform=f2 -gridfunction=u
numproc visualization npvis -scalarfunction=disp -comp=2
	-nolineartexture -novectorfunction=disp -nodeformationscale=.1