 geometry  = gummibear.geo
 mesh = gummibear.vol

# geometry = contactbricks.geo
# mesh = contactbricks.vol



define constant geometryorder = 1
define constant heapsize = 10000000

define coefficient lam
1, 1,





define coefficient zero
0, 0, 


define coefficient penaltyu
 0 0 1e10 0 1e10 0 0 0        #gummibear
# 1e10 1e10 0 0 0   # contactbricks

define coefficient penaltyrhsu
0 0 0 0 0

define coefficient sy
1 1


define coefficient one
1, 1, 1 1 1 1 1 1 1 1 

define coefficient small
1, 1,

define coefficient vsmall
0, 1,

define coefficient stab
1e6, 1e6,

define coefficient reg
-1e-7, -1e-7,


define coefficient mone
-1, -1,


define coefficient nu
0.4999 0.2

define coefficient e
1 1

define coefficient zeroslong
0 0 0. 0 0 0 0 0 0 0 0

define coefficient penaltyrhsun
 0 0 0. 0 -0.4e10      # gummibear
# -5e8 0 0 0 0      #contacbricks


define coefficient penaltyun
 0 0 0 0 1e10      #gummibear
# 1e10 1e10 0 0 0 0        # contactbricks

define fespace v -mixedmechhybrid -eliminate_internal -order=1 -facetorder=1 -curlorder=1 
define gridfunction u -fespace=v

define fespace vsigma -l2ho -dim=6
define gridfunction sigma -fespace=vsigma
define fespace vu -l2ho -dim=3
define gridfunction disp -fespace=vu

define linearform f -fespace=v
neumannhybrid penaltyrhsun -comp=3

define bilinearform a -fespace=v -symmetric -eliminate_internal -linearform=f 
mixedmechh e nu reg one -order=3
robinhybrid penaltyun -comp=3 -order=3
robinedge penaltyu -comp=2         -order=3


define preconditioner c -type=direct -bilinearform=a
                     
numproc hybridcontact np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c 
	-maxsteps=3 -taun=0.25 -tautau=0
	-usteps=100 -cbound1=1 -cbound2=0 -friction=0 -taup=1 -gap=0.4    #gummibear
#	-usteps=1000 -cbound1=2 -cbound2=3 -friction=0 -taup=1 -gap=0.1   #contactbricks

#numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=3

define bilinearform adiv -fespace=v -nonassemble
divdivhdivsym lam -comp=1

define bilinearform adisp -fespace=v -nonassemble
massedge lam -comp=2
robinedge one -comp=2


define bilinearform acurldisp -fespace=v -nonassemble
curlcurledge lam -comp=2

define bilinearform amass -fespace=v -nonassemble
masshdivsym lam -comp=1

numproc drawflux np2 -bilinearform=amass -solution=u -label=sigmaf
numproc drawflux np3 -bilinearform=adiv -solution=u -label=div_sigma
numproc drawflux np4 -bilinearform=adisp -solution=u -label=dispf
numproc drawflux np5 -bilinearform=acurldisp -solution=u -label=curl


numproc calcflux np2 -bilinearform=amass -solution=u -flux=sigma
numproc calcflux np3 -bilinearform=adisp -solution=u -flux=disp


numproc visualization npvis -scalarfunction=sigma -comp=3 -vectorfunction=disp -deformationscale=1