#geometry = tet.geo
#mesh = tet.vol
#geometry = shell.geo
#mesh = shell.vol

geometry = cylinder.geo
mesh = cylinder.vol


define constant heapsize = 100000000
define constant geometryorder = 1



define coefficient e
1 2

define coefficient nu
0.4 0.4


define coefficient zero
0 0 0 0 0 0 0 0 0 0

define coefficient penaltyun
1e10 1e10  0 0 1e10 0 0

define coefficient penaltyutau
1e10 1e-9 0 0  1e10 0 0 0

define coefficient penaltyrhsutauy
0  0  0 00 

define coefficient penaltyrhsutauz
0  -.01  0 00 

define coefficient penaltyunrhs
0  1e9 0 0






define coefficient reg
1e-14 1e-14

define coefficient lam
1 1 1 

define coefficient sy 
.1  .1

define coefficient one 
1 1 1 1 1 


define fespace v -mixedmechhybrid -eliminate_internal -order=1
	-facetorder=1
	-curlorder=1
	-lagrangeorder=1
	-alternative=0

define gridfunction u -fespace=v
# define gridfunction u1 -fespace=v  
# define gridfunction u2 -fespace=v 


define linearform f -fespace=v -printelvec
#sourceedge   sy zero  zero  -comp=2
#neumannhybrid one -comp=3 -order=6
neumannhybrid penaltyunrhs -comp=3 -order=4
neumannedge zero penaltyrhsutauy penaltyrhsutauz -comp=2 -order=4
#mixedmechsource  zero zero sy one   -order=2
#divhdivsym hsqr zero zero  -comp=1


define bilinearform a -fespace=v  -symmetric  -eliminate_internal -linearform=f   # -ho
mixedmechh e nu reg one  
robinedge penaltyutau  -comp=2 
robinhybrid penaltyun -comp=3 
#masshdivsym one -order=16


# define preconditioner c1 -type=local   -smoother=block  -blocktype=1 -bilinearform=a 
#	-coarsetype=direct -eliminate_internal
# define preconditioner c1 -type=direct -bilinearform=a
# define preconditioner c1 -type=wirebasket -bilinearform=a
define preconditioner c1 -type=multigrid   -smoother=block  -blocktype=1 -bilinearform=a -coarsetype=smoothing -eliminate_internal -ds_cluster=3 -inverse=sparsecholesky



#numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=5000  -eliminate_internal -prec=1e-70
numproc bvp  np11 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c1  -maxsteps=150  -prec=1e-12  -cg 
#numproc bvp np21 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c2 -maxsteps=100  -eliminate_internal -prec=1e-12


define bilinearform adiv -fespace=v -nonassemble
divdivhdivsym one -comp=1

define bilinearform adisp -fespace=v -nonassemble
massedge one -comp=2
robinedge one -comp=2


define bilinearform acurldisp -fespace=v -nonassemble
curlcurledge one -comp=2

define bilinearform amass -fespace=v -nonassemble
masshdivsym one -comp=1
# robinhdivsym one -comp=1

define bilinearform adispn -fespace=v -nonassemble
robinhybrid one -comp=3

define bilinearform adisptang -fespace=v -nonassemble
robinedge one -comp=2


define bilinearform aeps -fespace=v -nonassemble
epsilonedge one -comp=2


numproc drawflux np2 -bilinearform=amass -solution=u -label=sigmadrawflux
numproc drawflux np3 -bilinearform=adiv -solution=u -label=div_sigma
numproc drawflux np4 -bilinearform=adisp -solution=u -label=dispdrawflux
numproc drawflux np11 -bilinearform=aeps -solution=u -label=epsilon
#numproc drawflux np5 -bilinearform=acurldisp -solution=u -label=curl


numproc visualization npvis -scalarfunction=dispdrawflux -comp=3
	-clipsolution=scalar -clipvec=[0,1,0]
#define bilinearform adifference -fespace=v -nonassemble
#masshdivsym zero -comp=1
#massedge zero -comp=2

#define gridfunction d1 -fespace=v
#numproc difference npd1 -bilinearform=adifference -solution1=u -solution2=u1 -diff=d1
#define gridfunction d2 -fespace=v
#numproc difference npd2 -bilinearform=adifference -solution1=u1 -solution2=u2 -diff=d2
