geometry = cube_prism.geo
mesh = cube_prism.vol 
overlap = 1

# geometry = twinni.geo
# mesh = twinni.vol

define constant heapsize = 10000000

define coefficient e 
1, 2, 2, 1

define coefficient nu
0.499999,  0.4, 0.3, 0.4

define coefficient neumannrhs
1e6 0 0 0 0 1 2 3 


# define fespace v  -type=h1ho -order=15   -nocomplex  -nodim=2  -eliminate_internal  

define fespace v -hcurlho -order=3 -nograds -complex  -nodim=2 


# define fespace vw  -compound 
# -spaces=[w,v]


define coefficient penalty
1e3 0 0 0 0 0

define gridfunction u -fespace=v

define linearform f -fespace=v 
sourceedge e e e -comp=1 -imag
# neumann neumannrhs -comp=1 
#source e -comp=2 
# neumannhdiv neumannrhs   # -comp=1
#sourcehdiv e e e -comp=1


define bilinearform a -fespace=v -linearform=f  -eliminate_internal -nosymmetric
#laplace e  -comp=1
#mass e  -comp=1
#robin penalty -comp=1
#laplace e  -comp=2 
#mass e  -comp=2
#robin penalty -comp=2 
#laplace e  -comp=1 -imag
#mass e  -comp=1 -imag
#robin penalty -comp=1 -imag
#laplace e  -comp=2  -imag
#mass e  -comp=2 -imag
#robin penalty -comp=2 -imag
# laplace e  -comp=2
# mass e  -comp=2
# laplace e  -comp=3
# mass e  -comp=3
# laplace e  -comp=4
# mass e  -comp=4
 curlcurledge e   -comp=1
 massedge e  -comp=1
 curlcurledge e   -comp=1
 massedge e  -comp=1
# masshdiv nu -comp=1
# robinhdiv penalty -comp=1
# divdivhdiv e -comp=1

define bilinearform ah1 -fespace=v -nonassemble
mass e -comp=1


# define bilinearform ahcurl -fespace=v -nonassemble
# massedge e -comp=1

# define preconditioner c -type=direct -bilinearform=a -inverse=superlu_dist
define preconditioner c -type=local -block  -smoother=block  -bilinearform=a -blocktype=7  -noinverse=sparsecholesky 
# define preconditioner c -type=multigrid   -smoother=block  -blocktype=7 -bilinearform=a -coarsetype=direct -inverse=sparsecholesky
#
numproc bvp  npbvp  -gridfunction=u -fespace=v -bilinearform=a -linearform=f -maxsteps=22 -preconditioner=c -prec=1e-100 -solver=cg -print

numproc drawflux np2 -bilinearform=ah1 -solution=u -label=u_1
# numproc drawflux np2 -bilinearform=ahcurl -solution=u -label=u_curl
