geometry = quad16.in2d
mesh = quad16.vol

define constant heapsize = 10000000
define constant geometryorder = 1

define coefficient zero
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 00 0 0 0 0 0 0 0 0 

define coefficient one 
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

define coefficient alpha
1 100 10 1000 100 1 100 10 100000 1 1 100 1 1 1 100

define coefficient penalty
1e10 0 0 0 1e10

define coefficient reg
1e-5 1e-5 1e-5 1e-5

define fespace v -type=fetifespace -order=4 -lagrangebound=2

define gridfunction u -fespace=v 

numproc fetibvp2d np1 -gridfunction=u   -prec=1e-10
	-laplacecoefficient=one -masscoefficientm=one
	-norobincoefficient=penalty -sourcecoefficient=one
	-fetifespace=v -gridfunction=u -nonoQ 
	-maxsteps=200 -precond


define bilinearform a2 -fespace=v -nonassemble
mass one -comp=1
mass one -comp=2
mass one -comp=3
mass one -comp=4
mass one -comp=5
mass one -comp=6
mass one -comp=7
mass one -comp=8
mass one -comp=9
mass one -comp=10
mass one -comp=11
mass one -comp=12
mass one -comp=13
mass one -comp=14
mass one -comp=15
mass one -comp=16

define bilinearform aflux -fespace=v -nonassemble
laplace alpha -comp=1
laplace alpha -comp=2
laplace alpha -comp=3
laplace alpha -comp=4
laplace alpha -comp=5
laplace alpha -comp=6
laplace alpha -comp=7
laplace alpha -comp=8
laplace alpha -comp=9
laplace alpha -comp=10
laplace alpha -comp=11
laplace alpha -comp=12
laplace alpha -comp=13
laplace alpha -comp=14
laplace alpha -comp=15
laplace alpha -comp=16

numproc drawflux np4 -bilinearform=a2 -solution=u -label=u -useall
numproc drawflux np5 -bilinearform=aflux -solution=u -label=grad -useall
numproc drawflux np6 -bilinearform=aflux -solution=u -label=flux -applyd -useall

numproc visualization npvis -scalarfunction=u
