geometry = eightcubes.geo
mesh = eightcubes.vol

define constant heapsize = 10000000
define constant geometryorder = 1

define coefficient zero
0 0 0 0 0 0 0 0 0 0 

define coefficient one 
1 1 1 1 1 1 1 1 1 1 1

define coefficient alpha
1 100 10 1000 10 10000 1 10

define coefficient penalty
1e10 0 0

define coefficient reg
1e-4 1e-4 1e-4 1e-4 1e-4 1e-4 1e-4 1e-4

define fespace v -type=fetifespace -order=7  -lagrangebound=2

define gridfunction u -fespace=v 

numproc fetibvp3d np1 -gridfunction=u   -prec=1e-10
	-laplacecoefficient=one -nomasscoefficient=zero 
	-robincoefficient=penalty -sourcecoefficient=alpha
	-fetifespace=v -gridfunction=u 
	-maxsteps=500 -precond

define bilinearform amass -fespace=v -nonassemble
fetimass one -order=10


define bilinearform a2 -fespace=v -nonassemble
mass one -comp=1
mass one -comp=2
mass one -comp=3
mass one -comp=4
mass one -comp=5
mass one -comp=6
mass one -comp=7
mass one -comp=8
robin one -comp=1
robin one -comp=2
robin one -comp=3
robin one -comp=4
robin one -comp=5
robin one -comp=6
robin one -comp=7
robin one -comp=8

define bilinearform aflux -fespace=v -nonassemble
laplace alpha -comp=1
laplace alpha -comp=2
laplace alpha -comp=3
laplace alpha -comp=4

numproc drawflux np4 -bilinearform=amass -solution=u -label=sigma -applyd
numproc drawflux np4 -bilinearform=a2 -solution=u -label=u -useall
numproc drawflux np5 -bilinearform=aflux -solution=u -label=grad -useall
numproc drawflux np6 -bilinearform=aflux -solution=u -label=flux -applyd -useall

numproc visualization vis -scalarfunction=u -subdivision=3 -nolineartexture -nminval=-200 -nmaxval=200 -clipvec=[0,1,0] -clipsolution=scalar -clipdist=0.25
