geometry = /home/astrid/netgen/ngsolve/ngsusers/astrid/feti/foursquares.in2d
mesh = /home/astrid/netgen/ngsolve/ngsusers/astrid/feti/foursquares.vol

define constant heapsize = 10000000
define constant geometryorder = 1

# define constant refinep = 1

define coefficient zero
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 00 0 0 0 0 0 0 0 0 

define coefficient one 
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

define coefficient alpha
1 100 10 1000 100 1 100 10 100000 1 1 100 1 1 1 100

define coefficient penalty
1e10 0 0 0 0 1e10

define coefficient reg
1e-5 1e-5 1e-5 1e-5

define fespace v -type=fetidp_compound -space=h1ho -order=2 -eliminate_internal -primal_vertex_dofs=1 -primal_edge_dofs=0 -norefinep

define gridfunction u -fespace=v 

define linearform f -fespace=v
source one -comp=1
neumann one -comp=1 

define bilinearform a -fespace=v -fetidp -linearform=f -eliminate_internal -inverse=pardiso -feticoeff=alpha
laplace alpha
mass one 
#fetidp_b_h1 alpha
robin penalty 

define preconditioner c -bilinearform=a -type=fetidp_prec

numproc bvp np1 -gridfunction=u -bilinearform=a -linearform=f -solver=cg -preconditioner=c -print -maxsteps=2000

define bilinearform amass -fespace=v -nonassemble
mass one -comp=1

numproc drawflux npdf -solution=u -label=u -bilinearform=amass

numproc visualization npvis -scalarfunction=u -nolineartexture -subdivision=3 
