geometry = /home/astrid/netgen/ngsolve/ngsusers/astrid/feti/eightcubes.geo
mesh = /home/astrid/netgen/ngsolve/ngsusers/astrid/feti/eightcubes.vol

define constant heapsize = 100000000
define constant geometryorder = 1

# define constant refinep = 1

define coefficient zero
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 00 0 0 0 0 0 0 0 0 

define coefficient one 
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

define coefficient alpha_mass
1 2 3 4 5 6 7 8 

define coefficient alpha
1 100 10 1000 100 1 100 10 100000 1 1 100 1 1 1 100

define coefficient penalty bcnames
	dirichletbc 1e10
	neumannbc 0
	lagrangebc 0
	default 1e1

define coefficient neumannone bcnames
	dirichletbc 0
	neumannbc 1
	lagrangebc 0
	default 1e0

define coefficient reg
1e-5 1e-5 1e-5 1e-5

define fespace v -type=fetidp_compound -space=h1ho -order=3 -eliminate_internal -primal_vertex_dofs=1 -primal_edge_dofs=1 -primal_face_dofs=1 -norefinep -nofast

define gridfunction u -fespace=v 

define linearform f -fespace=v
source one -comp=1
neumann neumannone -comp=1

define bilinearform a -fespace=v -fetidp -linearform=f -eliminate_internal -inverse=sparsecholesky -feticoeff=alpha
laplace alpha
mass one
#fetidp_b_h1 alpha
robin penalty 

define preconditioner c -bilinearform=a -type=fetidp_prec

numproc bvp np1 -gridfunction=u -bilinearform=a -linearform=f -solver=cg -preconditioner=c -maxsteps=2000 -noprint

define bilinearform amass -fespace=v -nonassemble
mass one -comp=1
robin one -comp=1

numproc drawflux npdf -solution=u -label=u -bilinearform=amass -useall


numproc visualization vis -scalarfunction=u -subdivision=3 -nolineartexture -nminval=-200 -nmaxval=200 -clipvec=[0,1,0] -clipsolution=scalar -clipdist=0.25
