#ifndef FILE_HDIVHOFE_A_
#define FILE_HDIVHOFE_A_


///
template <class T_ORTHOPOL = TrigExtensionMonomial>
class HDivHighOrderTrigA : public HDivHighOrderFiniteElement<2>
{
public:

  HDivHighOrderTrigA (int aorder);
  virtual void ComputeNDof();
  virtual void GetInternalDofs (ARRAY<int> & idofs) const;

  /// compute shape
  virtual void CalcShape (const IntegrationPoint & ip,
			  FlatMatrixFixWidth<2> shape) const;

  /// compute Div of shape
  virtual void CalcDivShape (const IntegrationPoint & ip,
			     FlatVector<> shape) const;
  /// compute Div numerical diff
  //void CalcNumDivShape( const IntegrationPoint & ip,
  //			FlatVector<> divshape) const;

  virtual void GetFacetDofs(int i, ARRAY<int> & dnums) const; 
};


template <class T_ORTHOPOL = TrigExtensionMonomial>
class HDivHighOrderTetA : public HDivHighOrderFiniteElement<3>
{
   typedef TetShapesInnerLegendre T_INNERSHAPES;
   typedef TetShapesFaceLegendre T_FACESHAPES; 
public:

  HDivHighOrderTetA (int aorder);
  virtual void ComputeNDof();
  virtual void GetInternalDofs (ARRAY<int> & idofs) const;

  /// compute shape
  virtual void CalcShape (const IntegrationPoint & ip,
			  FlatMatrixFixWidth<3> shape) const;

  /// compute Div of shape
  virtual void CalcDivShape (const IntegrationPoint & ip,
			     FlatVector<> shape) const;
  /// compute Div numerical diff
  //void CalcNumDivShape( const IntegrationPoint & ip,
  //			FlatVector<> divshape) const;

  virtual void GetFacetDofs(int i, ARRAY<int> & dnums) const; 
};

#endif
