
geometry = circles_hole.in2d
mesh = circles_hole.vol


define constant heapsize = 60000000

define constant geometryorder = 10

define constant k = 100

define constant conjugate = 1

define coefficient absorb bcnames
	internal 0
	external (k)

define coefficient ck
(k), 0, 

define coefficient mkk
(-k*k), (-k*k), 

define coefficient cf
0, (1000*k), 

define coefficient cg bcnames
	internal (k)
	external 0


define coefficient one
1, 1, 

define fespace v -type=hybridhelmholtztreftz -order=20  -orderl2=20 -complex -eliminate_internal

define gridfunction u -fespace=v

define linearform f -fespace=v
neumann cg -comp=3

define bilinearform a -fespace=v -eliminate_internal -linearform=f -noprint -symmetric -noprintelmat
hybridhelmholtztreftz ck
hybridrobintreftz absorb 


# define preconditioner c -type=direct -bilinearform=a -inverse=sparsecholesky
# define preconditioner c -type=local -bilinearform=a -block
define preconditioner c -type=multigrid -bilinearform=a -block -blocktype=1 -coarsetype=smoothing 


numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=500 -prec=1e-10 -tau=0.3


define bilinearform au -fespace=v -nonassemble
hybridhelmholtztreftz ck
# mass one  -comp=1

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=3
robin one -comp=3


numproc drawflux df1 -bilinearform=au -solution=u -label=u

numproc drawflux df1b -bilinearform=alam -solution=u -label=lam
numproc visualization vis -scalarfunction=u -subdivision=1


