# upwind.pde
 geometry = spheres.geo
 mesh = spheres.vol
# geometry = ngsolve/ngsusers/astrid/examples/cube.geo
# mesh = ngsolve/ngsusers/astrid/examples/cube.vol

define constant heapsize = 60000000

define constant geometryorder = 3

define constant k = 15

define coefficient absorb
(k), 0, 1

define coefficient ck
(k), 0, 1

define coefficient mkk
(-k*k), (-k*k), 1

define coefficient cf
 0, (1000*k), 1
# (1000*k), 1

define coefficient one
1, 1, 1


#define fespace v1 -type=l2ho -order=3 -complex -eliminate_internal
#define fespace v2 -type=hdivho -order=1 -complex -eliminate_internal
#define fespace v3 -type=facet -order=1 -complex -eliminate_internal

#define fespace v  -compound -order=1
#-spaces=[v1,v2,v3]

define fespace v -type=hybridhelmholtz -order=2  -complex -eliminate_internal

define gridfunction u -fespace=v

define linearform f -fespace=v
source cf -comp=1 -definedon=2

define bilinearform a -fespace=v -noprintelmat -eliminate_internal -linearform=f -noprint -noprintelmat 
mass mkk  -comp=1
laplace one -comp=1
hybridhelmholtz ck
hybridrobin absorb 


define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
# define preconditioner c -type=local -bilinearform=a -blocktype=2 -smoother=block
# define preconditioner c -type=multigrid -bilinearform=a -smoother=block -coarsetype=direct -nocoarsesmoothingsteps=1

numproc bvpparallel np1 -solver=gmres -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=500 -prec=1e-10 -tau=0.3 -noprint


define bilinearform au -fespace=v -nonassemble
mass one  -comp=1

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=3
robin one -comp=3


numproc drawflux df1 -bilinearform=au -solution=u -label=u
numproc drawflux df1b -bilinearform=alam -solution=u -label=lam


numproc visualization vis -scalarfunction=u -subdivision=1 -clipvec=[0,1,0] -clipsolution=scalar


