geometry = rectangle.in2d
mesh = rectangle02.vol

define constant with_exp = 1
define constant heapsize = 60000000

define constant geometryorder = 2
# define constant rationalgeometry = 2
define constant k = 20

define coefficient absorb
(-1), 0, 1e10

define coefficient penalty
#astrid
#(0), 0, 1
#joachim
(-1e10), 0, 1e10

define coefficient ck
(k), 0, 1

define coefficient kvec1
(k)
define coefficient kvec0
0


define coefficient mkk
(-k*k), (-k*k), 1

define coefficient cf bcnames
	sourcebc (1*k)
	incoming  (0)
	default 0
 
define coefficient crobin bcnames
	absorbing 0  # (-1e7)
	sourcebc 1  # 0
	incoming 1  # 0
	default 1  # 0

define coefficient one
1, 1, 

define coefficient eikx
( cos(k*x) )
define coefficient imageikx
( sin(k*x) )

define coefficient coeff_udiv
( 1.0 / k * sin(k*x) )

define coefficient imagcoeff_udiv
( -1.0 / k * cos(k*x) ) 

define coefficient coeff_umass
( cos ( k*x) )

define coefficient imagcoeff_umass
( sin(k*x) ) 

define coefficient one_vis

define coefficient inversekappa
(-1.0/(k) ), 0 

define fespace v -type=helmholtz_exp_space -order=4 -complex -eliminate_internal -with_exp -kx=kvec1 -ky=kvec0 

define gridfunction sigma -fespace=v

define linearform f -fespace=v
neumann cf -comp=2 -imag
#hybridhelmholtzrhs ck cf 



define bilinearform a -fespace=v -eliminate_internal -linearform=f -ho
helmholtz_exp ck kvec1 kvec0
robin crobin -comp=2





#       Smoothing types:
#       1 .. facet by facet (noeliminate_internal)
#       12 .. facet by facet (eliminate_internal)
# 	2 .. element by element  (noeliminate_internal)
# 	22 .. element by element  (eliminate_internal)
# 	3 .. nichts
# 	4 .. master-edges/element (noelim_int)
# 	42 .. master-edges/element (elim_int)
# 	5 .. ds_clusters (noelim_int)
# 	6 .. vertex-patches (noelim_int)
# 	62 .. vertex-patches (elim_int)
# 	7 .. facet-patches (noelim_int)

#define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
#define preconditioner c -type=local -bilinearform=a -block -blocktype=9 -notest
#define preconditioner c -type=multigrid -bilinearform=a -smoother=block -blocktype=3 -ds_cluster=1 -coarsetype=smoothing -coarsesmoothingsteps=1 -inverse=pardiso
#define preconditioner c -type=wirebasket_complex -bilinearform=aprec
define preconditioner c -type=wirebasket -bilinearform=a -inverse=pardiso


numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f 
	-gridfunction=sigma  -maxsteps=500 -prec=1e-10

define bilinearform asigma -fespace=v -nonassemble
masshdiv eikx  -comp=1
masshdiv imageikx -imag -comp=1

define bilinearform au -fespace=v -nonassemble
divdivhdiv coeff_udiv -comp=1
divdivhdiv imagcoeff_udiv -imag -comp=1
masshdiv coeff_umass -comp=1
masshdiv imagcoeff_umass -comp=1 -imag


define bilinearform alam -fespace=v -nonassemble -complex
mass eikx  -comp=2
mass imageikx -imag  -comp=2


#define bilinearform aupp -fespace=vl2 -nonassemble
#mass one

numproc drawflux df1a -bilinearform=asigma -solution=sigma -label=sigmad -applyd -useall
numproc drawflux df1b -bilinearform=alam -solution=sigma -label=lamd -applyd -useall
numproc drawflux drawu -bilinearform=au -solution=sigma -label=u -applyd -useall
numproc drawflux df1a1 -bilinearform=asigma -solution=sigma -label=sigma1 
numproc drawflux df1b1 -bilinearform=alam -solution=sigma -label=lam1

numproc visualization vis -scalarfunction=sigmad -subdivision=3 -nolineartexture -nminval=10 -nmaxval=150

