# upwind.pde
# geometry = circle.in2d
# mesh = circle.vol
 geometry = spheres.geo
 mesh = spheres.vol
# geometry = ngsolve/ngsusers/astrid/examples/cube.geo
# mesh = ngsolve/ngsusers/astrid/examples/cube.vol

# geometry = circles_hole.in2d
# mesh = circles_hole.vol

define constant heapsize = 60000000

define constant geometryorder = 3
# define constant rationalgeometry = 1

define constant k = 15

#define coefficient absorb
#(k), 0, 1

define coefficient absorb bcnames
	external (k)
	internal 0
	cut  1

define coefficient ck
(k), 0, 1

define coefficient mkk
(-k*k), (-k*k), 1

define coefficient cf
 0, (1000*k), 1
# (1000*k), 1

define coefficient one
1, 1, 

define coefficient absorb bcnames
	internal 0
	external -1
	default 0

define fespace v -type=hybridhelmholtz -order=3 -complex -eliminate_internal

define gridfunction u -fespace=v

define linearform f -fespace=v
# divsource cf -comp=1
source cf -comp=2 -definedon=2

define bilinearform a -fespace=v -eliminate_internal -linearform=f -noelmatev -noprint -noprintelmat
hybridhelmholtz ck
#hybridrobin absorb 
robin absorb -comp=4

define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
# define preconditioner c -type=local -bilinearform=a -block -blocktype=1   -notest
# define preconditioner c -type=multigrid -bilinearform=a -smoother=block -blocktype=2 -coarsetype=smoothing -inverse=sparsecholesky -coarsesmoothingsteps=1 -notest

numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=100 -prec=1e-10 -tau=0.3 -noprint
# numproc bvp np1 -solver=simple -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=3000 -prec=1e-20 -tau=0.5


define bilinearform au -fespace=v -nonassemble
# divdivhdiv one -comp=1
mass one  -comp=2

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=4

define bilinearform asigma -fespace=v -nonassemble
masshdiv one  -comp=1



numproc drawflux df1 -bilinearform=au -solution=u -label=u
numproc drawflux df1b -bilinearform=alam -solution=u -label=lam
numproc drawflux df1a -bilinearform=asigma -solution=u -label=sigma


numproc visualization vis -scalarfunction=u -subdivision=3 -nolineartexture -minval=-200 -maxval=200 -clipvec=[0,1,0] -clipsolution=scalar

