 geometry = circles.in2d
 mesh = circles01.vol

define constant heapsize = 60000000

define constant geometryorder = 2
# define constant rationalgeometry = 1

define constant k = 20

define coefficient absorb
(-1), 0, 1e10

define coefficient penalty
#astrid
#(0), 0, 1
#joachim
(-1e10), 0, 1e10

define coefficient ck
(k), 0, 1

define coefficient mkk
(-k*k), (-k*k), 1

define coefficient cf
 0, (1000*k*( sqrt(x*x+y*y) - 0.05 ) ), 1 
# (1000*k), 1

define coefficient one
1, 1, 

define coefficient one_vis

define coefficient inversekappasqr
(-1.0/(k) ), 0 

define fespace v -type=hybridhelmholtzs -order=2 -complex -noeliminate_internal 

define gridfunction sigma -fespace=v

define linearform f -fespace=v
 divsource cf -comp=1 -imag
#hybridhelmholtzrhs ck cf 

define linearform f_precond -fespace=v
 divsource cf -comp=1 -imag
#hybridhelmholtzrhs ck cf 


define bilinearform a -fespace=v -eliminate_internal -linearform=f -symmetric -nprintelmat -elmatev
hybridhelmholtzs ck
#hybridrobins absorb 
#robin absorb -comp=2
robin penalty -comp=2

#define bilinearform a_precond -fespace=v -noeliminate_internal -linearform=f_precond -nsymmetric -nprintelmat
#hybridhelmholtzsp ck
#robin penalty -comp=2




#       Smoothing types:
#       1 .. facet by facet (noeliminate_internal)
#       12 .. facet by facet (eliminate_internal)
# 	2 .. element by element  (noeliminate_internal)
# 	22 .. element by element  (eliminate_internal)
# 	3 .. nichts
# 	4 .. master-edges/element (noelim_int)
# 	42 .. master-edges/element (elim_int)
# 	5 .. ds_clusters (noelim_int)
# 	6 .. vertex-patches (noelim_int)
# 	62 .. vertex-patches (elim_int)
# 	7 .. facet-patches (noelim_int)

#define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
#define preconditioner c -type=local -bilinearform=a_precond -block -blocktype=42 -notest
define preconditioner c -type=multigrid -bilinearform=a -smoother=block -blocktype=42
	-ds_cluster=0 -coarsetype=smoothing -inverse=sparsecholesky 
	-coarsesmoothingsteps=1 -notest

numproc bvp np1 -solver=cg -nobilinearform_precond=a_precond -preconditioner=c -bilinearform=a -linearform=f 
	-gridfunction=sigma  -maxsteps=1000 -prec=1e-10  

define bilinearform au -fespace=v -nonassemble
divdivhdiv inversekappasqr -comp=1
# mass one_vis  -comp=2

define bilinearform asigma -fespace=v -nonassemble
masshdiv one -comp=1

define bilinearform alam -fespace=v -nonassemble -complex
mass one  -comp=2


#define bilinearform aupp -fespace=vl2 -nonassemble
#mass one

numproc drawflux df1 -bilinearform=au -solution=sigma -label=u -applyd
numproc drawflux df1a -bilinearform=asigma -solution=sigma -label=sigma
numproc drawflux df1b -bilinearform=alam -solution=sigma -label=lam
#numproc drawflux df2 -bilinearform=aupp -solution=u -label=upp 

numproc visualization vis -scalarfunction=u -subdivision=3 -nolineartexture -nminval=10 -nmaxval=150

