# upwind.pde
# geometry = circles.in2d
# mesh = circles.vol
 geometry = spheres2.geo
 mesh = spheres2.vol
# geometry = ngsolve/ngsusers/astrid/examples/cube.geo
# mesh = ngsolve/ngsusers/astrid/examples/cube.vol

# geometry = circles_hole.in2d
# mesh = circles_hole.vol

define constant heapsize = 60000000

define constant geometryorder = 2
# define constant rationalgeometry = 1

define constant k = 10

define coefficient absorb
#(k), (k), (k), (k), 0, 0, 0, 0, 0, 0, 0,
#(k), 0, 1
(-1), 0, 1e10

define coefficient penalty
#astrid
#(0), 0, 1
#joachim
(-1e10), 0, 0



define coefficient ck
(k), 0, 1

define coefficient mkk
(-k*k), (-k*k), 1

define coefficient cf
 0, (1000*k), 1
# (1000*k), 1

define coefficient one
1, 1, 
define coefficient inversekappasqr
(-1.0/(k) ), 0 

define fespace v -type=hybridhelmholtzs -order=4 -complex -neliminate_internal 

define gridfunction u -fespace=v

define linearform f -fespace=v
 divsource cf -comp=1

define bilinearform a -fespace=v -neliminate_internal -linearform=f -noprint -noprintelmat -symmetric
hybridhelmholtzs ck
#hybridrobins absorb 
robin penalty -comp=2

#       Smoothing types:
#       1 .. facet by facet (eliminate_internal)
# 	2 .. element by element  (eliminate_internal)
# 	3 .. nichts
# 	4 .. master-edges/element (noelim_int)
# 	5 .. ds_clusters (noelim_int)
# 	6 .. vertex-patches (noelim_int)
# 	62 .. vertex-patches (elim_int)
# 	7 .. facet-patches (elim_int)

#define preconditioner c -type=direct -bilinearform=a -inverse=sparsecholesky
#define preconditioner c -type=local -bilinearform=a -block -blocktype=4 -notest
define preconditioner c -type=multigrid -bilinearform=a -smoother=block -blocktype=7 -ds_cluster=0 -coarsetype=smoothing -inverse=sparsecholesky -coarsesmoothingsteps=1 -notest

numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=400 -prec=1e-10 -tau=-0.0005 -noprint
# numproc bvp np1 -solver=simple -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=3000 -prec=1e-20 -tau=0.5


define bilinearform au -fespace=v -nonassemble
divdivhdiv inversekappasqr -comp=1
# mass one  -comp=2

define bilinearform asigma -fespace=v -nonassemble
masshdiv one -comp=1

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=2



numproc drawflux df1 -bilinearform=au -solution=u -label=u -applyd
numproc drawflux df1a -bilinearform=asigma -solution=u -label=sigma
numproc drawflux df1b -bilinearform=alam -solution=u -label=lam


numproc visualization vis -scalarfunction=u -subdivision=3 -nolineartexture -minval=-2000 -maxval=2000 -clipvec=[0,1,0] -clipsolution=scalar

