#ifndef MARINI_PIETRA_FESPACE_HPP___
#define MARINI_PIETRA_FESPACE_HPP___

#include <comp.hpp>

namespace ngcomp {
  

class MariniPietraFESpace : public FESpace
{
private:
  // Level
  int level;
  // number of elements
  int nel;
  // Number Dofs 
  int ndof;

  mutable ARRAY<int> maxedge;
  ARRAY<int> first_element_dof;

  ARRAY<int> ndlevel;

public:

  MariniPietraFESpace (const MeshAccess & ama, const Flags & flags, bool parseflags=false);
  ///
  virtual ~MariniPietraFESpace ();

  static FESpace * Create (const MeshAccess & ma, const Flags & flags);

  virtual string GetClassName () const   {return "MariniPietraFESpace";  }

  virtual void Update();
  
  virtual int GetNDof () const;

  virtual int GetNDofLevel (int level) const;

  virtual const FiniteElement & GetFE (int elnr, LocalHeap & lh) const;

  virtual const FiniteElement & GetSFE (int selnr, LocalHeap & lh) const; 

  virtual void GetDofNrs (int elnr, ARRAY<int> & dnums) const;

  virtual void GetExternalDofNrs (int elnr, ARRAY<int> & dnums) const;

  virtual void GetSDofNrs (int selnr, ARRAY<int> & dnums) const;
  
  virtual void SetOrientation(int elnr, int fmax) const;

//   virtual Table<int> * CreateSmoothingBlocks (const Flags & precflags) const;

//   virtual ARRAY<int> * CreateDirectSolverClusters (const Flags & precflags) const;

};


} // namespace


#endif
