# geometry = flow.in2d
# mesh = flow01.vol
# mesh = flowf.vol
# mesh = flowlf.vol
# mesh = flow.vol

geometry = doublestep2.in2d
mesh = doublestep2.vol

define constant heapsize = 10000000

define coefficient forcex
0, 1, 0,

define coefficient forcey
0, 0, 0,

define coefficient penalty
1e8, 0, 

define coefficient f0
1, 1, 
1, (1+10000*(x-0.4)*(0.6-x)*(y-0.4)*(0.6-y)),
1, 2, 

define coefficient one
1, 1, 1, 

define coefficient e1
0, 5, 0,

define coefficient e2
0, 0, 0, 


define fespace v -type=hermiteexpansion -order=3 -hermiteorder=5
define fespace vu -type=l2ho -order=3

define gridfunction f -fespace=v -multidim=200
define gridfunction hv -fespace=v -multidim=200
define gridfunction hv2 -fespace=v -multidim=200

define bilinearform a -fespace=v -symmetric

define bilinearform m -fespace=vu -symmetric
mass one

define bilinearform masse1 -fespace=vu -diagonal
mass e1

define bilinearform masse2 -fespace=vu -diagonal
mass e2


define bilinearform dudx1 -fespace=vu
dudx1

define bilinearform dudx2 -fespace=vu
dudx2



define bilinearform mfacet -fespace=v 
massfacet one -comp=2


define linearform initial -fespace=v
source f0 -comp=1



numproc boltzmann np1  -dt=3e-4 -te=15 -kn=0.01 -collision


define bilinearform df -fespace=v -nonassemble
mass one -comp=2

numproc drawflux df1 -bilinearform=df -solution=f -label=ffacet


numproc visualization vis -scalarfunction=f -subdivision=2  -nolineartexture 
# -minval=0.5 -maxval=1.5



# mesh=double_step
# order=3, hermite_order=3 kn=0.01,  dt=1e-5



# b=5, dt = 3e-4, kn=0.01, o=5
# b=5, dt = 0.5e-3, kn=0.05

# meshf.vol
# O = 3/9: 1e-3   0.290 / step


# hermiteorder=3
# mesh02   1e-2
# mesh01   5e-3
# mesh005  2.5e-3
# mesh0025  1.25e-3
