# upwind.pde
geometry = circles.in2d
mesh = circlesf.vol

# geometry = circle.in2d
# mesh = circle.vol

# geometry = circles_hole.in2d
# mesh = circles_hole.vol

define constant heapsize = 60000000

define constant geometryorder = 2
define constant rationalgeometry = 1


define constant k = 100

define coefficient absorb
# 1e-8, 1e-8, 1e-8, 1e-8, 0, 0, 0, 0, 
# 1e-5, 1e-5, 1e-5, 1e-5, 0, 0, 0, 0, 
(k), (k), (k), (k), 0, 0, 0, 0, 0, 0, 0, 0, 
# (-k), (-k), (-k), (-k), 0, 0, 0, 0
# (-2*k), (-2*k), (-2*k), (-2*k), 0, 0, 0, 0

define coefficient ck
(k), (k), 


define coefficient mkk
(-k*k), (-k*k), 

define coefficient one
(1.0), (1.0), 

define coefficient cf
0, (1000*k), 

define coefficient one
1, 1, 

define fespace v -type=hybridhelmholtz -order=10  -complex -eliminate_internal

define gridfunction u -fespace=v

define linearform f -fespace=v
source cf -comp=1 -definedon=2

define bilinearform a -fespace=v -noprintelmat -eliminate_internal -linearform=f -noprint -noprintelmat
mass mkk  -comp=1
laplace one -comp=1
hybridhelmholtz ck
hybridrobin absorb 


# define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
# define preconditioner c -type=local -bilinearform=a -block
define preconditioner c -type=multigrid -bilinearform=a -smoother=block -coarsetype=smoothing -coarsesmoothingsteps=1 -notest

numproc bvp np1 -solver=gmres -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=500 -prec=1e-10 
# numproc bvp np1 -solver=simple -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=500 -prec=1e-10 -tau=0.5


define bilinearform au -fespace=v -nonassemble
mass one  -comp=1

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=3



numproc drawflux df1 -bilinearform=au -solution=u -label=u
numproc drawflux df1b -bilinearform=alam -solution=u -label=lam


numproc visualization vis -scalarfunction=u -subdivision=3


