# joachim
geometry = circles.in2d
mesh = circlesc.vol


define constant heapsize = 60000000

define constant geometryorder = 10

define constant k = 40

define coefficient absorb
(k), (k), (k), (k), 0, 0, 0, 0, 

define coefficient ck
(k), 0, 

define coefficient mkk
(-k*k), (-k*k), 

define coefficient cf
0, (1000*k), 

define coefficient cg
0, 0, 0, 0, (k), (k), (k), (k) 


define coefficient one
1, 1, 

define fespace v -type=hybridhelmholtz -order=16 -orderl2=16 -complex -eliminate_internal -noprint

define gridfunction u -fespace=v

define linearform f -fespace=v
neumann cg -comp=3

define linearform f2 -fespace=v
neumann cg -comp=3

define bilinearform a -fespace=v  -eliminate_internal -linearform=f  -nonsymmetric -noprintelmat
hybridhelmholtz ck
hybridrobin absorb 

# define bilinearform apre -fespace=v  -eliminate_internal  -linearform=f2 -nonsymmetric -noprintelmat
# hybridhelmholtzprecond ck
# hybridrobin absorb 


# define preconditioner c -type=direct -bilinearform=a -inverse=pardiso
# define preconditioner c -type=direct -bilinearform=a -inverse=sparsecholesky
# define preconditioner c -type=direct -bilinearform=apre -inverse=pardiso
# define preconditioner c -type=local -bilinearform=a -block
# define preconditioner c -type=local -bilinearform=apre -block
define preconditioner c -type=multigrid -coarsetype=smoothing -bilinearform=a -smoother=block -coarsesmoothingsteps=3


# numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=500 -prec=1e-10 -tau=0.3
numproc bvp np1 -solver=simple -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=2000 -prec=1e-16 -tau=1


define bilinearform au -fespace=v -nonassemble
hybridhelmholtz ck

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=3
robin one -comp=3


numproc drawflux df1 -bilinearform=au -solution=u -label=u

numproc drawflux df1b -bilinearform=alam -solution=u -label=lam
numproc visualization vis -scalarfunction=u -subdivision=1


