# upwind.pde
# geometry = circle.in2d
# mesh = circlec.vol
geometry = circles.in2d
mesh = circles.vol

# geometry = circles_hole.in2d
# mesh = circles_holeff.vol

define constant heapsize = 60000000

define constant geometryorder = 2
define constant rationalgeometry = 1

define constant k = 60

define coefficient absorb
(k), (k), (k), (k), 0, 0, 0, 0, 0, 0, 0, 0, 

define coefficient ck
(k), (k), 


define coefficient mkk
(-k*k), (-k*k), 

define coefficient one
(1.0), (1.0), 

define coefficient cf
0, (10*k), 

define coefficient cn
0, 0, 0, 0, (k), (k), (k), (k),

define coefficient one
1, 1, 

define fespace v -type=hybridhelmholtz -order=4  -complex -eliminate_internal -noprint

define gridfunction u -fespace=v

define linearform f -fespace=v
# divsource cf -comp=1
# source cf -comp=2 -definedon=2
neumann cn -comp=4

define bilinearform a -fespace=v -noprintelmat -eliminate_internal -linearform=f -noprint -noprintelmat -symmetric 
hybridhelmholtz ck
hybridrobin absorb 

# define bilinearform b -fespace=v -noprintelmat -eliminate_internal  -noprint -noprintelmat
# hybridprecond ck



# define preconditioner c -type=direct -bilinearform=a -inverse=sparsecholesky
# define preconditioner c -type=local -bilinearform=b -block    -notest
define preconditioner c -type=multigrid -bilinearform=a -smoother=block -coarsetype=smoothing -coarsesmoothingsteps=1 -notest

numproc bvp np1 -solver=cg -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=1000 -prec=1e-8 -tau=0.3 
# numproc bvp np1 -solver=simple -preconditioner=c -bilinearform=a -linearform=f -gridfunction=u  -maxsteps=3000 -prec=1e-20 -tau=0.1


define bilinearform au -fespace=v -nonassemble
# divdivhdiv one -comp=1
mass one  -comp=2

define bilinearform adiv -fespace=v -nonassemble
divdivhdiv one -comp=1

define bilinearform alam -fespace=v -nonassemble
mass one  -comp=4



numproc drawflux df1 -bilinearform=au -solution=u -label=u
numproc drawflux df2 -bilinearform=adiv -solution=u -label=divu
numproc drawflux df1b -bilinearform=alam -solution=u -label=lam


numproc visualization vis -scalarfunction=u -subdivision=3


