#include <solve.hpp>
// #include <nginterface.h>


namespace ngsolve
{
  using namespace ngsolve;


  ///
  class NumProcTestHO : public NumProc
  {
  public:
    ///
    NumProcTestHO (PDE & apde, const Flags & flags);
    ///
    virtual ~NumProcTestHO();

    static NumProc * Create (PDE & pde, const Flags & flags)
    {
      return new NumProcTestHO (pde, flags);
    }

    ///
    virtual void Do();
    ///
    virtual string GetClassName () const
    {
      return "TestHO";
    }

    virtual void PrintReport (ostream & ost)
    {
      ;
    }
  };



  NumProcTestHO :: NumProcTestHO (PDE & apde, const Flags & flags)
    : NumProc (apde)
  {
    ;
  }

  NumProcTestHO :: ~NumProcTestHO()
  {
    ;
  }


  void NumProcTestHO :: Do()
  {
    cout << "testho" << endl;

    BaseVector & vecu = pde.GetGridFunction ("u")->GetVector();
    FlatVector<> fvu = vecu.FVDouble();

    int np = ma.GetNP();
    for (int i = 0; i < np; i++)
      {
	Vec<3> point;
	ma.GetPoint (i, point);
	fvu(i) = 2 * point(2);
      }
  }



  namespace {
    class Init
    { 
    public: 
      Init ();
    };
    
    Init::Init()
    {
      GetNumProcs().AddNumProc ("testho", NumProcTestHO::Create);
    }

    
    Init init;
  }

}
