
geometry = d_square.in2d
mesh = d_square.vol

define constant heapsize = 10000000

define constant twopi = 6.283185307179586

define constant IndexAboveReal = 1

define constant IndexAboveImag = 0

define constant IndexBelowReal = 2

define constant IndexBelowImag = 0

define coefficient LaplaceDomain
1,1,

define coefficient LaplaceBoundary
1,1,1,1,1,1,1,

define coefficient coef_source
0,0, 

define coefficient masr
(-twopi*twopi*(IndexAboveReal*IndexAboveReal-IndexAboveImag*IndexAboveImag)/1),(-twopi*twopi*(IndexBelowReal*IndexBelowReal-IndexBelowImag*IndexBelowImag)/1),

define coefficient masi
(-twopi*twopi*IndexAboveReal*IndexAboveImag*2.0/1.0),(-twopi*twopi*IndexBelowReal*IndexBelowImag*2.0/1.0),


define fespace v -defract -complex -order=1 -fourier1order=0  -fourier2order=0 -bc1=1 -bc2=2

define gridfunction u -fespace=v -nested


define bilinearform a -fespace=v 
laplace LaplaceDomain  -comp=1
mass masr  -comp=1
mass masi    -comp=1   -imag



define linearform f -fespace=v
source coef_source  -comp=1


# define preconditioner c -type=direct -bilinearform=a -smoothingsteps=1 



numproc bvpfourier np1 -bilinearform=a -linearform=f -gridfunction=u  -nopreconditioner=c -maxsteps=50 -alpha=0.5235988 -lambda=1 -penalty=1e3  -polarisation=1 -solver=direct -layer  -print



define bilinearform ag -fespace=v -nonassemble
mass masr	-comp=1
#mass masi  -imag  -comp=1


numproc drawflux np2 -bilinearform=ag -solution=u -label=flux