
geometry = test.in2d
mesh = test.vol

define constant heapsize = 10000000

define constant twopi = 6.283185307179586

define constant IndexAboveReal = 1

define constant IndexAboveImag = 0

define constant IndexBelowReal = 0.97265332

define constant IndexBelowImag = 0.01678092

define coefficient LaplaceDomain
1,1,1,1,1,

define coefficient LaplaceBoundary
1,1,1,1,1,1,1,

define coefficient coef_source
0,0,0,0,0,

define coefficient masr
(-twopi*twopi*(IndexAboveReal*IndexAboveReal-IndexAboveImag*IndexAboveImag)/0.013921/0.013921),(-twopi*twopi*(IndexBelowReal*IndexBelowReal-IndexBelowImag*IndexBelowImag)/0.013921/0.013921),(-twopi*twopi*(0.97265332*0.97265332-0.01678092*0.01678092)/0.013921/0.013921),(-twopi*twopi*(0.94462828*0.94462828-0.033084*0.033084)/0.013921/0.013921),(-twopi*twopi*(0.9365116*0.9365116-0.0365208*0.0365208)/0.013921/0.013921)

define coefficient masi
(-twopi*twopi*IndexAboveReal*IndexAboveImag*2.0/0.013921/0.013921),(-twopi*twopi*IndexBelowReal*IndexBelowImag*2.0/0.013921/0.013921),(-twopi*twopi*0.97265332*0.01678092*2.0/0.013921/0.013921),(-twopi*twopi*0.94462828*0.033084*2.0/0.013921/0.013921),(-twopi*twopi*0.9365116*0.0365208*2.0/0.013921/0.013921),


define fespace v -defract -complex -order=7 -fourier1order=120  -fourier2order=120 -bc1=1 -bc2=2 -noeliminate_internal

define gridfunction u -fespace=v -nested



define linearform f -fespace=v
source coef_source  -comp=1


define bilinearform a -fespace=v -noeliminate_internal -linearform=f -nonassemble
laplace LaplaceDomain  -comp=1
mass masr  -comp=1
mass masi    -comp=1   -imag






# define preconditioner c -type=direct -bilinearform=a -smoothingsteps=1 



numproc bvpfourier np1 -bilinearform=a -linearform=f -gridfunction=u  -alpha=0.104187429 -lambda=0.013921 -penalty=1  -polarisation=1 -solver=direct -layer  



define bilinearform ag -fespace=v -nonassemble
mass masr	-comp=1
#mass masi  -imag  -comp=1


numproc drawflux np2 -bilinearform=ag -solution=u -label=flux