geometry = lshape_dirich.in2d
mesh = lshape_dirich.vol

#define constant hpref_setnoorders = 0

#define constant hpref = 4

define constant refinehp = 1

define constant mesh_smooth_order = 0

define constant heapsize = 500000000

define coefficient lam
1, 1, 1, 

define coefficient penalty
1e16, 0, 0, 0, 0, 0, 0, 

define constant pi = 3.14159265

define coefficient coef_source
1, (sin(pi*x)*sin(pi*y)) 


define fespace v -h1ho -relorder=0 #-relorder=0
define fespace v2 -h1ho -relorder=4 #-variableorder #-relorder=15
#define fespace vdiv -hdivho -discontinuous -relorder=-1
define fespace verr -l2 -order=0

define gridfunction u -fespace=v 
define gridfunction u2 -fespace=v2 
#define gridfunction sigma -fespace=vdiv 
 
define gridfunction err -fespace=verr
define gridfunction errzz -fespace=verr
define gridfunction diff -fespace=verr

define bilinearform a -fespace=v -symmetric #-printelmat -elmatev
laplace lam
robin penalty

define bilinearform aa -fespace=v -symmetric #-printelmat -elmatev
laplace lam

define linearform f -fespace=v
source coef_source

define bilinearform a2 -fespace=v2 -symmetric 
laplace lam
robin penalty

define linearform f2 -fespace=v2
source coef_source

#define preconditioner c -type=local -bilinearform=a -smoothingsteps=3 
#define preconditioner c2 -type=local -bilinearform=a2 -smoothingsteps=3


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u  -solver=direct #-preconditioner=c -maxsteps=500
numproc bvp np1a -bilinearform=a2 -linearform=f2 -gridfunction=u2  -solver=direct #-preconditioner=c2 -maxsteps=500

#numproc drawflux np2 -bilinearform=a -solution=u -applyd -label=flux 

numproc difference np3a  -bilinearform1=a -bilinearform2=a2 -solution1=u -solution2=u2 -diff=diff  
-filename=equ_ee/lshape_dirich/diff_test.out 

#numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -error=errzz -minlevel=1 -filename=equ_ee/lshape_dirich/zz_lshape_dirich.out

 
numproc equilibrationeesz2a np4 -bilinearform=aa -rel2=0 -linearform=f -solution=u -error=err -minlevel=1 -coeff=coef_source   
-filename=equ_ee/lshape_dirich/eetesta.out #-energy=2.930099251462474 -laplace


numproc markelements np4a -error=err -minlevel=1 -factor=0.7


numproc drawflux np5 -marked
numproc drawflux np6 -order 




 
