geometry = cube.geo
mesh = cube.vol

define constant hpref_setnoorders = 1 

#define constant hpref = 5

define constant refinep = 1

define constant heapsize = 50000000

define coefficient lam
1, 1, 1, 

define coefficient penalty
1e15, 0, 0, 0, 0, 0, 0, 

define constant pi = 3.14159265

define coefficient coef_source
1, (sin(pi*x)*sin(pi*y))


define fespace v -h1ho -relorder=0 #-relorder=0
define fespace v2 -h1ho -relorder=3 #-variableorder #-relorder=15
#define fespace vdiv -hdivho -discontinuous -relorder=-1
define fespace verr -l2 -order=0

define gridfunction u -fespace=v 
define gridfunction u2 -fespace=v2 
#define gridfunction sigma -fespace=vdiv 
 
define gridfunction err -fespace=verr
define gridfunction errzz -fespace=verr
define gridfunction diff -fespace=verr

define bilinearform a -fespace=v -symmetric #-printelmat -elmatev
laplace lam
robin penalty

define bilinearform a2 -fespace=v2 -symmetric #-printelmat -elmatev
laplace lam
robin penalty

define bilinearform aa -fespace=v -symmetric #-printelmat -elmatev
laplace lam

define linearform f -fespace=v
source coef_source

define linearform f2 -fespace=v2
source coef_source

define preconditioner c -type=multigrid -smoother=block -bilinearform=a -smoothingsteps=3 
define preconditioner c2 -type=multigrid -smoother=block -bilinearform=a2 -smoothingsteps=3


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u  -solver=direct #-preconditioner=c -maxsteps=500
numproc bvp np1a -bilinearform=a2 -linearform=f2 -gridfunction=u2  -solver=direct #-preconditioner=c -maxsteps=500

#numproc drawflux np2 -bilinearform=a -solution=u -applyd -label=flux 

numproc difference np3a  -bilinearform1=a -bilinearform2=a2 -solution1=u -solution2=u2 -diff=diff  -filename=equ_ee/cube/diff_cube_3.out 

numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -error=errzz -minlevel=1 -filename=equ_ee/cube/zz_cube_zz.out

 
numproc equilibrationeesz np4 -bilinearform=aa -rel2=1 -linearform=f -solution=u -error=err -minlevel=1 -coeff=coef_source   -filename=equ_ee/cube/equ_ee_cube_uniform_p.out   -energy=3.930099251462474


numproc markelements np4a -error=err -minlevel=1 -factor=0.5


numproc drawflux np5 -marked
numproc drawflux np6 -order 




 