geometry = cube.geo
mesh = cube.vol

define constant hpref_setnoorders = 1 

#define constant hpref = 5

define constant refinep = 1

define constant heapsize = 50000000

define coefficient lam
1, 1, 1, 

define coefficient penalty
1e15, 0, 0, 0, 0, 0, 0, 

define constant pi = 3.14159265

define coefficient coef_source
1, (sin(pi*x)*sin(pi*y))


define fespace v -h1ho -relorder=0-print #-relorder=0 #-relorder=0
define fespace v2 -h1ho -relorder=2 -print #-relorder=1 #-variableorder #-relorder=15
#define fespace vdiv -hdivho -discontinuous -relorder=-1
define fespace verr -l2ho -order=0

define gridfunction u -fespace=v 
define gridfunction u2 -fespace=v2 
define gridfunction diff -fespace=verr

define bilinearform a -fespace=v -symmetric #-printelmat -elmatev
laplace lam
robin penalty

define bilinearform a2 -fespace=v2 -symmetric #-printelmat -elmatev
laplace lam
robin penalty

define bilinearform aa -fespace=v -symmetric #-printelmat -elmatev
laplace lam

define linearform f -fespace=v
source coef_source

define linearform f2 -fespace=v2
source coef_source

define preconditioner c -type=multigrid -smoother=block -bilinearform=a -smoothingsteps=3 
define preconditioner c2 -type=multigrid -smoother=block -bilinearform=a2 -smoothingsteps=3


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u  -solver=direct #-preconditioner=c -maxsteps=500


numproc difference np3a  -bilinearform1=a -bilinearform2=a2 -solution1=u -solution2=u2  -diff=diff -filename=equ_ee/cube/diff_cube_3.out 






 