// ATTENTION : Prism is not fully working !!! 
// ATTENTION CURL-Shapes of trig-faces not the same as of HCURL!! 
// (here we use xi(lami(0),lami(1)) in H(curl) we set xi(lami(0),lami(3)) !!   

// Falls copy to hdivhofe2.cpp ATTENTION : factor 0.25 in FaceShapes TET for 
// compability to trigs 

#include <fem.hpp>
#include "hdivhofenew.hpp" 

namespace ngfem 
{  
  using namespace ngfem; 
// hv.DValue() = (grad u) x (grad v) 
  AutoDiff<3> GradCrossGradSZ (const AutoDiff<3> & u,
                             const AutoDiff<3> & v)
  {
    AutoDiff<3> hv;
    hv.Value() = 0.0;
    hv.DValue(0) = u.DValue(1)*v.DValue(2)-u.DValue(2)*v.DValue(1);
    hv.DValue(1) = u.DValue(2)*v.DValue(0)-u.DValue(0)*v.DValue(2);
    hv.DValue(2) = u.DValue(0)*v.DValue(1)-u.DValue(1)*v.DValue(0);
    return hv;
  }

  Vec<3> GradCrossVecSZ (const AutoDiff<3> & u,
                       const Vec<3> & v)
  {
    Vec<3> hv;
    hv(0) = u.DValue(1)*v(2)-u.DValue(2)*v(1);
    hv(1) = u.DValue(2)*v(0)-u.DValue(0)*v(2);
    hv(2) = u.DValue(0)*v(1)-u.DValue(1)*v(0);
    return hv;
  }
   
  
  
  // 2d (gradu) x (grad v)
  double  GradCrossGradSZ2 (const AutoDiff<2> & u, const AutoDiff<2> & v) 
  {
    return(u.DValue(0)*v.DValue(1) - u.DValue(2)*v.DValue(1)); 
  }  


  
  
  //------------------------------------------------------------------------
  // HDivHighOrderFiniteElementSZ
  //------------------------------------------------------------------------
  template <int D>
  HDivHighOrderFiniteElementSZ<D> ::
  HDivHighOrderFiniteElementSZ (ELEMENT_TYPE aeltype)
    : HDivFiniteElement<D> (aeltype, -1, -1)
  {
    for (int i = 0; i < 8; i++)
      vnums[i] = i;

    augmented = 0;
    discont = 0; 
  }

  template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetVertexNumbers (FlatArray<int> & avnums)
  {
    for (int i = 0; i < avnums.Size(); i++)
      vnums[i] = avnums[i];
  }

  template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetOrderEdge (FlatArray<int> & oe)
  {
    for (int i = 0; i < oe.Size(); i++)
      order_edge[i] = oe[i];
    ComputeNDof();
  }

  template <int D> 
  void HDivHighOrderFiniteElementSZ<D>::
  SetOrderFace (FlatArray<int> & of)
  {
    for (int i = 0; i < of.Size(); i++)
      order_face[i] = INT<2>(of[i],of[i]); 
    ComputeNDof();
   
  }

  template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetOrderInner (int oi)
  {
    order_inner = INT<3>(oi,oi,oi);
    order_inner_curl = INT<3>(oi,oi,oi);
    ComputeNDof();

  }
 
 template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetOrderInner (INT<3> oi)
  {
    order_inner = oi; 
    order_inner_curl = oi; 
    ComputeNDof(); 
  }

  template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetOrderInnerCurl (INT<3> oi)
  {
    order_inner_curl = oi;
    ComputeNDof(); 
  }

  template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetOrderFace (FlatArray<INT<2> > & of)
  {
    for (int i = 0; i < of.Size(); i++)
      order_face[i] = of[i];
    ComputeNDof(); 
  }

  // Increase Curl-Fields by order "rel"
  template <int D>
  void HDivHighOrderFiniteElementSZ<D>::
  SetRelOrderCurl (int rel)
  {
    for(int i=0; i < 12; i++)
      order_edge[i] += rel; 
    for(int i=0; i<6; i++) 
      for(int l=0;l<2;l++)
	order_face[i][l] += rel;
    for(int l=0; l<3; l++)
      order_inner_curl[l] = order_inner[l] + rel; 
    ComputeNDof();
  }
  
 
  //------------------------------------------------------------------------
  // HDivHighOrderNormalFiniteElement
  //------------------------------------------------------------------------
  template <int D>
  HDivHighOrderNormalFiniteElementSZ<D> ::
  HDivHighOrderNormalFiniteElementSZ (ELEMENT_TYPE aeltype)
    : HDivNormalFiniteElement<D> (aeltype, -1, -1)
  {
    for (int i = 0; i < 4; i++)
      vnums[i] = i;

    augmented = 0;
    discont = 0; 
  }

  template <int D>
  void HDivHighOrderNormalFiniteElementSZ<D>::
  SetVertexNumbers (FlatArray<int> & avnums)
  {

    for (int i = 0; i < avnums.Size(); i++)
      vnums[i] = avnums[i];
  }

  template <int D>
  void HDivHighOrderNormalFiniteElementSZ<D>::
  SetOrderInner (int oi)
  {
    order_inner = INT<2> (oi,oi);
    ComputeNDof(); 
  }

  template <int D>
  void HDivHighOrderNormalFiniteElementSZ<D>::
  SetOrderInnerCurl (int oi)
  {
    order_inner = INT<2> (oi,oi);
    ComputeNDof(); 
  }

  template <int D>
  void HDivHighOrderNormalFiniteElementSZ<D>::
  SetRelOrderCurl (int rel)
  {
    for(int l=0;l<2;l++)
      order_inner[l] += rel; 
    ComputeNDof(); 
  }

  template <int D>
  void HDivHighOrderNormalFiniteElementSZ<D>::
  SetOrderInner (INT<3> oi)
  {
    order_inner = INT<2>(oi[0],oi[1]); 
    order_inner_curl = INT<2>(oi[0],oi[1]); 
    ComputeNDof(); 
  }

  template <int D>
  void HDivHighOrderNormalFiniteElementSZ<D>::
  SetOrderInnerCurl (INT<3> oi)
  {
    order_inner_curl = INT<2>(oi[0],oi[1]); 
  }

  //------------------------------------------------------------------------
  // HDivHighOrderNormalSegmSZ
  //------------------------------------------------------------------------
  template <class T_ORTHOPOL>
  HDivHighOrderNormalSegmSZ<T_ORTHOPOL> :: HDivHighOrderNormalSegmSZ (int aorder)
    : HDivHighOrderNormalFiniteElementSZ<1>(ET_SEGM)
  {
    order_inner = INT<2> (aorder,aorder);
    discont=0; 
    //order_inner_curl = INT<2> (aorder,aorder);
    ComputeNDof();
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderNormalSegmSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    if(discont) { ndof = 0; return; } 
    ndof = order_inner[0] + 1;
    order = order_inner[0];
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderNormalSegmSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip,
							 FlatVector<> shape) const
  {
    double x = ip(0);

    int p = order_inner[0];

    int fac = 1;
    if (vnums[0] > vnums[1])
      {
	fac *= -1;
	x=1-x;
      }


    ArrayMem<double, 10> rec_pol(p+1), leg(2);

    MatrixFixWidth<2> DExt(p);
    T_ORTHOPOL::CalcTrigExtDeriv(p+1, 1-2*x, 0, DExt);

    //IntegratedLegendrePolynomial (order_inner, 1-2*x, rec_pol);
    // LegendrePolynomial (order_inner, 2*x-1, rec_pol);
    //T_ORTHOPOL::CalcDeriv(order_inner+1, 1-2*x, rec_pol);
    shape(0) = -1.*fac;
    for(int j=1; j<=p;j++)
      shape(j) = 2.* fac * DExt(j-1,0);

  }
  
  template class HDivHighOrderNormalSegmSZ<IntegratedLegendreMonomialExt>;
//   template class HDivHighOrderNormalSegmSZ<TrigExtensionMonomial>;
  
  //template class HDivHighOrderNormalSegmSZ<TrigExtensionOptimal>;
  //template class HDivHighOrderNormalSegmSZ<TrigExtensionMin>;

  //------------------------------------------------------------------------
  // HDivHighOrderNormalQuadSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderNormalQuadSZ<T_ORTHOPOL> :: HDivHighOrderNormalQuadSZ (int aorder)
    : HDivHighOrderNormalFiniteElementSZ<2>(ET_QUAD)
  {
    order_inner = INT<2> (aorder,aorder);
    order_inner_curl = INT<2> (aorder,aorder);
    discont = 0; 
    ComputeNDof();
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderNormalQuadSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    if(discont) { ndof = 0; return; } 
    ndof = 1 + order_inner_curl[0]*order_inner[1] + order_inner_curl[0] + order_inner_curl[1];
    order = int(max(order_inner_curl[0],order_inner_curl[1])); 
    order++;
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderNormalQuadSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip,
							 FlatVector<> shape) const
  {
    if(discont) return; 

    int i, j, k, l, m;
    AutoDiff<2> x (ip(0), 0);
    AutoDiff<2> y (ip(1), 1);


    AutoDiff<2> lami[4] = {(1-x)*(1-y),x*(1-y),x*y,(1-x)*y};
    AutoDiff<2> sigma[4] = {(1-x)+(1-y),x+(1-y),x+y,(1-x)+y};

    shape = 0.0;

   
    int fmax = 0;
    for (int j = 1; j < 4; j++)
      if (vnums[j] > vnums[fmax])
	fmax = j;
    
    int f1 = (fmax+3)%4;
    int f2 = (fmax+1)%4;
    
    int fac = 1;
    if(vnums[f2] > vnums[f1])
      {
	swap(f1,f2); // fmax > f1 > f2;
	fac *= -1;
      }

    shape(0) = fac;
    int ii = 1;
 
    INT<2> p = INT<2>(order_inner[0],order_inner[1]);
    INT<2> pc = INT<2>(order_inner_curl[0],order_inner_curl[1]);
    INT<2> pp = INT<2>(int(max(order_inner[0],order_inner_curl[0])), int(max(order_inner[1],order_inner_curl[1]))); 
    
 
    ArrayMem<AutoDiff<2>,20> pol_xi(pp[0]+1), pol_eta(pp[1]+1);
    AutoDiff<2> polprod;

    AutoDiff<2> xi  = sigma[fmax]-sigma[f1];
    AutoDiff<2> eta = sigma[fmax]-sigma[f2];


    T_ORTHOPOL::Calc(pp[0], xi,pol_xi); 
    T_ORTHOPOL::Calc(pp[1],eta,pol_eta);

    // Curl-Fields ( of Type 2) // 2*grad(v)xgrad(u) 
    for (k = 0; k < pc[0]; k++)
      for (l = 0; l < pc[1]; l++)
	shape(ii++) = 2.*(pol_eta[l].DValue(0)*pol_xi[k].DValue(1)-pol_eta[l].DValue(1)*pol_xi[k].DValue(0));
	    
    // Curl-Fields( of Type 3) 
    // Attention structuring changed for anisotropic order (-> also change in 3d elems!)  
    for (k = 0; k < pc[0]; k++)
      shape(ii++) = -eta.DValue(0)*pol_xi[k].DValue(1) + eta.DValue(1)*pol_xi[k].DValue(0);
   
    for (k = 0; k < pc[1]; k++)
      shape(ii++)   = -xi.DValue(0)*pol_eta[k].DValue(1) + xi.DValue(1)*pol_eta[k].DValue(0);
   
    return;

  }

  template class HDivHighOrderNormalQuadSZ<IntegratedLegendreMonomialExt>;
//   template class HDivHighOrderNormalQuadSZ<TrigExtensionMonomial>;
  // template class HDivHighOrderNormalQuadSZ<TrigExtensionOptimal>;
//   template class HDivHighOrderNormalQuadSZ<TrigExtensionMin>;

  //------------------------------------------------------------------------
  // HDivHighOrderNormalTrigSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderNormalTrigSZ<T_ORTHOPOL> :: HDivHighOrderNormalTrigSZ (int aorder)
    : HDivHighOrderNormalFiniteElementSZ<2>(ET_TRIG)
  {
    order_inner = INT<2>(aorder,aorder);
    order_inner_curl = INT<2>(aorder,aorder);
    discont = 0; 
    ComputeNDof();
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderNormalTrigSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    if(discont) { ndof = 0; return; } 
    ndof = 1 + (order_inner[0]*order_inner[0]+3*order_inner[0])/2;
    order = order_inner[0];
    order++;
  }
  
 
  
  template <class T_ORTHOPOL>
  void HDivHighOrderNormalTrigSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip, 
					 	       FlatVector<> shape) const
  {  
    if (discont) return; 
    
    AutoDiff<2> x (ip(0), 0); 
    AutoDiff<2> y (ip(1), 1); 
    AutoDiff<2> lami[3] = { x, y, 1-x-y };
    
    int i, j, k,l;
    int p = order_inner_curl[0]; 
       
    shape = 0.0; 
          
    //Sort vertices  first edge op minimal vertex 
    int fav[3] = {0,1,2};
    int fswap = 1; 
    if(vnums[fav[0]] > vnums[fav[1]]) {swap(fav[0],fav[1]); fswap*=-1; }
    if(vnums[fav[1]] > vnums[fav[2]]) {swap(fav[1],fav[2]); fswap*=-1; } 
    if(vnums[fav[0]] > vnums[fav[1]]) {swap(fav[0],fav[1]); fswap*=-1;} 

    shape(0) = fswap; 
    int ii = 1; 
      
    // Attention: xi f1-> f2 !!! is that compatible with 3D ELEMS?
    // But now compatible with H(curl)!! 
    AutoDiff<2> xi = lami[fav[2]]-lami[fav[1]];
    AutoDiff<2> eta = lami[fav[0]]; // in [0,1]
    ArrayMem<AutoDiff<2>,20 > adpol1(order+2),adpol2(order+2) ,adpol3(order+2); 
           
    T_INNERSHAPES::CalcSplitted (p+1, xi, eta, adpol1, adpol2); 
        
    // Curl-Fields (of Type 2)  2 * (nabla pol2) x (nabla pol1) 
    for (j = 0; j <= p-1; j++)
      for (k = 0; k <= p-1-j; k++, ii++)
	shape(ii) = 2* GradCrossGradSZ2(adpol2[k],adpol1[j]);  
    
    // Curl-Fields (of Type 2)  curl(ned)*adpol2 + \nabla ned x \nabla(adpol2) 
    double curlned = 2* GradCrossGradSZ2(lami[fav[1]],lami[fav[2]]); 
    for (j = 0; j <= p-1; j++, ii++)
      shape(ii) = curlned * adpol2[j].Value()
	+ lami[fav[1]].Value() *  GradCrossGradSZ2(adpol2[j],lami[fav[2]]) 
	- lami[fav[2]].Value() *  GradCrossGradSZ2(adpol2[j],lami[fav[1]]);

     
    // *testout << " ip " << ip << endl; 
    //*testout << " HdivNormalTrigSZ shape " << shape << endl; 
  }

  template class HDivHighOrderNormalTrigSZ<IntegratedLegendreMonomialExt>;
//   template class HDivHighOrderNormalTrigSZ<TrigExtensionMonomial>;
  // template class HDivHighOrderNormalTrigSZ<TrigExtensionOptimal>;
//   template class HDivHighOrderNormalTrigSZ<TrigExtensionMin>;

  //------------------------------------------------------------------------
  // HDivHighOrderTrigSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderTrigSZ<T_ORTHOPOL> :: HDivHighOrderTrigSZ (int aorder)
    : HDivHighOrderFiniteElementSZ<2>(ET_TRIG)
  {
    order_inner = INT<3>(aorder,aorder,aorder);
    for (int i = 0; i < 3; i++)
      order_edge[i] = aorder;

    order_inner_curl = INT<3>(aorder,aorder,aorder); 
    discont = 0; 
    ComputeNDof();
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderTrigSZ<T_ORTHOPOL> :: ComputeNDof()
  { 

    ndof = 3; // Thomas-Raviart 
    for (int i = 0; i < 3; i++)
      ndof += order_edge[i];
    
    int p = order_inner[0], pc = order_inner_curl[0];  
    if (pc > 1 )
      ndof += pc*(pc-1)/2;
    if (p > 1 ) 
      ndof += p*(p-1)/2 + p-1;
    
    order = 0; // max(order_edges_normal,order_inner);
    for (int i = 0; i < 3; i++)
      if (order_edge[i] > order)
	order = order_edge[i];
    
    if (p > order)  order = p;
    if (pc > order) order = pc; 
    order++;

  }

  template <class T_ORTHOPOL>
  void HDivHighOrderTrigSZ<T_ORTHOPOL> :: GetFacetDofs(int fa, ARRAY<int> & dnums) const 
  {
    if (fa > 2 ) 
      {
	cout << " Warning HDIVHighOrderTrigSZ::GetFacetDofNrs() index out of range" << endl; 
	
	dnums.SetSize(0); 
	return; 
      } 
  
    dnums.SetSize(0); 
    dnums.Append(fa); 
    
    int ii = 3; // Thomas-Raviart 
    for (int i = 0; i < fa; i++)
      ii += order_edge[i];

    for(int i = 0; i < order_edge[fa]; i++)  
      dnums.Append(ii+i); 
  }                  


 

  template <class T_ORTHOPOL>
  void HDivHighOrderTrigSZ<T_ORTHOPOL> ::
  GetInternalDofs (ARRAY<int> & idofs) const
  {
    //ComputeNDof(); 
    idofs.SetSize (0);
    
    int first_in = 3;  
    if (discont == 1) 
      first_in = 0; 
    
    if (!discont) 
      for (int i = 0; i < 3; i++)
	first_in += order_edge[i];
    
    for (int i = first_in; i < ndof; i++)
      idofs.Append (i);
  }

  /*   template <class T_ORTHOPOL>
  void HDivHighOrderTrigSZ<T_ORTHOPOL> :: GetFirstFacetDof(ARRAY<int> & first_facet_dof) 
  {
    first_facet_dof.SetSize(4); 
    
    first_facet_dof[0] = 3;
    for(int i=1;i<4;i++)
      first_facet_dof[i] = first_facet_dof[i-1]+order_edge[i]; 
      }*/ 

  

  template <class T_ORTHOPOL>
  void HDivHighOrderTrigSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip,
						   FlatMatrixFixWidth<2> shape) const
  { // Implemented as 90° rotation of H(curl) Trig

    AutoDiff<2> x(ip(0),0); 
    AutoDiff<2> y(ip(1),1); 
    AutoDiff<2> lami[3] = {x,y,1-x-y};

    double sign[2] = {1,-1}; 
    // curl(l) = sign[l]*grad((l+1)%2)  
    shape = 0.0; 
    
    int i, j, k, l;
    int ii = 3; 
        
    const EDGE * edges = ElementTopology::GetEdges (ET_TRIG);
    ArrayMem<double,30> mem(2*(order+2)); 
    ArrayMem<AutoDiff<2>,10> adpol1(order),adpol2(order);	
	
    for (i = 0; i < 3; i++)
      {
	int es = edges[i][0]; 
	int ee = edges[i][1];
	
	if (vnums[es] > vnums[ee])  swap (es, ee);

	//Raviart-Thomas-0 (lowest order) edge shape function
	for(l=0;l<2;l++) 
	  shape(i,l) = sign[l] * ( - lami[ee].DValue((l+1)%2)*lami[es].Value() + 
				   lami[es].DValue((l+1)%2)*lami[ee].Value());  

	int p = order_edge[i]; 
	//HO-Edge shapes (Curl Fields)   
	if(p>0) 
	  { 
	    AutoDiff<2> xi = lami[ee] - lami[es]; 
	    AutoDiff<2> eta = 1 - lami[ee] - lami[es]; 
	    T_ORTHOPOL::CalcTrigExt(p+1,xi, eta, adpol1); 
	   
	    for(j=0; j< p;j++,ii++) 
	      for(l=0;l<2;l++)
		shape(ii,l) = sign[l] * adpol1[j].DValue((l+1)%2);
	  }
      }   
     
    int p = order_inner[0]; 
    int pc = order_inner_curl[0];
    int pp = max(p,pc); 

    //Inner shapes (Face) 
    if(p>1) 
      {
	int fav[3] = {0,1,2}; 
	//Sort vertices ... v(f0) < v(f1) < v(f2) 
	if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]); 
	if(vnums[fav[1]] > vnums[fav[2]]) swap(fav[1],fav[2]);
	if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]); 	  

	AutoDiff<2> xi  = lami[fav[2]]-lami[fav[1]];
	AutoDiff<2> eta = lami[fav[0]]; 

	
	T_INNERSHAPES::CalcSplitted(pp+1, xi, eta, adpol1,adpol2);
	
	// curls:
	
	  for (j = 0; j < pc-1; j++)
	    for (k = 0; k < pc-1-j; k++, ii++)
	      for (l = 0; l < 2; l++)
		shape(ii, l) = sign[l] * (adpol1[j].DValue((l+1)%2) * adpol2[k].Value()
					  + adpol1[j].Value() * adpol2[k].DValue((l+1)%2)); 
	
	// other combination
	for (j = 0; j < p-1; j++)
	  for (k = 0; k < p-1-j; k++, ii++)
	    for (l = 0; l < 2; l++)
	      shape(ii, l) = sign[l] * (adpol1[j].DValue((l+1)%2) * adpol2[k].Value()
					- adpol1[j].Value() * adpol2[k].DValue((l+1)%2)); 
		
	
	double ned0[2]; 
	for(l=0;l<2;l++) 
	  ned0[l] = lami[fav[1]].Value()*lami[fav[2]].DValue(l) - lami[fav[2]].Value()*lami[fav[1]].DValue(l) ;  

	// rec_pol * (lami(1) Curl (lami(2))- lami(2) Curl(lami(1))) 
	for (j = 0; j < p-1; j++, ii++)
	  for (l = 0; l < 2; l++)
	    shape(ii,l) = sign[l]* adpol2[j].Value() * ned0[(l+1)%2]; 

	// (*testout) << "nedelec trig, shape = " << endl << shape << endl;
      }
  }
 
  // SZ: via H(curl) 
  template <class T_ORTHOPOL>
  void HDivHighOrderTrigSZ<T_ORTHOPOL> :: CalcDivShape (const IntegrationPoint & ip, 
						      FlatVector<> shape) const
  { 
    shape = 0.0; 
    
    AutoDiff<2> x(ip(0),0); 
    AutoDiff<2> y(ip(1),1); 
    AutoDiff<2> lami[3] = {x,y,1-x-y};
    
    const EDGE * edges = ElementTopology::GetEdges (ET_TRIG);
    
    int i, j, k, l, ii;
    ii=3; 
    if(augmented==1) ii = 6; 
      
    
    for (i = 0; i < 3; i++)
      {
	int es = edges[i][0]; 
	int ee = edges[i][1];
	if (vnums[es] > vnums[ee]) swap (es, ee);
	
	// \nabla \lambda_E  Curl \lambda_s - \nabla \lambda_s \curl \lambda_E 
	shape(i,0) = 2*(-lami[es].DValue(0)*lami[ee].DValue(1)
			 + lami[es].DValue(1)*lami[ee].DValue(0));  
	
	// Curl(Edge tangential shapes)  = 0.0; 
 	ii += order_edge[i];
      }    
      
    int p = order_inner[0]; 
    int pc = order_inner_curl[0];
    int pp = int(max(double(p),double(pc))); 
    
    // Inner shapes (Face) 
    
    int fav[3] ={0,1,2};    
    //Sort vertices  first edge op minimal vertex 
    if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]); 
    if(vnums[fav[1]] > vnums[fav[2]]) swap(fav[1],fav[2]);
    if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]); 	  
    
    AutoDiff<2> xi  = lami[fav[2]]-lami[fav[1]];
    AutoDiff<2> eta = lami[fav[0]]; // 1- lami[f2] - lami[f1]; 

    ArrayMem<AutoDiff<2>,10> adpol1(order),adpol2(order); 
    T_INNERSHAPES::CalcSplitted(p+1,xi,eta,adpol1,adpol2); 
    
    // curl(gradients) = 0.0
    ii += (pc-1)*pc/2; //  - (p-1);

    // curl(other combinations) = 2 Curl(u) * grad(v)  
    for (j = 0; j < p-1; j++)
      for (k = 0; k < p-1-j; k++)
	shape(ii++, 0) = -2*(- adpol2[k].DValue(0) * adpol1[j].DValue(1) 
			    + adpol2[k].DValue(1) * adpol1[j].DValue(0));

    // RT_0 * v_j 
    double rt0[2] = { - lami[fav[1]].Value()*lami[fav[2]].DValue(1) +
		      lami[fav[2]].Value()*lami[fav[1]].DValue(1), 
		      lami[fav[1]].Value()*lami[fav[2]].DValue(0) - 
		      lami[fav[2]].Value()*lami[fav[1]].DValue(0) };
        
    double divrt0 = 2*(-lami[fav[1]].DValue(0)*lami[fav[2]].DValue(1)
			 + lami[fav[1]].DValue(1)*lami[fav[2]].DValue(0)); 
 
    for (j = 0; j <= p-2; j++)  
      shape(ii++,0) = -1.*(divrt0 * adpol2[j].Value() + rt0[0]*adpol2[j].DValue(0) + 
		       rt0[1]*adpol2[j].DValue(1)); 
  }

  template class HDivHighOrderTrigSZ<IntegratedLegendreMonomialExt>;
  // template class HDivHighOrderTrigSZ<TrigExtensionMonomial>;
  //  template class HDivHighOrderTrigSZ<TrigExtensionOptimal>;
  // template class HDivHighOrderTrigSZ<TrigExtensionMin>;

  //------------------------------------------------------------------------
  // HDivHighOrderQuadSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderQuadSZ<T_ORTHOPOL> :: HDivHighOrderQuadSZ (int aorder)
    : HDivHighOrderFiniteElementSZ<2>(ET_QUAD)
  {
    order_inner = INT<3> (aorder,aorder,aorder);
    order_inner_curl = INT<3> (aorder,aorder,aorder);
    
    for (int i = 0; i < 4; i++)
      order_edge[i] = aorder;
    discont = 0; 
    ComputeNDof();
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    int i;
    ndof = 4;

    for (i = 0; i < 4; i++)
      ndof += order_edge[i];

    
    ndof += order_inner_curl[0]*order_inner_curl[1] +
      order_inner[0]*order_inner[1]+order_inner[0]+order_inner[1];

    order = 0;
    for (i = 0; i < 4; i++)
      if (order_edge[i] > order)
	order = order_edge[i];
    for(i=0;i<2;i++)
      if (order_inner[i] > order)
	order = order_inner[i];
    for(i=0;i<2;i++)
      if (order_inner_curl[i] > order)
	order = order_inner_curl[i];

    order++;
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> ::
  GetInternalDofs (ARRAY<int> & idofs) const
  {
    //ComputeNDof(); 
    idofs.SetSize (0);
    
    int first_in = 4;   
    if (discont == 1) 
      first_in = 0; 
    
    if (!discont) 
      for (int i = 0; i < 4; i++)
	first_in += order_edge[i];
    
    for (int i = first_in; i < ndof; i++)
      idofs.Append (i);
    
  }

  
 template <class T_ORTHOPOL>
 void HDivHighOrderQuadSZ<T_ORTHOPOL> :: GetFacetDofs(int fa, ARRAY<int> & dnums) const
  {
    if (fa > 3 ) 
      {
	cout << " Warning HDIVHighOrderQuadSZ::GetFacetDofNrs() index out of range" << endl; 
	
	dnums.SetSize(0); 
	return; 
      } 

   
    dnums.SetSize(0); 
    dnums.Append(fa);  
   
    int ii = 4; // Thomas-Raviart 
    for (int i = 0; i < fa; i++)
      ii += order_edge[i];

    for(int i = 0; i < order_edge[fa]; i++)  
      dnums.Append(ii+i); 
   

  } 

  /*   template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: GetFirstFacetDof(ARRAY<int> & first_facet_dof) 
  {
    first_facet_dof.SetSize(5); 
    
    first_facet_dof[0] = 4;
    for(int i=1;i<5;i++)
      first_facet_dof[i] = first_facet_dof[i-1]+order_edge[i]; 
      }*/ 
#undef OLDHDIVV
#ifdef OLDHDIVV
  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip,
						   FlatMatrixFixWidth<2> shape) const
  {


    AutoDiff<2> x (ip(0), 0);
    AutoDiff<2> y (ip(1), 1);


    AutoDiff<2> lami[4] = {(1-x)*(1-y),x*(1-y),x*y,(1-x)*y};
    AutoDiff<2> sigma[4] = {(1-x)+(1-y),x+(1-y),x+y,(1-x)+y};


    AutoDiff<2> ext[4] = {1-y, y, 1-x, x};


    Mat<4,2> can(0);
    can(0,1) = -1.;
    can(1,1) = 1.;
    can(2,0) = -1.;
    can(3,0) = 1.;

    shape = 0.0;


    int p;

    int ii = 4;


    ArrayMem<AutoDiff<2>,20> rec_pol(order+2);


    const EDGE * edges = ElementTopology::GetEdges (ET_QUAD);

    int is, ie;
    for (int i = 0; i < 4; i++)
      {
	p = order_edge[i];

	is = edges[i][0];
	ie = edges[i][1];


	//(*testout)<<"vnums[is]="<<vnums[is]<<"vnums[ie]="<<vnums[ie]<<endl;
        int fac=1;
	if (vnums[is] > vnums[ie])
	  { swap (is, ie); fac *= -1;}
	// (*testout)<<"vnums[is]="<<vnums[is]<<"vnums[ie]="<<vnums[ie]<<endl;
	//(*testout)<<"fac="<<fac<<endl;



        AutoDiff<2> prod;
	AutoDiff<2> xi  = sigma[ie]-sigma[is]; // in [-1,1]
	AutoDiff<2> eta = lami[ie]+lami[is];  // attention in [0,1]

        T_ORTHOPOL::Calc(p+1, xi,rec_pol);

        //RT low order edge shape function
        for(int k=0; k<2; k++)
	  shape(i,k) = -1.*fac*ext[i].Value()*can(i,k);

	//Edge normal shapes
	for (int j=0; j < p; j++, ii++)
	  {
	    prod = eta*rec_pol[j];
	    shape(ii,0) = prod.DValue(1);
	    shape(ii,1) = -prod.DValue(0);
	  }

	/*
	  AutoDiff<2> ss = sigma[is];
	  AutoDiff<2> se = sigma[ie];
	  AutoDiff<2> xi  = sigma[ie]-sigma[is]; // in [-1,1]
	  AutoDiff<2> eta = lami[ie]+lami[is];  // attention in [0,1]
	  LegendrePolynomial(p+1, se-ss, rec_pol);
	  //RT low order edge shape function
	  for(int k=0; k<2; k++)
	  shape(i,k) = -1.*fac*ext[i].Value()*can(i,k);
	  // Edge normal shapes
	  for (int j=1; j<=p; j++, ii++)
	  for (int k=0; k<2; k++)
	  shape(ii,k) = 2.*fac*rec_pol[j].Value()*ext[i].Value()*can(i,k);
	*/




      }
    // Inner shapes
    p = order_inner[0];

    ArrayMem<AutoDiff<2>,20> polxi(p+1), poleta(p+1);
    AutoDiff<2> polprod;

    int fmax = 0;
    for (int j = 1; j < 4; j++)
      if (vnums[j] > vnums[fmax])
	fmax = j;

    int f1 = (fmax+3)%4;
    int f2 = (fmax+1)%4;


    if(vnums[f2] > vnums[f1])
      swap(f1,f2);  // fmax > f1 > f2;


    AutoDiff<2> xi  = sigma[fmax]-sigma[f1];
    AutoDiff<2> eta = sigma[fmax]-sigma[f2];

    //LegendrePolynomial(p+1, xi, polxi);
    //LegendrePolynomial(p+1, eta, poleta);

    T_ORTHOPOL::Calc(p+1, xi,polxi);
    T_ORTHOPOL::Calc(p+1,eta,poleta);


    for (int i = 0; i < p; i++)
      {
	for (int j = 0; j < p; j++)
	  {
	    polprod = polxi[i]*poleta[j];
	    shape(ii,0) = polprod.DValue(1);
	    shape(ii++,1) = -polprod.DValue(0);
	  }
      }
    for (int i = 0; i < p; i++)
      {
	for (int j = 0; j < p; j++)
	  {
	    shape(ii,0) = (polxi[i].DValue(1)*poleta[j].Value() - polxi[i].Value()*poleta[j].DValue(1));
	    shape(ii++,1) = (-polxi[i].DValue(0)*poleta[j].Value() + polxi[i].Value()*poleta[j].DValue(0));
	  }
      }
    for (int i= 0; i < p; i++, ii+=2)
      {

	shape(ii,0) = (xi.DValue(1)*poleta[i].Value());
	shape(ii,1) = (-xi.DValue(0)*poleta[i].Value());
	shape(ii+1,0) = (eta.DValue(1)*polxi[i].Value());
	shape(ii+1,1) = (-eta.DValue(0)*polxi[i].Value());
      }

    return;

  }

 #ifndef SABINE 

  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: CalcDivShape (const IntegrationPoint & ip,
						      FlatVector<> shape ) const
  {


    AutoDiff<2> x (ip(0), 0);
    AutoDiff<2> y (ip(1), 1);


    AutoDiff<2> lami[4] = {(1-x)*(1-y),x*(1-y),x*y,(1-x)*y};
    AutoDiff<2> sigma[4] = {(1-x)+(1-y),x+(1-y),x+y,(1-x)+y};
    AutoDiff<2> ext[4] = {(1-y), y, (1-x), x};
    int ind[4] = {1, 1, 0, 0};
    int can[4] = {-1, 1, -1, 1};
    shape = 0.0;

    int p;

    int ii = 4;

    ArrayMem<AutoDiff<2>,10> rec_pol(order+1);
    AutoDiff<2> pol_ext;

    const EDGE * edges = ElementTopology::GetEdges (ET_QUAD);

    int is, ie;
    for (int i = 0; i < 4; i++)
      {
	p = order_edge[i];
	is = edges[i][0];
	ie = edges[i][1];

        int fac=1;
	if (vnums[is] > vnums[ie])
	  {  swap (is, ie); fac*=-1;
	  }

        AutoDiff<2> ss = sigma[is];
	AutoDiff<2> se = sigma[ie];

        LegendrePolynomial(p+1, se-ss, rec_pol);

        //RT low order edge shape function

	shape(i) = -1.*fac*ext[i].DValue(ind[i])*can[i];

	//Edge normal shapes
	/*for (int j=1; j<=p; j++)
	  {
	  pol_ext = rec_pol[j]*ext[i];
	  shape(ii++) = 2.*fac*pol_ext.DValue(ind[i])*can[i];
	  //shape(ii++) = rec_pol[j].DValue(ind[i]);

	  }*/
	ii += p;

      }
    // Inner shapes
    p = order_inner[0];

    ArrayMem<AutoDiff<2>,20> polxi(p+1), poleta(p+1);
    AutoDiff<2> polprod;

    int fmax = 0;
    for (int j = 1; j < 4; j++)
      if (vnums[j] > vnums[fmax])
	fmax = j;

    int f1 = (fmax+3)%4;
    int f2 = (fmax+1)%4;

    if(vnums[f2] > vnums[f1]) swap(f1,f2);  // fmax > f1 > f2;

    AutoDiff<2> xi  = sigma[fmax]-sigma[f1];
    AutoDiff<2> eta = sigma[fmax]-sigma[f2];


    //LegendrePolynomial(p+1, xi, polxi);
    //LegendrePolynomial(p+1, eta, poleta);
    T_ORTHOPOL::Calc(p+1, xi,polxi);
    T_ORTHOPOL::Calc(p+1,eta,poleta);

    ii += p*p;

    for (int i = 0; i < p; i++)
      {
	for (int j = 0; j < p; j++)
	  {
	    shape(ii++) = (2*(polxi[i].DValue(1)*poleta[j].DValue(0) - polxi[i].DValue(0)*poleta[j].DValue(1)));
          }
      }
    for (int i= 0; i < p; i++, ii+=2)
      {

	shape(ii) = (xi.DValue(1)*poleta[i].DValue(0)-xi.DValue(0)*poleta[i].DValue(1));
	shape(ii+1) = (eta.DValue(1)*polxi[i].DValue(0)-eta.DValue(0)*polxi[i].DValue(1));
      }

    return;

  }

  #endif 
#else


  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip, 
				       FlatMatrixFixWidth<2> shape) const
  { // Implemenated as 90° rotation of H(curl) 
    int i, j, k, l;
    AutoDiff<2> x (ip(0),0);
    AutoDiff<2> y (ip(1),1);

    AutoDiff<2> lami[4] = {(1-x)*(1-y),x*(1-y),x*y,(1-x)*y};  
    AutoDiff<2> sigma[4] = {(1-x)+(1-y),x+(1-y),x+y,(1-x)+y};  
 
    const EDGE * edges = ElementTopology::GetEdges (ET_QUAD);

    shape = 0;
    int ii = 4;
    double sign[2] = {-1.,1.}; // sign in 90° rotation

    ArrayMem<AutoDiff<2>, 10> pol_xi(order+2);
    ArrayMem<AutoDiff<2>, 10> pol_eta(order+2);
    
    // edges
    for (i = 0; i < 4; i++)
      {
	int p = order_edge[i]; 
	int es = edges[i][0];
	int ee = edges[i][1];
	if (vnums[es] > vnums[ee]) swap (es, ee);

	AutoDiff<2> xi  = sigma[ee]-sigma[es];
	AutoDiff<2> lam_e = lami[ee]+lami[es];  // attention in [0,1]

	// RT0-shapes
	for(l=0; l<2; l++) 
	  shape(i,l) = 0.5*sign[l]*xi.DValue((l+1)%2)*lam_e.Value(); 
	
	// High Order edges ... Gradient fields 
	T_ORTHOPOL::Calc (p+1, xi,pol_xi);  
	for (j = 0; j < p; j++, ii++)
	  for(l=0; l<2; l++)
	    shape(ii,l) =  sign[l] * (lam_e.DValue((l+1)%2)*pol_xi[j].Value() + 
				      lam_e.Value()*pol_xi[j].DValue((l+1)%2));
      }
     
    INT<2> p = INT<2>(order_inner[0],order_inner[1]);
    INT<2> pc = INT<2>(order_inner_curl[0],order_inner_curl[1]);
    INT<2> pp = INT<2>((max(pc[0],p[0])),(max(pc[1],p[1])));
	    	      
    int fmax = 0; 
    for (j = 1; j < 4; j++)
      if (vnums[j] > vnums[fmax])
	fmax = j;
    
    int f1 = (fmax+3)%4; 
    int f2 = (fmax+1)%4; 
    if(vnums[f1] > vnums[f2]) swap(f1,f2);  // fmax > f2 > f1; 

    AutoDiff<2> xi = sigma[fmax]-sigma[f2];  // in [-1,1]
    AutoDiff<2> eta = sigma[fmax]-sigma[f1]; // in [-1,1]
    
    T_ORTHOPOL::Calc(pp[0]+1, xi,pol_xi);
    T_ORTHOPOL::Calc(pp[1]+1,eta,pol_eta);
    
    // curl-fields
    for (k = 0; k < pc[0]; k++)
      for (j= 0; j < pc[1]; j++, ii++)
	for(l=0; l<2; l++)
	  shape(ii,l) = sign[l]*(pol_xi[k].Value()*pol_eta[j].DValue((l+1)%2) 
				 + pol_xi[k].DValue((l+1)%2)*pol_eta[j].Value()); 
    
    // non-div-free Type 2a
    for (k = 0; k < p[0]; k++)
      for (j= 0; j < p[1]; j++, ii++)
	for(l=0; l<2; l++)
	  shape(ii,l) = sign[l]*(pol_xi[k].DValue((l+1)%2)*pol_eta[j].Value() 
				 - pol_xi[k].Value()*pol_eta[j].DValue((l+1)%2)); 

    // non-div-free Type 2b
    for(j=0; j< p[0]; j++, ii++)
      for(l=0;l<2;l++)
	shape(ii,l) = sign[l]*0.5*eta.DValue((l+1)%2)*pol_xi[j].Value();
    for(j=0; j< p[1]; j++, ii++)
      for(l=0;l<2;l++)
	shape(ii,l) = sign[l]*0.5*xi.DValue((l+1)%2)*pol_eta[j].Value(); 
    
    return;
  }


  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: CalcDivShape (const IntegrationPoint & ip,
 							FlatVector<> shape) const
  {
    int i, j, k, l;
    AutoDiff<2> x (ip(0),0);
    AutoDiff<2> y (ip(1),1);

    AutoDiff<2> lami[4] = {(1-x)*(1-y),x*(1-y),x*y,(1-x)*y};  
    AutoDiff<2> sigma[4] = {(1-x)+(1-y),x+(1-y),x+y,(1-x)+y};  
 
    const EDGE * edges = ElementTopology::GetEdges (ET_QUAD);

    shape = 0.0;
    int ii = 4;

    ArrayMem<AutoDiff<2>, 10> pol_xi(order+2);
    ArrayMem<AutoDiff<2>, 10> pol_eta(order+2);
    
    // edges
    for (i = 0; i < 4; i++)
      {
	int p = order_edge[i]; 
	int es = edges[i][0];
	int ee = edges[i][1];
	if (vnums[es] > vnums[ee]) swap (es, ee);

	AutoDiff<2> xi  = sigma[ee]-sigma[es];
	AutoDiff<2> lam_e = lami[ee]+lami[es];  

	// rt0-shapes
	for(l=0; l<2; l++) 
	  shape(i) = 0.5*(- lam_e.DValue(0)*xi.DValue(1) + 
			    lam_e.DValue(1)*xi.DValue(0));

	// curl-fields  
	ii+=order_edge[i]; 
      }
     
    INT<2> p(order_inner[0],order_inner[1]);
    int fmax = 0; 
    for (j = 1; j < 4; j++)
      if (vnums[j] > vnums[fmax])
	fmax = j;
    
    int f1 = (fmax+3)%4; 
    int f2 = (fmax+1)%4; 
    if(vnums[f1] > vnums[f2]) swap(f1,f2);  // fmax > f2 > f1; 

    AutoDiff<2> xi = sigma[fmax]-sigma[f2];  // in [-1,1]
    AutoDiff<2> eta = sigma[fmax]-sigma[f1]; // in [-1,1]
    
    T_ORTHOPOL::Calc(p[0]+1, xi,pol_xi);
    T_ORTHOPOL::Calc(p[1]+1,eta,pol_eta);
    
    //Curl-Fields
    ii+=p[0]*p[1]; 
        
    //Rotation of Gradient fields
    for (k = 0; k < p[0]; k++)
      for (j= 0; j < p[1]; j++, ii++)
	shape(ii,0)=- 2*(pol_eta[j].DValue(0)*pol_xi[k].DValue(1)-pol_eta[j].DValue(1)*pol_xi[k].DValue(0));

    //Missing ones 
    for(j=0; j< p[0]; j++, ii++)
      shape(ii,0) = - 0.5*(pol_xi[j].DValue(0)*eta.DValue(1)-pol_xi[j].DValue(1)*eta.DValue(0)); 
    
    for(j=0; j< p[1]; j++, ii++)
      shape(ii,0) = - 0.5*(pol_eta[j].DValue(0)*xi.DValue(1)-pol_eta[j].DValue(1)*xi.DValue(0)); 

    return;
  }
#endif
  
  template <class T_ORTHOPOL>
  void HDivHighOrderQuadSZ<T_ORTHOPOL> :: CalcNumDivShape (const IntegrationPoint & ip,
							 FlatVector<> divshape) const
  {
    double x=ip(0);
    double y=ip(1);
    LocalHeap lh(10000000);
    FlatMatrixFixWidth<2> cshape(ndof, lh);
    FlatMatrixFixWidth<2> cshape1(ndof, lh);
    FlatMatrixFixWidth<2> cshape_(ndof, lh);
    FlatMatrixFixWidth<2> cshape1_(ndof, lh);
    FlatMatrixFixWidth<2> cshape2(ndof, lh);
    FlatMatrixFixWidth<2> cshape3(ndof, lh);
    FlatMatrixFixWidth<2> cshape2_(ndof, lh);
    FlatMatrixFixWidth<2> cshape3_(ndof, lh);

    double h = 0.001;
    IntegrationPoint ipp(x+h,y,0,0);
    IntegrationPoint ipp1(x-h,y,0,0);
    IntegrationPoint ipp_(x+2*h,y,0,0);
    IntegrationPoint ipp1_(x-2*h,y,0,0);
    IntegrationPoint ipp2(x,y+h,0,0);
    IntegrationPoint ipp3(x,y-h,0,0);
    IntegrationPoint ipp2_(x,y+2*h,0,0);
    IntegrationPoint ipp3_(x,y-2*h,0,0);

    CalcShape(ipp,cshape);
    CalcShape(ipp1,cshape1);
    CalcShape(ipp_,cshape_);
    CalcShape(ipp1_,cshape1_);
    CalcShape(ipp2,cshape2);
    CalcShape(ipp3,cshape3);
    CalcShape(ipp2_,cshape2_);
    CalcShape(ipp3_,cshape3_);

    for (int i = 0; i< ndof; i++)
      divshape(i) = 2/(3*h)*(cshape(i,0)-cshape1(i,0))-1/(12*h)*(cshape_(i,0)-cshape1_(i,0)) + 2/(3*h)*(cshape2(i,1)-cshape3(i,1))-1/(12*h)*(cshape2_(i,1)-cshape3_(i,1));

    return;
  }
  

  template class HDivHighOrderQuadSZ<IntegratedLegendreMonomialExt>;
  // template class HDivHighOrderQuadSZ<TrigExtensionMonomial>;
  // template class HDivHighOrderQuadSZ<TrigExtensionOptimal>;
  // template class HDivHighOrderQuadSZ<TrigExtensionMin>;


  //------------------------------------------------------------------------
  // HDivHighOrderTetSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderTetSZ<T_ORTHOPOL> :: HDivHighOrderTetSZ (int aorder)
    : HDivHighOrderFiniteElementSZ<3>(ET_TET)
  {
    nv = 4;
    ned = 6;
    nf = 4;
    augmented =0;
    discont = 0; 

    int i;
    order_inner = INT<3>(aorder,aorder,aorder); 
    order_inner_curl = INT<3>(aorder,aorder,aorder); 
    ComputeNDof();
  }


  template <class T_ORTHOPOL>
  void HDivHighOrderTetSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    ndof = 4;
    for (int i = 0; i < 4; i++)
      {
	if (order_face[i][0] > 0)
	  ndof += (order_face[i][0]*order_face[i][0]+3*order_face[i][0])/2;
	else 
	  order_face[i] = 0; 
      }
	
    int p = order_inner[0];
    int pc = order_inner_curl[0]; 
    if(pc > 1) 
      ndof += pc*(pc+1)*(pc-1)/3 + pc*(pc-1)/2;
    if(p > 1) 
      ndof += p*(p+1)*(p-1)/6 + p*(p-1)/2 + p-1;
      
    order = 0; // max(order_face_normal,order_inner);
    for (int i = 0; i < 4; i++)
      if (order_face[i][0] > order)
	order = order_face[i][0];
    if (p > order)
      order = p;
    if (pc > order) 
      order = pc; 
    order++;
  }

  


  template <class T_ORTHOPOL>
  void HDivHighOrderTetSZ<T_ORTHOPOL> ::
  GetInternalDofs (ARRAY<int> & idofs) const
  {
    //ComputeNDof(); 
    idofs.SetSize (0);
    
    int first_in = 4;  
    if (discont == 1) 
      first_in = 0; 
    
    if (!discont) 
      {
	for (int i = 0; i < 4 ; i++)
	  first_in += order_edge[i];
	for (int i = 0; i < 4; i++)
	  first_in += (order_face[i][0]*order_face[i][0] + 3*order_face[i][0])/2;
      }

    for (int i = first_in; i < ndof; i++)
      idofs.Append (i);
  }

  

  template <class T_ORTHOPOL>
  void HDivHighOrderTetSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip,
						  FlatMatrixFixWidth<3> shape) const
  {
    AutoDiff<3> x(ip(0),0);
    AutoDiff<3> y(ip(1),1);
    AutoDiff<3> z(ip(2),2);

    AutoDiff<3> lami[4] = {x, y, z, 1-x-y-z}; 
    
    int i, j, ii, k,l, m, n;
    int print=0;
    shape = 0.0; 
  
    const FACE * faces = ElementTopology::GetFaces (ET_TET);
  
    ArrayMem<AutoDiff<3>,10> adpol1(order+2),adpol2(order+2),adpol3(order+2); 
     
    ii =4; 
    for (i = 0; i < 4; i++)
      {
	int p = order_face[i][0]; 

	int fav[3] =  { faces[i][0], faces[i][1], faces[i][2] };
      
	//Sort vertices  first edge op minimal vertex
	if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]);
	if(vnums[fav[1]] > vnums[fav[2]]) swap(fav[1],fav[2]);
	if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]);
	int fop = 6 - fav[0] - fav[1] - fav[2];
      
	AutoDiff<3> cr0 =  GradCrossGradSZ(lami[fav[1]],lami[fav[2]]); 
	AutoDiff<3> cr1 =  GradCrossGradSZ(lami[fav[2]],lami[fav[0]]);
	AutoDiff<3> cr2 =  GradCrossGradSZ(lami[fav[0]],lami[fav[1]]);
      
	AutoDiff<3> rt = cr0 * lami[fav[0]].Value() + cr1 *lami[fav[1]].Value() + cr2 *lami[fav[2]].Value();  
	
	//RT_0 low order
	for(l=0;l<3;l++) 
	  shape(i,l) = rt.DValue(l); 
	
	// Curl-Shapes   
	AutoDiff<3> xi = lami[fav[1]]-lami[fav[0]];//lami[fav[2]]-lami[fav[1]];
	AutoDiff<3> eta = lami[fav[2]];//lami[fav[0]]; // in [0,1]
	AutoDiff<3> zeta = lami[fop];  // in [0,1] // lam_F
      
	T_FACESHAPES::CalcSplitted (p+2, xi, eta, zeta, adpol1, adpol2); 

     
      // ATTENTION WITH TRIG!! 
      // for (k=0;k<adpol1.Size();k++)
      //   adpol1[k]*=0.25; 
      
	// Curl (Type 2) 2*grad v x grad u
	for (j = 0; j <= p-1; j++) 
	  for (k = 0; k <= p-1-j; k++, ii++)
	    { 
	      AutoDiff<3> hv =  GradCrossGradSZ(adpol2[k],adpol1[j]); 
	      for(l=0;l<3;l++)
		shape(ii,l) = 2*hv.DValue(l); 
	    }
	
	// Curl (Type 3) //curl( * v) = nabla v x ned + curl(ned)*v
      Vec<3> ned; 
	for(l=0;l<3;l++) 
        ned(l) = lami[fav[0]].Value()*lami[fav[1]].DValue(l) - lami[fav[1]].Value()*lami[fav[0]].DValue(l);//lami[fav[1]].Value()*lami[fav[2]].DValue(l) - lami[fav[2]].Value()*lami[fav[1]].DValue(l);
      AutoDiff<3> curlned =  
          2* GradCrossGradSZ(lami[fav[0]],lami[fav[1]]);//2* GradCrossGradSZ(lami[fav[1]],lami[fav[2]]);
	
	for (j = 0; j <= p-1; j++, ii++)
	  {
	    Vec<3> hv1 =  GradCrossVecSZ(adpol2[j],ned); 
	    
	    for(l=0;l<3;l++)
	      shape(ii,l) = curlned.DValue(l) * adpol2[j].Value()+ hv1(l);  
	  }
      }
    
      
    // cell-based shapes 
    int p = order_inner[0];
    int pc = order_inner_curl[0];  
    int pp = max(p,pc); 
    if ( p >= 2 || pc >= 2 ) 
      {
	T_INNERSHAPES::CalcSplitted(pp+2, lami[0]-lami[3], lami[1], lami[2],adpol1, adpol2, adpol3 );
      
	// Curl-Fields 
      for (i = 0; i <= pc-2; i++)
	  for (j = 0; j <= pc-2-i; j++)
	    for (k = 0; k <= pc-2-i-j; k++, ii+=2)
	      {
		// 2 grad v  x  grad (uw)
		AutoDiff<3> hv = 2* GradCrossGradSZ(adpol2[j],adpol1[i]*adpol3[k]);
	
		for (l = 0; l < 3; l++)
		  shape(ii,l) = hv.DValue(l);
				
		// 2 grad w  x  grad (uv)
		hv = 2* GradCrossGradSZ(adpol3[k], adpol1[i] * adpol2[j]);
	
		for (l = 0; l < 3; l++)
		  shape(ii+1,l) = hv.DValue(l); 
     
          // new 
           /* 
            ii++;
            hv =  GradCrossGradSZ(adpol1[i],adpol2[j]);
            
              for (l = 0; l < 3; l++)
                shape(ii+1,l) = hv.DValue(l) * adpol3[k].Value(); 
           */
	      }	

	// Type 1 : Curl(T3)
	// ned = lami[0] * nabla(lami[3]) - lami[3] * nabla(lami[0]) 
	double curlned[3] = {0,2,-2}; 
      Vec<3> curlnedv; curlnedv(0) = 0; curlnedv(1)=2; curlnedv(2)=-2; // = {0,2,-2}; 
	Vec<3> nedv; 
     
	for(l=0;l<3;l++) 
	  nedv(l) = lami[0].Value()*lami[3].DValue(l) - lami[3].Value()*lami[0].DValue(l);
      
	for (j= 0; j <= pc-2; j++)
	  for (k = 0; k <= pc-2-j; k++, ii++)
	    {
	      // Curl(Ned*vj*wk) = vj*wk*Curl(ned) + nabla(vj*wk)xNed0
            AutoDiff<3> pjk = adpol2[j] * adpol3[k]; 
            Vec<3> vv =  GradCrossVecSZ(pjk,nedv); 
            vv +=pjk.Value()*curlnedv; 
             
            for(l=0; l<3; l++) 
		  shape(ii,l) = vv(l); 
            
          /*  //new      
            ii++;
            vv =  GradCrossVecSZ(adpol2[j],nedv);
              for(l=0; l<3; l++) 
                shape(ii,l) = -adpol3[k].Value()*vv(l);
         */ 
             
	    }
       
	// Type 2:  
      // (grad u  x  grad v) w 
	for (i = 0; i <= p-2; i++)
	  for (j = 0; j <= p-2-i; j++)
	    {
	      AutoDiff<3> hv =  GradCrossGradSZ(adpol1[i],adpol2[j]);
	      for (k = 0; k <= p-2-i-j; k++,ii++)
		for (l = 0; l < 3; l++)
		  shape(ii,l) = hv.DValue(l) * adpol3[k].Value(); 
	    }    
          
	 // (ned0 x grad v) w    
	for (j = 0; j <= p-2; j++)
	  {
          Vec<3> vv =  GradCrossVecSZ(adpol2[j],nedv);
          for (k= 0; k <= p-2-j; k++, ii++)
	      for(l=0; l<3; l++) 
		  shape(ii,l) = -adpol3[k].Value()*vv(l);
	  } 
	
          
      // Type 3: 
      // (ned0 x e_z) v = (N_y, -N_x,0)^T * v ) 
	for (j=0; j<=p-2; j++,ii++) 
      {        
        Vec<3> hv =  GradCrossVecSZ(z,nedv);
       for(int l=0;l<3;l++) shape(ii,l) = -hv(l)*adpol2[j].Value();
      }
      
      }
      
     // *testout << " shape new " << shape << endl; 
    return; 

  }
 
#ifdef DIVTET

  template <class T_ORTHOPOL>
  void HDivHighOrderTetSZ<T_ORTHOPOL> :: CalcDivShape (const IntegrationPoint & ip,
						     FlatVector<> shape) const		 
  {
    
    LocalHeap lh(100000); 
    FlatVector<> shape2(shape.Size(),lh); 
    HDivHighOrderFiniteElementSZ<3> :: CalcDivShape(ip,shape2); 
    
    AutoDiff<3> x(ip(0),0);
    AutoDiff<3> y(ip(1),1);
    AutoDiff<3> z(ip(2),2);
    AutoDiff<3> lami[4] = {x, y, z, 1-x-y-z}; 
    
    shape = 0.0; 
  
    const FACE * faces = ElementTopology::GetFaces (ET_TET);
    const POINT3D * vertices = ElementTopology::GetVertices (ET_TET);
    
    ArrayMem< AutoDiff<3> , 10> adpol1(order+2), adpol2(order+2), adpol3(order+2); 
     
    int ii = 4;
    for (int i = 0; i < 4; i++)
    {
      int p = order_face[i][0]; 
      ii += (p*p+3*p)/2; 

      int fav[3] =  { faces[i][0], faces[i][1], faces[i][2] };
      
      //Sort vertices  first edge op minimal vertex
      if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]);
      if(vnums[fav[1]] > vnums[fav[2]]) swap(fav[1],fav[2]);
      if(vnums[fav[0]] > vnums[fav[1]]) swap(fav[0],fav[1]);
      int fop = 6 - fav[0] - fav[1] - fav[2];
      
   
      AutoDiff<3> cr0 =  GradCrossGradSZ(lami[fav[1]],lami[fav[2]]); 
      AutoDiff<3> cr1 =  GradCrossGradSZ(lami[fav[2]],lami[fav[0]]);
      AutoDiff<3> cr2 =  GradCrossGradSZ(lami[fav[0]],lami[fav[1]]);
      
    
   
      for(int l=0;l<3;l++)
      {
        shape(i) += cr0.DValue(l)*lami[fav[0]].DValue(l) + cr1.DValue(l)*lami[fav[1]].DValue(l) +cr2.DValue(l)*lami[fav[2]].DValue(l) ; 
      }
	
    
    }
     // cell-based shapes 
    int p = order_inner[0];
    int pc = order_inner_curl[0];  
    int pp = max(p,pc); 
    if (pc >= 2 ) 
       ii += pc*(pc+1)*(pc-1)/3 + pc*(pc-1)/2; 
      
    if (p >=2) 
      { 
        
        
	T_INNERSHAPES::CalcSplitted(pp+2, x-(1-x-y-z), y, z,adpol1, adpol2, adpol3 );
	
      // Type 2:  
       // (grad u  x  grad (v)) . grad w 
      for (int i = 0; i <= p-2; i++)
        for (int j = 0; j <= p-2-i; j++)
        for (int k = 0; k <= p-2-i-j; k++,ii++)             
        { 
       //   ii+=2; // curl
          
          AutoDiff<3> hv =  GradCrossGradSZ(adpol1[i],adpol2[j]);
          for (int l = 0; l < 3; l++)
            shape(ii) += hv.DValue(l) * adpol3[k].DValue(l); 
  
        }
      
            
      Vec<3> curlnedv; curlnedv(0) = 0; curlnedv(1)=2; curlnedv(2)=-2; // = {0,2,-2}; 
      Vec<3> nedv; 
     
      for(int l=0;l<3;l++) 
      nedv(l) = lami[0].Value()*lami[3].DValue(l) - lami[3].Value()*lami[0].DValue(l);
      AutoDiff<3> ned[3]; 
      for(int l=0;l<3;l++) 
        ned[l] = lami[0]*lami[3].DValue(l) - lami[3]*lami[0].DValue(l);
      
      
       // div((ned0 x grad v) w) = grad v * curlned *w + gradw *(ned0xgradv)    
      for (int j = 0; j <= p-2; j++)
      {
        
        
        Vec<3> vv =  GradCrossVecSZ(adpol2[j],nedv);
        double sp = 0; 
        for(int l=0;l<3;l++) sp+=curlnedv(l)*adpol2[j].DValue(l);
        for (int k= 0; k <= p-2-j; k++, ii++)
        { 
          //ii++; //curl
          
          shape(ii) = adpol3[k].Value()*sp; 
          for(int l=0; l<3; l++) 
            shape(ii) -=  adpol3[k].DValue(l)*vv(l);
         
        }
      } 
      
       // div((ned0 x grad z) v) = grad z * curlned *v + gradv *(ned0xgradz)    
     
        Vec<3> vv =  GradCrossVecSZ(z,nedv);
        double sp = 0; 
        for(int l=0;l<3;l++) sp+=curlnedv(l)*z.DValue(l);
        for (int k= 0; k <= p-2; k++, ii++)
        { 
          shape(ii) = adpol2[k].Value()*sp; 
          for(int l=0; l<3; l++) 
            shape(ii) -=  adpol2[k].DValue(l)*vv(l);
        }
      
      
      }
      
      *testout << " divshape new " << shape << endl; 
      *testout << " shape2 " << shape2 << endl;
      *testout << " diff " << shape-shape2 << endl;   
  }

#endif



  
  //------------------------------------------------------------------------
  // HDivHighOrderPrismSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderPrismSZ<T_ORTHOPOL> :: HDivHighOrderPrismSZ (int aorder)
    : HDivHighOrderFiniteElementSZ<3>(ET_PRISM)
  {
    order_inner = INT<3>(aorder,aorder,aorder);
    order_inner_curl  = order_inner; 
    
    for (int i=0; i<5; i++)
      order_face[i] = INT<2> (aorder,aorder);

    discont = 0; 
    ComputeNDof();
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderPrismSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    ndof = 5; // RT_0
    // trig_faces
    for (int i=0; i < 2; i++)
      ndof += (order_face[i][0]*(3+order_face[i][0]))/2;
    
    // quad_faces
    for (int i=2; i < 5; i++)
      ndof +=  order_face[i][0]*order_face[i][1] + order_face[i][0] + order_face[i][1];
    
    // SZ: INNER CURLS !!! 
    if (order_inner[0]>0)
      {
	// inner_dof horizontal
	ndof += (order_inner[0]+1)*(3*(order_inner[0]-1)+(order_inner[0]-2)*(order_inner[0]-1));
	// inner dof vertical
	ndof += (order_inner[0]-1)*(order_inner[0]+1)*(order_inner[0]+2)/2;
      }
    //(*testout)<<"Prismen ndof = "<<ndof<<endl;
    order = 0; // max(order_edges_tang,order_inner);
    for(int i=0; i<5; i++)
      for(int l=0;l<2;l++)
	if (order_face[i][l] > order)
	  order = order_face[i][l];
    for(int l=0;l<3;l++)
      {
	if (order_inner[l] > order)
	  order = order_inner[l];
	if (order_inner_curl[l] > order)
	  order = order_inner[l];
      }
    order++;
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderPrismSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip, FlatMatrixFixWidth<3> shape) const
  {
    AutoDiff<3> x (ip(0), 0);
    AutoDiff<3> y (ip(1), 1);
    AutoDiff<3> z (ip(2), 0);
    AutoDiff<3> lami[6] = { x, y, 1-x-y, x, y, 1-x-y };
    AutoDiff<3> muz[6]  = { 1-z, 1-z, 1-z, z, z, z };
   
    shape = 0.0;

    const FACE * faces = ElementTopology::GetFaces (ET_PRISM);
   
    ArrayMem<AutoDiff<3>,20> adpolxy1(order+1), adpolxy2(order+1), adpolx(order+1), adpoly(order+1);
    ArrayMem<AutoDiff<3>,20> adpolz(order+1);

    int ii = 5;

    // trig-faces 
    for (int i = 0; i < 2; i++)
      {
	int p = order_face[i][0];
        int fac = 1;
        int fav[3] = {faces[i][0], faces[i][1], faces[i][2]};

	
	// each svap of vertices swaps normal direction by 180°
	if(vnums[fav[0]] > vnums[fav[1]]) { swap(fav[0],fav[1]); fac *= -1;}
	if(vnums[fav[1]] > vnums[fav[2]]) { swap(fav[1],fav[2]); fac *= -1;}
	if(vnums[fav[0]] > vnums[fav[1]]) { swap(fav[0],fav[1]); fac *= -1;}

	// RT0
	shape(i,2) = fac*muz[fav[0]].Value()*muz[fav[0]].DValue(2);
	
	AutoDiff<3> xi = lami[fav[2]]-lami[fav[1]];
	AutoDiff<3> eta = lami[fav[0]]; 

	T_TRIGFACESHAPES::CalcSplitted(p+2,xi,eta,adpolxy1,adpolxy2);

	// curl-fields 2 grad u x grad v
	for (int j = 0; j <= p-1; j++)
	  for (int k = 0; k <= p-1-j; k++)
	    {
	      // SZ Attention wo gehort das muz dazu? adpolxy1/2? 
	      AutoDiff<3> hd = 2* GradCrossGradSZ(adpolxy2[k],adpolxy1[j]*muz[fav[2]]); 
	      for (int l = 0; l < 3; l++)
		shape(ii,l) = hd.DValue(l); 
	      ii++;
	    }	

	//  curl(Ned0*adpolxy2[j]*muz) 
	for (int j = 0; j <= p-1; j++,ii++)
	  {
	    AutoDiff<3> hd = 
	       GradCrossGradSZ(lami[fav[1]]*adpolxy2[j]*muz[fav[2]],lami[fav[2]])
	      -  GradCrossGradSZ(lami[fav[2]]*adpolxy2[j]*muz[fav[2]],lami[fav[1]]); 
	    
	    for (int l = 0; l < 3; l++)
	      shape(ii,l) = hd.DValue(l); 
	  }
      } 
    
    // quad faces 
    for ( int i = 2; i < 5; i++)
      {
	INT<2> p = order_face[i]; 
	int fmax = 0;
       
	// each swap swaps normal direction by -1 
	for (int j = 1; j < 4; j++)
	  if (vnums[faces[i][j]] > vnums[faces[i][fmax]]) {fmax = j;} 
	
	int fz = 3-fmax;
	int ftrig = fmax^1;
	AutoDiff<3> xi = lami[faces[i][fmax]]-lami[faces[i][ftrig]]; 
	AutoDiff<3> eta = 1-lami[faces[i][fmax]]-lami[faces[i][ftrig]]; 
	AutoDiff<3> zeta = muz[faces[i][fmax]]-muz[faces[i][fz]]; 

	T_ORTHOPOL::CalcTrigExt(order+1,xi,eta,adpolxy1);
	T_ORTHOPOL::Calc(order+1,zeta,adpolz);

	int hf1 = faces[i][(fmax+3)%4];
	int hf2 = faces[i][(fmax+1)%4];

	double fac=1; 
	if (vnums[hf1] > vnums[hf2]) //SZ org: <
	  fac = -1; 

	double sign=-1; 
	if (vnums[hf1] > vnums[hf2]) //SZ org: <
	  sign = 1; 

    	//RT low order shape function 
		
	// lami_1 * Curl(lami_0) - lami_0 * Curl(lami_1) 
	// 1,0 always on trig-side 
	// has right direction and then mult by sign (swaps)  
	shape(i,0) = fac *
	  (lami[faces[i][1]].Value()*lami[faces[i][0]].DValue(1) -
	   lami[faces[i][0]].Value()*lami[faces[i][1]].DValue(1)); 
	shape(i,1) = - fac *
	  (lami[faces[i][1]].Value()*lami[faces[i][0]].DValue(0) -
	   lami[faces[i][0]].Value()*lami[faces[i][1]].DValue(0)); 
	
	// --> 2* grad(polz) * grad(polxy1) 
	if(vnums[faces[i][ftrig]] > vnums[faces[i][fz]]) 
	  { 
	    for (int k = 0; k <= p[0]-1; k++)
	      for (int j = 0; j <= p[1]-1; j++,ii++)
		{
		  // why in hcurlho no if/else? 
		  AutoDiff<3> hd = 2* GradCrossGradSZ(adpolz[j],adpolxy1[k]);
		  for (int l=0; l<3;l++) 
		    shape(ii,l) = hd.DValue(l); 
		}
	  } 
	else 
	  { 
	    for (int j = 0; j <= p[0]-1; j++)
	      for (int k = 0; k <= p[1]-1; k++,ii++)
		{
		  AutoDiff<3> hd = - 2* GradCrossGradSZ(adpolz[j],adpolxy1[k]);
		  for (int l=0; l<3;l++) 
		    shape(ii,l) = hd.DValue(l); 
		}
	  } 


	if(vnums[faces[i][ftrig]] > vnums[faces[i][fz]]) 
	  {
	    for( int j=0;j<=p[0]-1;j++, ii++)
	      {  
		AutoDiff<3> hd =  GradCrossGradSZ(adpolxy1[j],zeta);
		for( int l=0; l<3; l++)
		  shape(ii,l) = hd.DValue(l);  
	      }
	    for(int j=0;j<=p[1]-1;j++, ii++) 
	      {
		AutoDiff<3> hd = 
		   GradCrossGradSZ(lami[faces[i][ftrig]]*adpolz[j],lami[faces[i][fmax]])
		  - GradCrossGradSZ(lami[faces[i][fmax]]*adpolz[j],lami[faces[i][ftrig]]); 
		for( int l=0; l<3; l++)
		  shape(ii,l) = hd.DValue(l);
	      } 
	  }
	else 
	  {
	    for(int j=0;j<=p[0]-1;j++, ii++) 
	      {
		AutoDiff<3> hd = 
		   GradCrossGradSZ(lami[faces[i][ftrig]]*adpolz[j],lami[faces[i][fmax]])
		  - GradCrossGradSZ(lami[faces[i][fmax]]*adpolz[j],lami[faces[i][ftrig]]); 
		for( int l=0; l<3; l++)
		  shape(ii,l) = hd.DValue(l);
	      } 
	    for( int j=0;j<=p[1]-1;j++, ii++)
	      {  
		AutoDiff<3> hd =  GradCrossGradSZ(adpolxy1[j],zeta);
		for( int l=0; l<3; l++)
		  shape(ii,l) = hd.DValue(l);  
	      } 
	  }
      }

    INT<3> p = order_inner;
    INT<3> pc = order_inner_curl; 

    T_TRIGFACESHAPES::CalcSplitted(order+1,x-y,1-x-y,adpolxy1,adpolxy2);
    T_ORTHOPOL::Calc(order+1,2*z-1,adpolz); 


    // SZ: Check if bounds for indices are sensefull ... 
    // SZ: up to now use the ones from old hdivho 
    for(int i=0;i<=pc[0]-2;i++)
      for(int j=0;j<=pc[0]-2-i;j++)
	for(int k=0;k<=pc[2];k++,ii++)
	  {
	    AutoDiff<3> hd = 2* GradCrossGradSZ(adpolxy2[j],adpolxy1[i]*adpolz[k]); 
	    for(int l=0;l<3;l++)
	      shape(ii,l) = hd.DValue(l); 
	    ii++; 
	    hd = 2* GradCrossGradSZ(adpolz[k],adpolxy1[i]*adpolxy2[j]); 
	    for(int l=0;l<3;l++)
	      shape(ii,l) = hd.DValue(l); 
	  }
    
    // Type 3
    // ned0(trig) * polxy2[j]*polz 
    // z.DValue(0) * polxy1[i] * polxy2[j] 
    double ned0trig[3] = {y.Value(),-x.Value(),0.};  
    double curlned[3] = {0.,0.,-2.};
    
    for(int j=0;j<=pc[0]-2;j++) 
      for ( int k=0;k<=pc[2];k++,ii++)
	{
	  AutoDiff<3> hd = 
	     GradCrossGradSZ(adpolz[k]*adpolxy2[j]*y, x) 
	    -  GradCrossGradSZ(adpolz[k]*adpolxy2[j]*x, y);  
	  
	      for( int l=0;l<3;l++) 
		shape(ii,l) = hd.DValue(l); 
	}
    
    for(int i=0;i<=pc[0]-2;i++) 
      for(int j=0;j<=pc[0]-2-i;j++,ii++) 
	{
	  AutoDiff<3> hd =  GradCrossGradSZ(adpolxy1[i]*adpolxy2[j],z); 
	  
	  for(int l=0;l<3;l++)
	    shape(ii,l) = hd.DValue(l); 
	} 

     // SZ: Check if bounds for indices are sensefull ... 
    // SZ: up to now use the ones from old hdivho 
    // non-div-free 
    for(int i=0;i<=pc[0]-2;i++)
      for(int j=0;j<=pc[0]-2-i;j++)
	{
	  AutoDiff<3> hd = 2* GradCrossGradSZ(adpolxy1[i],adpolxy2[j]);
	  for(int k=0;k<=pc[2];k++,ii++)
	    for(int l=0;l<3;l++)
	      shape(ii,l) = hd.DValue(l)*adpolz[k].Value(); 
	}
    
    
    // \ned0 x nabla(vj) w_k 
    for(int j=0;j<=pc[0]-2;j++)
      {
	AutoDiff<3> hd1 =  GradCrossGradSZ(x,adpolxy2[j]); 
	AutoDiff<3> hd2 =  GradCrossGradSZ(y,adpolxy2[j]); 
	for(int k=0;k<=pc[0];k++,ii++)
 	  for(int l=0;l<3;l++)
	    shape(ii,l) = (y.Value()*hd1.DValue(l) - 
			   hd2.DValue(l)*x.Value())* adpolz[k].Value(); 
      }
    
    // wk ez 
    for(int k=0;k<=pc[0];k++,ii++)
      shape(ii,2) = adpolz[k].Value(); 
    
    // ned x ez vj 
    double nedxez[3] = {-x.Value(),-y.Value(),0}; 
    for(int j=0;j<=pc[0]-2;j++)
      for(int l=0;l<2;l++)
	shape(ii,l) =  adpolxy2[j].Value() * nedxez[l];
    
    //(*testout)<<" Prismen ii = "<<ii<<endl;
    return;


  }

  //------------------------------------------------------------------------
  // HDivHighOrderHexSZ
  //------------------------------------------------------------------------

  template <class T_ORTHOPOL>
  HDivHighOrderHexSZ<T_ORTHOPOL> :: HDivHighOrderHexSZ (int aorder)
    : HDivHighOrderFiniteElementSZ<3>(ET_HEX)
  {
    order_inner_curl = INT<3>(aorder,aorder,aorder);
    order_inner = order_inner_curl; 
    
    for (int i=0; i<6; i++)
      order_face[i] = INT<2> (aorder,aorder);
    ComputeNDof(); 
    discont = 0; 
  }
    
  template <class T_ORTHOPOL>
  void HDivHighOrderHexSZ<T_ORTHOPOL> :: ComputeNDof()
  {
    ndof = 6; // RT_0
        
    for (int i = 0; i < 6; i++)
      ndof += order_face[i][0]*(order_face[i][1]+1) + order_face[i][1]; 
    
    INT<3> pc = order_inner_curl; 
    INT<3> p = order_inner; 

    ndof += 2*pc[0]*pc[1]*pc[2] + pc[0]*pc[1] + pc[1]*pc[2] + pc[0]* pc[2]; 
    ndof += p[0]*(p[1]*p[2] + p[1] + p[2] + 1)  + p[1]*p[2] + p[1] + p[2]; 
    
    order = 0; // max(order_face_normal,order_inner);
    for (int i = 0; i < 6; i++)
      for( int l=0;l<2;l++)
	if (order_face[i][l] > order)
	  order = order_face[i][l];
    
    for(int l=0;l<3;l++)
      if (p[l] > order) order = p[l];
    for(int l=0;l<3;l++)
      if (pc[l] > order) order = pc[l];
    
    order++; // integration order
  }

  template <class T_ORTHOPOL>
  void HDivHighOrderHexSZ<T_ORTHOPOL> ::  GetInternalDofs (ARRAY<int> & idofs) const
  {
    // ComputeNDof(); 
    idofs.SetSize (0);
    
    int first_in = 6;  
    if (discont == 1) 
      first_in = 0; 
    
    if (!discont) 
      for (int i = 0; i < 6; i++)
	first_in += order_face[i][0]*(order_face[i][1]+1) + order_face[i][1]; ;
    
    for (int i = first_in; i < ndof; i++)
      idofs.Append (i);
  }

 
  template <class T_ORTHOPOL> 
  void HDivHighOrderHexSZ<T_ORTHOPOL> :: CalcShape (const IntegrationPoint & ip, 
				       FlatMatrixFixWidth<3> shape) const
  {    // MatrixFixWidth<3> shape2(shape.Height()); 
    // HCurlHighOrderFiniteElement<3> :: CalcCurlShape(ip,shape2); 
    
    int i, j, k, l;
    AutoDiff<3> x (ip(0),0);
    AutoDiff<3> y (ip(1),1);
    AutoDiff<3> z (ip(2),2); 
    
    AutoDiff<3> lami[8]={(1-x)*(1-y)*(1-z),x*(1-y)*(1-z),x*y*(1-z),(1-x)*y*(1-z),
			 (1-x)*(1-y)*z,x*(1-y)*z,x*y*z,(1-x)*y*z}; 
    AutoDiff<3> sigma[8]={(1-x)+(1-y)+(1-z),x+(1-y)+(1-z),x+y+(1-z),(1-x)+y+(1-z),
			  (1-x)+(1-y)+z,x+(1-y)+z,x+y+z,(1-x)+y+z}; 
    shape = 0.0;
       
    ArrayMem<AutoDiff<3>, 20> pol_xi(order+2),pol_eta(order+2),pol_zeta(order+2);
    ArrayMem<AutoDiff<3>, 20> pol_lfxi(order+2),pol_lfeta(order+2);
   
    int ii = 6; // rt0
    const FACE * faces = ElementTopology::GetFaces (ET_HEX);
    for (i = 0; i<6; i++)
      {
	INT<2> p = order_face[i];
	AutoDiff<3> lam_f = lami[faces[i][0]]+lami[faces[i][1]]+lami[faces[i][2]]+lami[faces[i][3]];
;	
	int qmax = 0;
	for (j = 1; j < 4; j++)
	  if (vnums[faces[i][j]] > vnums[faces[i][qmax]])
	    qmax = j;
	
	int q1 = (qmax+3)%4; 
	int q2 = (qmax+1)%4; 
       
	double fac; 
	if(vnums[faces[i][q2]] > vnums[faces[i][q1]])
	  { 
	    swap(q1,q2);  // fmax > f1 > f2
	    fac *= -1; 
	  }
	
	for(l=0;l<3;l++)
	  shape(i,l) = fac * lam_f.DValue(l) * lam_f.Value(); 

	// horiz = 1 if sigma_{fmax}-sigma_{f1} is horizontal coordinate 
	// for anisotropic meshes (vertical(esp. z) is the longer one) 
	double horiz=1.; 
	if( (qmax & 2) == (q2 & 2)) 
	  horiz = -1.; 
		
	int fmax = faces[i][qmax]; 
	int f1 = faces[i][q1]; 
	int f2 = faces[i][q2]; 
	      
	AutoDiff<3> xi = sigma[fmax]-sigma[f1]; 
	AutoDiff<3> eta = sigma[fmax]-sigma[f2]; 
    
	T_ORTHOPOL::Calc(p[0]+1, xi,pol_xi);
	T_ORTHOPOL::Calc(p[1]+1, eta,pol_eta);
	
	for (j = 0; j < p[0]; j++)
	  pol_lfxi[j] = lam_f*pol_xi[j];
	for (j = 0; j < p[1]; j++)
	  pol_lfeta[j] = lam_f*pol_eta[j];
	
	if (horiz == 1)
	  {	
	    for (k = 0; k < p[0]; k++)
	      for (j= 0; j < p[1]; j++, ii++)
		{
		  AutoDiff<3> hd = 2.0 *  GradCrossGradSZ (pol_eta[j], pol_lfxi[k]);
		  for(l=0; l<3; l++) shape(ii,l) = hd.DValue(l);
		}
	  }
	else
	  {
	    for (k = 0; k < p[0]; k++)
	      for (j= 0; j < p[1]; j++, ii++)
		{
		  AutoDiff<3> hd = 2.0 *  GradCrossGradSZ (pol_lfeta[j], pol_xi[k]);
		  for(l=0; l<3; l++) shape(ii,l) = hd.DValue(l);
		}
	  }

	//Missing ones 
	for (j= 0; j < p[0]; j++, ii++)
	  {
	    AutoDiff<3> hd = 0.5 *  GradCrossGradSZ(pol_lfxi[j],eta);
	    for(l=0; l<3; l++)
	      shape(ii,l) = hd.DValue(l);  
	  }
	for(j=0;j<p[1];j++, ii++)
	  {
	    AutoDiff<3> hd = 0.5 *  GradCrossGradSZ (pol_lfeta[j], xi);
	    for(l=0; l<3; l++)
	      shape(ii,l) = hd.DValue(l);
	  }
      }
        
    // Element-based shapes
        
    T_ORTHOPOL::Calc(order+1,2*x-1,pol_xi);
    T_ORTHOPOL::Calc(order+1,2*y-1,pol_eta);
    T_ORTHOPOL::Calc(order+1,2*z-1,pol_zeta); 

    
    INT<3> pc = order_inner_curl;
    INT<3> p = order_inner; 
    // Curl-Fields of Type 2
    for (i=0; i<order_inner_curl[0]; i++)
      for(j=0; j<order_inner_curl[1]; j++) 
	for(k=0; k<order_inner_curl[2]; k++,ii++)	  
	    {
	      AutoDiff<3> uw = pol_xi[i]*pol_zeta[k]; 
	      AutoDiff<3> hd = 2*  GradCrossGradSZ(pol_eta[j],uw); 
	     
	      for (l=0; l<3; l++) shape(ii,l)=hd.DValue(l); 

	      AutoDiff<3> uv = pol_xi[i]*pol_eta[j]; 
	      hd = 2*  GradCrossGradSZ(pol_zeta[k],uv); 
	      ii++;
	      for (l=0; l<3; l++) shape(ii,l)=hd.DValue(l); 
	      
	    } 
    
    // Curl-Fields of Type 3  
    for(i=0;i<order_inner_curl[0];i++)
      for(j=0;j<order_inner_curl[1];j++)
	{
	  AutoDiff<3> uv = pol_xi[i]*pol_eta[j]; 
	  AutoDiff<3> hd =  GradCrossGradSZ(uv,z); 
	  for (l=0; l<3; l++) shape(ii,l)=hd.DValue(l);
	  ii++;
	}
    for(i=0;i<order_inner_curl[0];i++)
      for(k=0;k<order_inner_curl[2];k++)
	{
	  AutoDiff<3> uw = pol_xi[i]*pol_zeta[k]; 
	  AutoDiff<3> hd =  GradCrossGradSZ(uw,y); 
	  for (l=0; l<3; l++) shape(ii,l)=hd.DValue(l); 
	  ii++; 
	}
    for(j=0;j<order_inner_curl[1];j++)
      for(k=0;k<order_inner_curl[2];k++)
	{
	  AutoDiff<3> vw = pol_eta[j]*pol_zeta[k]; 
	  AutoDiff<3> hd =  GradCrossGradSZ(vw,x); 
	  for (l=0; l<3; l++) shape(ii,l)=hd.DValue(l); 
	  ii++; 
	}

    // Non-Div-Free 
    for (i=0; i<order_inner[0]; i++)
      {
	shape(ii++,0) = pol_xi[i].Value();
	for(j=0; j<order_inner[1]; j++)
	  {
	    shape(ii,1) = pol_xi[i].DValue(0)*pol_eta[j].Value(); 
	    shape(ii++,0) = pol_xi[i].Value()*pol_eta[j].DValue(1); 
	    for(k=0; k<order_inner[2]; k++,ii++)
	      {
		shape(ii,0) = pol_xi[i].Value()*pol_eta[j].DValue(1)*pol_zeta[k].DValue(2); 
		shape(ii,1) = pol_xi[i].DValue(0)*pol_eta[j].Value()*pol_zeta[k].DValue(2); 
	      }
	  }
      }
    
    for(j=0; j<order_inner[1]; j++)
      {
	shape(ii++,1) = pol_eta[j].Value();
	for(k=0; k<order_inner[2]; k++,ii++)
	  {
	    shape(ii,1) = pol_eta[j].Value()*pol_zeta[k].DValue(2); 
	    shape(ii,2) = pol_eta[j].DValue(1)*pol_zeta[k].Value();
	  }
      }
   
    for(k=0; k<order_inner[2]; k++)
      {
	shape(ii++,2) = pol_eta[k].Value();
	for(i=0; i<order_inner[0]; i++, ii++) 
	  {
	    shape(ii,0) = pol_xi[i].Value()*pol_zeta[k].DValue(2); 
	    shape(ii,2) = pol_eta[i].DValue(0)*pol_zeta[k].Value();
	  }
      }
     
    /* (*testout) << " CURL SHAPE HEX " << endl; 
      (*testout) << " curlshape code  " << endl << shape << endl ;  
      (*testout) << " curlshape num " << endl << shape2 << endl; 
      shape2 -= shape;  
      (*testout) << " curlshape diff " << endl << shape2 << endl; 
    */
    return; 
  }
 
 template <class T_ORTHOPOL> 
  void HDivHighOrderHexSZ<T_ORTHOPOL> :: CalcDivShape (const IntegrationPoint & ip, 
				       FlatVector<> shape) const
  {
    // MatrixFixWidth<3> shape2(shape.Height()); 
    // HCurlHighOrderFiniteElement<3> :: CalcCurlShape(ip,shape2); 
    
    int i, j, k, l;
    AutoDiff<3> x (ip(0),0);
    AutoDiff<3> y (ip(1),1);
    AutoDiff<3> z (ip(2),2); 
    
    AutoDiff<3> lami[8]={(1-x)*(1-y)*(1-z),x*(1-y)*(1-z),x*y*(1-z),(1-x)*y*(1-z),
			 (1-x)*(1-y)*z,x*(1-y)*z,x*y*z,(1-x)*y*z}; 
    AutoDiff<3> sigma[8]={(1-x)+(1-y)+(1-z),x+(1-y)+(1-z),x+y+(1-z),(1-x)+y+(1-z),
			  (1-x)+(1-y)+z,x+(1-y)+z,x+y+z,(1-x)+y+z}; 
    shape = 0.0;
       
    ArrayMem<AutoDiff<3>, 20> pol_xi(order+2),pol_eta(order+2),pol_zeta(order+2);
    ArrayMem<AutoDiff<3>, 20> pol_lfxi(order+2),pol_lfeta(order+2);
   
    int ii = 6; 
    const FACE * faces = ElementTopology::GetFaces (ET_HEX);
    for (i = 0; i<6; i++)
      {
	INT<2> p = order_face[i];
	ii += p[0]*p[1] + p[0] + p[1]; 
      }
    // Element-based shapes
        
    T_ORTHOPOL::Calc(order+1,2*x-1,pol_xi);
    T_ORTHOPOL::Calc(order+1,2*y-1,pol_eta);
    T_ORTHOPOL::Calc(order+1,2*z-1,pol_zeta); 
    
    INT<3> pc = order_inner_curl;
    INT<3> p = order_inner; 
   
    ii+= pc[0]*pc[1]*pc[2]+pc[0]*pc[1]+ pc[1]*pc[2] + pc[0]*pc[2]; 

   // Non-Div-Free 
    for (i=0; i<order_inner[0]; i++)
      {
	shape(ii++) = pol_xi[i].DValue(0);
	for(j=0; j<order_inner[1]; j++)
	  {
	    shape(ii++) = pol_xi[i].DValue(0)*pol_eta[j].DValue(1); 
	    for(k=0; k<order_inner[2]; k++)
	      shape(ii++) = pol_xi[i].DValue(0)*pol_eta[j].DValue(1)*pol_zeta[k].DValue(2); 
	  }
      }
    
    for(j=0; j<order_inner[1]; j++)
      {
	shape(ii++) = pol_eta[j].DValue(1);
	for(k=0; k<order_inner[2]; k++)
	  shape(ii++) = pol_eta[j].DValue(1)*pol_zeta[k].DValue(2); 
      }
   
    for(k=0; k<order_inner[2]; k++)
      {
	shape(ii++) = pol_zeta[k].DValue(2);
	for(i=0; i<order_inner[0]; i++) 
	  shape(ii++) = pol_xi[i].DValue(0)*pol_zeta[k].DValue(2); 
      }
    
    return; 
  }

  template class HDivHighOrderHexSZ<IntegratedLegendreMonomialExt>;
  //  template class HDivHighOrderHexSZ<TrigExtensionMonomial>;
  //  template class HDivHighOrderHexSZ<TrigExtensionOptimal>;
  // template class HDivHighOrderHexSZ<TrigExtensionMin>;

  template class HDivHighOrderTetSZ<IntegratedLegendreMonomialExt>;
  // template class HDivHighOrderTetSZ<TrigExtensionMonomial>;
  //  template class HDivHighOrderTet<TrigExtensionOptimal>;
  // template class HDivHighOrderTetSZ<TrigExtensionMin>;

  template class HDivHighOrderPrismSZ<IntegratedLegendreMonomialExt>;
  // template class HDivHighOrderPrismSZ<TrigExtensionMonomial>;
  //  template class HDivHighOrderPrism<TrigExtensionOptimal>;
  // template class HDivHighOrderPrismSZ<TrigExtensionMin>;

  template class  HDivHighOrderFiniteElementSZ<2>;
  template class  HDivHighOrderFiniteElementSZ<3>;
  template class  HDivHighOrderNormalFiniteElementSZ<1>;
  template class  HDivHighOrderNormalFiniteElementSZ<2>;
}



