
#ifndef FILE_HDIVHOFESPACE_EE

#define FILE_HDIVHOFESPACE_EE

/*********************************************************************/
/* File:   hdivhofespace_ee.hpp                                         */
/* Author: Sabine Zaglmayr                                           */
/* Date:   1. March 2007                                             */
/*********************************************************************/

/**
   HDiv High Order Finite Element Space
*/

//#include <comp.hpp>
#include "hdivhofespacesz.hpp" 

namespace ngcomp
{
 

class HDivHighOrderFESpaceEE : public HDivHighOrderFESpaceSZ 
{
protected:
  int trig_relorder; 
  int quad_relorder; 
  int trig_order; 
  int quad_order; 
   
public:

  HDivHighOrderFESpaceEE (const MeshAccess & ama, const Flags & flags);
  ///
  virtual ~HDivHighOrderFESpaceEE ();

  static FESpace * Create (const MeshAccess & ma, const Flags & flags);

  virtual void Update(); 

  virtual string GetClassName () const
  {
    return "HDivHighOrderFESpaceEE";
  }
  
};
}
#endif





