#ifndef FILE_L2HOFESPACE_EE
#define FILE_L2HOFESPACE_EE 

/*********************************************************************/
/* File:   l2hofespace_ee.hpp                                           */
/* Author: SZ                                                     */
/* Date:   1.März 2007 
/*********************************************************************/
  
/**
   High Order Finite Element Space for L2 (element by element)
   with quad and trig order for EE 
*/

using namespace ngmg;

namespace ngcomp
{
  using namespace ngcomp;

class L2HighOrderFESpaceEE : public L2HighOrderFESpace
{
protected:
  
  int quad_relorder; 
  int quad_order; 
  int trig_relorder; 
  int trig_order; 
  
public:

  L2HighOrderFESpaceEE (const MeshAccess & ama, const Flags & flags, bool parseflags=false);
  ///
  virtual ~L2HighOrderFESpaceEE ();

  static FESpace * Create (const MeshAccess & ma, const Flags & flags)
  {
    return new L2HighOrderFESpaceEE (ma, flags, true);
  };

  virtual string GetClassName () const
  {
    return "L2HighOrderFESpaceEE";
  }

  ///
  virtual void Update();
 
};

}

#endif

