# Extends Demo-File dd5_harmonBVP_circ.pde using Perfectly Matched Layers 
# as non-reflecting boundary condition (instead of 
# instead of first order Absorbing BC's).  
# There are two variants for choosing PML-domain:  
# rectangular or circular. This demo for CIRCULAR PML.   

geometry = ngsolve/piezo_sabine/demo_pml/4elecs_circ_pml.in2d
mesh = ngsolve/piezo_sabine/demo_pml/4elecs_circ_pml.vol



# geometry order (curved elements) equal to element order 
define constant geometryorder = 4

# Solve button -> p-refinement  (default h-refinement)
define constant refinep = 1 


# Two parameters for the circular PML domain 
# (artificial domain starting at radius pml_r and 
#  pml_alpha rules magnitude of damping in artificial layer) 
define constant pml_alpha = .1
define constant pml_r = 1.5e-5


# HP-Refinement-Levels towards predefined points/edges
#define constant hpref = 1


#define coefficient matnr 
#0,1,1,1,1,0, 

#define coefficient matnr1 material
#elec1 (1),
#elec2 (1), 
#default (0) 

define coefficient matnr 
0,1,-1,1,-1, 5

define coefficient matnr1 material
elec1 (1),
elec2 (-1), 
pml (5),
default (0) 

define coefficient one
1,1,1,1,1,1,1, 

define fespace fes -type=h1ho 
define gridfunction ut1 -fespace=fes 
define gridfunction ut2 -fespace=fes 
define bilinearform at -fespace=fes
mass one
define linearform ft1 -fespace=fes
source matnr 
define linearform ft2 -fespace=fes
source matnr1
 
numproc bvp nptest1 -bilinearform=at -solver=direct -linearform=ft1 -gridfunction=ut1 
numproc bvp nptest2  -bilinearform=at -solver=direct -gridfunction=ut2 -linearform=ft2 

