geometry = coil_plate_prism2.geo
mesh = coil_plate_prism2.vol

define constant geometryorder = 2
define constant heapsize = 100000000

define constant I = (2742 / 0.0025 )

define coefficient nu material
	default (1.0 / 1.247E-6)

define coefficient sigma material
	alu (3.526E7 * 6.2830 * 50)
	default 0

define coefficient reg material
	default 4

define coefficient cs1
(I*(y)/sqrt(y*y+x*x)), 0, 0,0,0,0,

define coefficient cs2
(-I*x/sqrt(y*y+x*x)), 0,0,0,0,0,0,

define coefficient cs3
0, 0, 0,0,0,0,0, 


define fespace v -hcurlho -order=4 -complex -eliminate_internal  -gradientdomains=[0,0,1,0,0] 
define fespace vr -hcurlho -order=4  -eliminate_internal  -gradientdomains=[0,0,1,0,0] -eliminate_internal

define gridfunction u -fespace=v -eliminate_internal

define linearform f -fespace=v 
sourceedge cs1 cs2 cs3

define linearform fr -fespace=vr 
sourceedge cs1 cs2 cs3

define bilinearform a -fespace=v -symmetric -eliminate_internal -linearform=f 
curlcurledge nu 
massedge sigma -imag -definedon=3
massedge reg -imag 

define bilinearform ar -fespace=vr -symmetric -eliminate_internal -linearform=fr 
curlcurledge nu 
massedge sigma -definedon=3
massedge reg 

define bilinearform acurl -fespace=v -symmetric -nonassemble
curlcurledge nu 



define bilinearform aeddy -fespace=v -symmetric -nonassemble
massedge sigma



define preconditioner cr -type=multigrid -bilinearform=ar -cylce=1 -smoother=block -coarsetype=direct -coarsesmoothingsteps=5 -test
define preconditioner c -type=complex -realpreconditioner=cr
# define preconditioner c -type=direct -bilinearform=a


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=150 -prec=1.e-6


numproc drawflux np5 -bilinearform=acurl -solution=u  -label=flux
numproc drawflux np6 -bilinearform=aeddy -solution=u  -label=eddy -applyd
