algebraic3d

solid tank = orthobrick (0, 0, 0; 3, 1, 2) -bc=1;

solid upperyoke = orthobrick (0.7, 0.4, 1.5; 2.3, 0.6, 1.72) -bc=2;
solid loweryoke = orthobrick (0.7, 0.4, 0.28; 2.3, 0.6, 0.5) -bc=2;
solid core_top = plane(0, 0, 1.7; 0, 0, 1) -bc=2;
solid core_bottom = plane(0, 0, 0.3; 0, 0, -1) -bc=2;
solid core_front = plane(0, 0.6, 0; 0, 1, 0) -bc=2;
solid core_back = plane(0, 0.4, 0; 0, -1, 0) -bc=2;

solid limb1 = core_front and core_back and
      plane (0.770711, 0.570711, 0; 1, 1, 0) and
      plane (0.770711, 0.429289, 0; 1, -1, 0) and
      plane (0.629289, 0.570711, 0; -1, 1, 0) and
      plane (0.629289, 0.429289, 0; -1, -1, 0) and
      plane (0.6, 0, 0; -1,0,0) and
      plane (0.8, 0, 0; 1,0,0);

solid limb2 = core_front and core_back and
      plane (1.57071, 0.570711, 0; 1, 1, 0) and
      plane (1.57071, 0.429289, 0; 1, -1, 0) and
      plane (1.42929, 0.570711, 0; -1, 1, 0) and
      plane (1.42929, 0.429289, 0; -1, -1, 0) and
      plane (1.4, 0, 0; -1,0,0) and
      plane (1.6, 0, 0; 1,0,0);

solid limb3 = core_front and core_back and
      plane (2.37071, 0.570711, 0; 1, 1, 0) and
      plane (2.37071, 0.429289, 0; 1, -1, 0) and
      plane (2.22929, 0.570711, 0; -1, 1, 0) and
      plane (2.22929, 0.429289, 0; -1, -1, 0) and
      plane (2.2, 0, 0; -1,0,0) and
      plane (2.4, 0, 0; 1,0,0);

solid core = (loweryoke or upperyoke or limb1 or limb2 or limb3) and core_top and core_bottom;

solid testcylo1 = cylinder (0.7, 0.5, 0.895; 0.7, 0.5, 0.905; 0.255) -bc=5 -maxh=0.0565685;
solid testcyli1 = cylinder (0.7, 0.5, 0.895; 0.7, 0.5, 0.905; 0.245) -bc=5 -maxh=0.0565685;
solid testplanetop1 = plane (0, 0, 0.905; 0, 0, 1) -bc=5;
solid testplanebottom1 = plane (0, 0, 0.895; 0, 0, -1) -bc=5;
solid testwire1 = testcylo1 and not testcyli1 and testplanetop1 and testplanebottom1;

#tlo testwire1 -material=wire1 -col=[0,1,0];

#singular face testcylo1 testcyli1; 
#singular face testwire1 testwire1;

solid cylo1 = cylinder (0.7, 0.5, 0.6; 0.7, 0.5, 1.4; 0.3) -bc=3 -maxh=0.178885;
solid cyli1 = cylinder (0.7, 0.5, 0.6; 0.7, 0.5, 1.4; 0.2) -bc=3 -maxh=0.178885;
solid coilplanetop1 = plane (0, 0, 1.4; 0, 0, 1) -bc=3;
solid coilplanebottom1 = plane (0, 0, 0.6; 0, 0, -1) -bc=3;
solid coilfull1 = cylo1 and not cyli1 and coilplanetop1 and coilplanebottom1;

solid coil1 = coilfull1 and not testwire1;
tlo coil1 -material=coil1 -col=[1,0,0];


#singular face cylo1 cyli1;
singular face cylo1 coilplanetop1;  


solid lfguide1 = orthobrick ( 0.6, 0.25, 0.45; 2.4, 0.4, 0.5) -bc=4;
solid lfguide2 = orthobrick ( 0.6, 0.25, 1.5; 2.4, 0.4, 1.55) -bc=4;
solid lfguide3 = orthobrick ( 0.6, 0.6, 0.45; 2.4, 0.75, 0.5) -bc=4;
solid lfguide4 = orthobrick ( 0.6, 0.6, 1.5; 2.4, 0.75, 1.55) -bc=4;

#tlo lfguide1 -material=lfguide -col=[1,1,0];
#tlo lfguide2 -material=lfguide -col=[1,1,0];
#tlo lfguide3 -material=lfguide -col=[1,1,0];
#tlo lfguide4 -material=lfguide -col=[1,1,0];

solid air = tank and not core and not testwire1 and not coilfull1 and not lfguide1 and not lfguide2 and not lfguide3 and not lfguide4;

#tlo core -material=core -col=[0,0,1];
#tlo air -material=air -transparent;

#boundarycondition lfguide1 lfguide1 4;
#boundarycondition lfguide2 lfguide2 4;
#boundarycondition lfguide3 lfguide3 4;
#boundarycondition lfguide4 lfguide4 4;

#boundarycondition core core 2;

