geometry = cyl.geo
mesh = cyl.vol

define constant heapsize = 10000000
define constant geometryorder = 4

define constant pen = 1e15

define coefficient lam
1, 

define coefficient rho
x*x*y*y*z,



define coefficient coef_source
1, 

define fespace v -order=4  -h1ho  -eliminate_internal #-fast

define gridfunction u -fespace=v 


define linearform f -fespace=v
source coef_source


define bilinearform a -fespace=v -symmetric   -linearform=f  -eliminate_internal 
#laplace lam
masstp lam
robin penalty




define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -notest -blocktype=3


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=150 -prec=1e-8

numproc visualization vis -scalarfunction=u -clipsolution=scalar -clipvec=[1,0,0] -clipdist=0.0 -subdivision=3