geometry = cube.geo
mesh = cubepyr.vol

define constant heapsize = 100000000

define coefficient eps
1,

define coefficient one
1, 1, 1, 1, 1, 1, 1, 1, 

define coefficient coeff_x 
(x*x*y*y*z*z), 

define coefficient coeff_y
(y),

define coefficient coeff_z
(y),

define fespace v -hcurlho -order=2
define fespace vw -h1ho -order=1
#define fespace vb -l2 -order=1 -dim=3
define gridfunction u -fespace=v
define gridfunction w -fespace=vw
define gridfunction us -fespace=v 

#define gridfunction b -fespace=vb

define bilinearform aw -fespace=vw
mass eps

define bilinearform a -fespace=v -printelmat -elmatev
#curlcurledge one
massedge eps 
#robinedge one 

#define bilinearform ad -fespace=v
#curlcurledge one


define linearform f -fespace=v
sourceedge coeff_x coeff_y coeff_z 
define linearform fw -fespace=vw
source coeff_x  

define preconditioner c -type=multigrid -bilinearform=a -cylce=1 -smoother=block -coarsetype=direct -coarsesmoothingsteps=5 define preconditioner cw -type=multigrid -bilinearform=aw -cylce=1 -smoother=block -coarsetype=direct -coarsesmoothingsteps=5 
#define preconditioner c -type=direct -bilinearform=a 
#define preconditioner cw -type=direct -bilinearform=aw 

numproc bvp  np1 -gridfunction=u -bilinearform=a -linearform=f -preconditioner=c 
numproc bvp  np2 -gridfunction=w -bilinearform=aw -linearform=fw  -preconditioner=cw 


#numproc shapetester  np2 -gridfunction=us -bilinearform=a -dof=1
#numproc drawflux npdraw -solution=u -bilinearform=ad -label=curl_u
#numproc calcflux np5 -bilinearform=ad -solution=u  -flux=b 

