##geometry = cube.geo
#mesh = cube.vol
geometry = fichera.geo
mesh = fichera.vol

define constant heapsize = 10000000
define constant geometryorder = 1

define constant pen = 1e15

define coefficient lam
1, 

define coefficient rho
10,

define coefficient penalty
(pen), (pen), (pen), (pen),(pen), (pen), (pen), (pen),

define coefficient coef_source
1, 

define fespace vfast -order=6 -h1ho  -eliminate_internal -fast
#define fespace vstd -order=6 -h1ho  -eliminate_internal 

define gridfunction ufast -fespace=vfast 
#define gridfunction ustd -fespace=vstd 


define linearform f -fespace=vfast
sourcetp coef_source


define bilinearform a -fespace=v -symmetric   -linearform=f  -eliminate_internal 
laplacetp lam
robin penalty


define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -blocktype=3

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=150 -prec=1e-8

numproc visualization vis -scalarfunction=u -clipsolution=scalar -clipvec=[1,0,0] -clipdist=0.0 -subdivision=5