geometry = cyl.geo
mesh = cyl.vol

define constant heapsize = 10000000
define constant geometryorder = 5


define coefficient lam
1

define coefficient pen
(1e15 ), (1e15 ), (1e15 ), 


define coefficient coef_source
1, 

define coefficient coef_source2
((x*x-1)*(y*y-1)*z), 

define fespace v -order=5  -h1ho  -eliminate_internal #-fastsz

define gridfunction u -fespace=v 



define linearform f -fespace=v
source coef_source2

define bilinearform m -fespace=v -symmetric  -linearform=f  -eliminate_internal 
#mass lam
mass lam
robin pen 

define preconditioner c -type=multigrid -bilinearform=m -smoothingsteps=1 -smoother=block -notest -blocktype=3

numproc bvp np1 -bilinearform=m -linearform=f -gridfunction=u -preconditioner=c -maxsteps=150 -prec=1e-8

numproc visualization vis -scalarfunction=u -clipsolution=scalar -clipvec=[1,0,0] -clipdist=0.0 -subdivision=3