#geometry = square.in2d
mesh = square_q2.vol

define constant heapsize = 100000000

define constant refinehp = 1 

define coefficient zero
0, 

define coefficient one 
1,

define coefficient src1 
(sin(x)*sin(y))

define coefficient src 
(x*x*y*y)

define fespace v -type=hdivho -order=0 -variableorder 
define fespace vsz -type=hdivhosz -order=0 -variableorder 

# the solution field ...
define gridfunction u -fespace=v 
define gridfunction usz -fespace=vsz 

define bilinearform a -fespace=v
divdivhdiv one 
masshdiv one 

define bilinearform asz -fespace=vsz
divdivhdiv one
masshdiv one 

define linearform f -fespace=v
sourcehdiv src1 src

define linearform fsz -fespace=vsz
sourcehdiv src1 src 

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -solver=direct
numproc bvp np1 -bilinearform=asz -linearform=fsz -gridfunction=usz -solver=direct

define fespace vl2 -type=l2  
define gridfunction diff -fespace=vl2

numproc difference np1 -bilinearform1=a -bilinearform2=asz  -solution1=u -solution2=usz -diff=diff

