#geometry = cube.geo
mesh = cube.vol

define constant heapsize = 100000000

#define constant refinehp = 1 

define coefficient zero
0, 

define coefficient one 
1,1,1,1, 

define coefficient src 
(sin(x)*sin(y))

#define coefficient src1 
#((x-0.5)),((y-0.5))

define fespace v -type=hdivho  -order=5 #-variableorder 
define fespace vsz -type=hdivhosz -order=5 # -orderfacet=1 -orderinner=2 #-variableorder 
define fespace vh1 -type=h1ho -order=5 -dim=3

# the solution field ...
define gridfunction u -fespace=v 
define gridfunction uh1 -fespace=vh1 
define gridfunction usz -fespace=vsz 
define gridfunction uszt -fespace=vsz 

define bilinearform a -fespace=v #-printelmat -elmatev -print
#divdivhdiv one 
masshdiv one 

define bilinearform ah1 -fespace=vh1 #-printelmat -elmatev -print
mass one -comp=0
#mass one -comp=1
#mass one -comp=2

define bilinearform asz -fespace=vsz #-printelmat -elmatev -print
#divdivhdiv one
masshdiv one 

define linearform f -fespace=v
sourcehdiv  src src src 
#sourcehdiv src1 src zero

define linearform fh1 -fespace=vh1
source  src -comp=1
source  src -comp=2
source  src -comp=3
 
define linearform fsz -fespace=vsz
sourcehdiv  src src src
#sourcehdiv one one one  
#sourcehdiv src1 src zero 

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -solver=direct
numproc bvp np2 -bilinearform=asz -linearform=fsz -gridfunction=usz -solver=direct
numproc bvp np3 -bilinearform=ah1 -linearform=fh1 -gridfunction=uh1 -solver=direct

define bilinearform an -fespace=v -noassemble
robinhdiv one 

define bilinearform ansz -fespace=vsz -noassemble
robinhdiv one 

numproc drawflux npdf1 -bilinearform=an -solution=u -label=un 
numproc drawflux npdf1 -bilinearform=ansz -solution=usz -label=unsz 

define fespace vl2 -type=l2  
define gridfunction diff -fespace=vl2

#numproc difference np6 -bilinearform1=a -bilinearform2=ah1  -solution1=u -solution2=uh1 -diff=diff
numproc difference np4 -bilinearform1=ah1 -bilinearform2=a  -solution1=uh1 -solution2=u -diff=diff

numproc difference np5 -bilinearform1=asz -bilinearform2=a -solution1=usz -solution2=u -diff=diff
#numproc difference np7 -bilinearform1=ah1 -bilinearform2=asz -solution1=uh1 -solution2=usz -diff=diff

#numproc shapetester  np8 -gridfunction=uszt -bilinearform=asz -dof=1
