#ifdef PARALLEL

#include <parallelngs.hpp>
#include <parallel.hpp>
#include "../parallel/parallelinterface.hpp"

namespace ngparallel
{

  using namespace ngparallel;
  using namespace netgen;

  ParallelMeshAccess :: ParallelMeshAccess ( const MeshAccess & ama )
    : ma( ama )
  {
   ;
  }


const int ParallelMeshAccess :: Glob2Loc_SurfEl (const int & locnum )
  { return netgen::NgPar_Glob2Loc_SurfEl ( locnum ); }

  const int ParallelMeshAccess :: Glob2Loc_VolEl (const int & locnum )
  { return netgen::NgPar_Glob2Loc_VolEl ( locnum ); }

  const int ParallelMeshAccess :: Glob2Loc_Segm (const int & locnum )
  { return netgen::NgPar_Glob2Loc_Segm ( locnum ); }

  const int ParallelMeshAccess ::Glob2Loc_Vert (const int & locnum )
  { return netgen::NgPar_Glob2Loc_Vert ( locnum ); }

  const int  ParallelMeshAccess ::GetDistantPNum ( const int & proc, const int & locpnum ) const
  {return netgen::NgPar_GetDistantPNum ( proc, locpnum ); }

  const int  ParallelMeshAccess ::GetDistantEdgeNum ( const int & proc, const int & locedgenum ) const
  { return netgen::NgPar_GetDistantEdgeNum ( proc, locedgenum ); }

  const int  ParallelMeshAccess ::GetDistantFaceNum ( const int & proc, const int & locfacenum ) const
  { return netgen::NgPar_GetDistantFaceNum ( proc, locfacenum ); }

  const int  ParallelMeshAccess ::GetDistantElNum ( const int & proc, const int & locelnum ) const
  { return netgen::NgPar_GetDistantElNum ( proc, locelnum ); }

  bool ParallelMeshAccess ::IsExchangeFace ( const int fnr ) const 
  { return netgen::NgPar_IsExchangeFace ( fnr ); }

  bool ParallelMeshAccess ::IsExchangeVert (const int vnum ) const 
  { return netgen::NgPar_IsExchangeVert ( vnum ); }

  bool ParallelMeshAccess ::IsExchangeEdge (const int ednum ) const
  { return netgen::NgPar_IsExchangeEdge ( ednum ); }

  void ParallelMeshAccess :: PrintParallelMeshTopology () const
  { netgen::NgPar_PrintParallelMeshTopology (); }

  bool ParallelMeshAccess :: IsElementInPartition ( const int elnum, const int dest ) const
  { return netgen::NgPar_IsElementInPartition ( elnum, dest ); }

  const int ParallelMeshAccess :: GetLoc2Glob_VolEl ( const int & locnum )
  { return NgPar_GetLoc2Glob_VolEl ( locnum ); }



  bool ParallelMeshAccess :: IsGhostFace ( const int facenum ) const
  { return NgPar_IsGhostFace ( facenum );}

  bool ParallelMeshAccess :: IsGhostEdge ( const int edgenum ) const
  {return NgPar_IsGhostEdge ( edgenum ); }
}


#endif
