#ifndef FILE_PARALLELTOP
#define FILE_PARALLELTOP

#ifdef PARALLEL


class ParallelMeshAccess
{
private :

  const MeshAccess & ma;

public : 

  ParallelMeshAccess ( const MeshAccess & ama );
  ~ParallelMeshAccess ()
  {
    ;
  }

  const int Glob2Loc_SurfEl (const int & locnum );

  const int Glob2Loc_VolEl (const int & locnum );

  const int Glob2Loc_Segm (const int & locnum );

  const int Glob2Loc_Vert (const int & locnum );

  const int GetLoc2Glob_VolEl ( const int & locnum );

  const int  GetDistantPNum ( const int & proc, const int & locpnum ) const;

  const int  GetDistantEdgeNum ( const int & proc, const int & locedgenum ) const;

  const int  GetDistantFaceNum ( const int & proc, const int & locfacenum ) const;

  const int  GetDistantElNum ( const int & proc, const int & locelnum ) const;

  bool IsExchangeFace ( const int fnr ) const ;

  bool IsExchangeVert (const int vnum ) const ;

  bool IsExchangeEdge (const int ednum ) const;

  void PrintParallelMeshTopology () const;

  bool IsElementInPartition ( const int elnum, const int dest ) const;

  bool IsGhostFace ( const int facenum ) const;

  bool IsGhostEdge ( const int edgenum ) const;
};





#endif //PARALLEL

#endif
