# geometry = examples/square.in2d
# mesh = examples/square.vol

geometry = ngusers/EMI/tool.geo
mesh = ngusers/EMI/tool2.vol


define constant nucore = 132.7
define constant nuhole = 796200
define constant nuwall = 7962
define constant nufound = 796200

# sigma = sigma_true * 2 * pi * f
define constant sigmacore = 0.314
define constant sigmahole = 31.4
define constant sigmawall = 314000
define constant sigmafound = 31.4

define coefficient nu
(nuhole), (nucore), (nucore), (nucore), (nuhole), (nuhole),
(nuhole), (nuhole), (nuhole), (nuhole), (nuhole), (nuhole), 
(nuhole), (nuhole), (nuhole), (nuhole), (nuhole), (nuhole), 
(nuwall), (nuwall), (nuwall), (nuwall), (nuwall), (nuwall),
(nufound), (nufound), (nufound), (nufound), (nufound), (nufound),

define coefficient sigma
(sigmahole), (sigmacore), (sigmacore), (sigmacore), (sigmahole), (sigmahole),
(sigmahole), (sigmahole), (sigmahole), (sigmahole), (sigmahole), (sigmahole), 
(sigmahole), (sigmahole), (sigmahole), (sigmahole), (sigmahole), (sigmahole), 
(sigmawall), (sigmawall), (sigmawall), (sigmawall), (sigmawall), (sigmawall),
(sigmafound), (sigmafound), (sigmafound), (sigmafound), (sigmafound), (sigmafound),

define coefficient one
1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 
1, 1, 1, 1, 1, 1, 

define coefficient penalty
1e15, 0, 0, 0,

define coefficient coef_source
0, 1, 0, 0,

define fespace v -order=1
define gridfunction u -fespace=v -nested

define bilinearform a -fespace=v -symmetric
laplace sigma
robin penalty

define linearform f -fespace=v
neumann coef_source

define preconditioner c -type=amg -bilinearform=a -coefe=sigma -coeff=sigma  -test

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000
