mesh = microcoil.vol

define coefficient lam
1000, 1e-3, 

define coefficient penalty
0, 0, 1e5, 1e5, 

define coefficient coef_rhs
0, 0, 1e5, 0, 


define fespace v -order=1

define gridfunction u -fespace=v -nested

define bilinearform a -fespace=v -symmetric -multilevel
laplace lam
robin penalty

define linearform f -fespace=v
neumann coef_rhs

# define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1
define preconditioner c -type=amg -bilinearform=a -coefe=lam


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000

define bilinearform ag -fespace=v -nonassemble
laplace lam
numproc drawflux np2 -bilinearform=ag -solution=u -label=flux


define fespace verr -l2 -order=0
define gridfunction err -fespace=verr

numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -error=err -minlevel=1
numproc markelements np4 -error=err -minlevel=1 -factor=0.5 
