geometry = one_proton_3d.geo
mesh = one_proton_3d.vol



define constant geometryorder = 3


define coefficient one
1, 1, 

define coefficient fac
10, 10, 

define coefficient rho
0, -1e7,


define coefficient penaltyh
1e5, 0, 

define coefficient penalty
1e5, 0, 



define fespace v -order=2

define bilinearform h  -fespace=v -symmetric
laplace one
robin penaltyh

define bilinearform s   -fespace=v  -symmetric
mass one

define bilinearform bfpot   -fespace=v  -symmetric
laplace one
robin penalty


define bilinearform bfmass   -fespace=v  -symmetric
mass fac


define linearform rhobg -fespace=v
source rho


define gridfunction psi -fespace=v  -multidim=8
define gridfunction rho -fespace=v  
define gridfunction pot -fespace=v  


numproc dft np1  -dftits=10 -evpits=20

define bilinearform bfgrad   -fespace=v -nonasselbme
laplace one

numproc drawflux npdf -bilinearform=bfgrad -solution=rho -label=gradrho


# source = -10e5, multidim=16
# 216 els:
# p/nd/time/lam1 = 1,  119,  0.22 sec, -27.2193
# p/nd/time/lam1 = 2,  453,  1.55 sec, -37.7526
# p/nd/time/lam1 = 3, 1003,  4.03 sec, -37.9676
# p/nd/time/lam1 = 4, 1769, 11.7  sec, -37.972437
# p/nd/time/lam1 = 5, 2751, 13.9  sec, -37.97252521
# p/nd/time/lam1 = 6,                  -37.97252868

# 3030 els 
# p/nd/time/lam1 = 1, 1584,  3.36 sec, -36.9986
# p/nd/time/lam1 = 2, 6197, 25.38 sec, -37.9709
