geometry = ehd.in2d
mesh = ehd.vol


define constant heapsize = 10000000


define coefficient one
1, 

define coefficient stab
10,


define coefficient pot
0, 1, 1, 0, 0,

define coefficient penaltyE
1e8, 0, 0, 0, 0, 

define coefficient penaltyj
1e12, 1e8, 0, 0, 0,

# define coefficient sourcej
# 0, 0, 0.1e8, 0, 0, 



define fespace v -mixedEHD -order=4
define fespace vpost -l2 -order=1
define fespace verr -l2 -order=0


define bilinearform a -fespace=v -nonsymmetric -noprintelmat
mixedEHD
mixedEHDjumps stab
mixedEHDbound
robinhdiv penaltyE -comp=1
robinhdiv penaltyj -comp=3

define bilinearform massn -fespace=v -nonassemble 
mass one -comp=4

define bilinearform arhs -fespace=v -nonassemble 
mixedEHDrhsbound


define bilinearform norm -fespace=v -symmetric
masshdiv one -comp=1
robinhdiv penaltyE -comp=1
mass one -comp=2
masshdiv one -comp=3
robinhdiv penaltyj -comp=3
mass one -comp=4


define linearform f -fespace=v
neumannhdiv pot -comp=1
# neumannhdiv sourcej -comp=3

define gridfunction u -fespace=v -nested
define gridfunction npost -fespace=vpost  -nested
define gridfunction err -fespace=verr -nested



# numproc mixedEHD np1 -dt=0.003 -b=500 -te=10
# numproc mixedEHD np1 -dt=0.01 -b=3000 -te=0.5

# high electrod penalty
# numproc mixedEHD np1 -dt=0.00001 -b=30000 -te=1 -elec=1000000

# high electrod penalty
numproc mixedEHD np1 -dt=0.01 -b=30000 -te=1 -elec=1000



# numproc mixedEHD np1 -dt=0.000001 -b=1000 -te=10

numproc mixedEHDpost np1b
numproc markelements np1c -error=err -minlevel=1 -factor=0.5 

define bilinearform compe -fespace=v -nonassemble
masshdiv one -comp=1

define bilinearform compphi -fespace=v -nonassemble
mass one -comp=2

define bilinearform compj -fespace=v -nonassemble
masshdiv one -comp=3

define bilinearform compn -fespace=v -nonassemble
mass one -comp=4


numproc drawflux df1 -bilinearform=compe -solution=u -label=E
numproc drawflux df2 -bilinearform=compphi -solution=u -label=phi
numproc drawflux df3 -bilinearform=compj -solution=u -label=j
numproc drawflux df4 -bilinearform=compn -solution=u -label=n