geometry = examples/squareinsquare.in2d
mesh = examples/squareinsquare_hp.vol
# geometry = examples/square.in2d
# mesh = examples/square.vol

define constant geometryorder = 1
define constant secondorder = 0
define constant refinehp = 1

define coefficient lam
0.1, 10, 1, 

define coefficient penalty
1e5, 1e5, 1e5, 1e5, 0, 0, 0, 0, 

define coefficient coef_source
0, 1, 0,

define fespace v -order=1 -h1ho
define fespace vp -order=2 -hdivho
define fespace verr -order=0 -l2


define gridfunction u -fespace=v 
define gridfunction p -fespace=vp
define gridfunction p2 -fespace=vp
define gridfunction err -fespace=verr


define bilinearform a -fespace=v -symmetric 
laplace lam
robin penalty

define bilinearform ap -fespace=v -nonassemble
masshdiv lam


define linearform f -fespace=v
source coef_source

# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 
define preconditioner c -type=direct -bilinearform=a

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=50

# numproc calcflux np2 -bilinearform=a -solution=u -flux=p -applyd
numproc rtzzerrorestimator npee -bilinearform=a -solution=u -error=err

numproc markelements npme -error=err -minlevel=1 -factor=0.5
numproc drawflux df0 -solution=u -bilinearform=a -label=df
numproc drawflux df1 -marked 
numproc drawflux df2 -order


# numproc shapetester nptest -gridfunction=p2 -bilinearform=ap

