geometry = ngusers/etc/infinite.in2d
mesh = ngusers/etc/infinite.vol

define constant k = 10

define coefficient lam
1, 1, 

define coefficient rho
(-k*k), (-k*k),

define coefficient coef_k
(k), (k),

define coefficient coef_r
1, 1, 

define coefficient coef_source
1, 0, 

define coefficient absorb
0, (-k), 

define coefficient absorb_re
0, 0.5, 


define fespace v -infinitefe -complex
define fespace vabs  -complex

define gridfunction u -fespace=v
define gridfunction uabs -fespace=vabs

define bilinearform a -fespace=v -nonsym -print
laplace lam
mass rho
cut_ieq coef_k coef_r -definedon=2

define bilinearform aabs -fespace=vabs 
laplace lam
mass rho
robin absorb -imag
robin absorb_re

define linearform f -fespace=v
source coef_source

define linearform fabs -fespace=vabs
source coef_source

# define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block

# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -coarsetype=smoothing

define preconditioner cabs -type=direct -bilinearform=aabs 

# numproc bvp np1 -bilinearform=aabs -linearform=fabs -gridfunction=uabs -preconditioner=cabs -maxsteps=10000 -print -qmr

numproc polecond np2  -bilinearform=a -linearform=f -gridfunction=u -maxsteps=50

