geometry = ngusers/etc/nonlinmagedge.in2d
mesh = ngusers/etc/nonlinmagedge.vol

define constant mu0 = 1.246E-6
define constant tau = 0.00002
define constant te = 0.015

define coefficient mu1
(mu0), (10000*mu0), (mu0),

define coefficient mu2
(mu0), (mu0), (mu0),

define coefficient bsat
2, 2, 2, 

define coefficient sigmatau
0, (5e6/tau), 0,

define coefficient penalty
1e10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

define coefficient coef_source
0, 0, (1.414*3956*1000)

define fespace v -order=1
define gridfunction u -fespace=v -nested

define bilinearform a -fespace=v
nonlinmag mu1 mu2 bsat
mass sigmatau -definedon=2
robin penalty

define bilinearform m -fespace=v
mass sigmatau


define linearform f -fespace=v
source coef_source


define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1

# numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000
numproc nonlinmag np1
numproc drawflux draw1 -bilinearform=a -solution=u -label=b
