geometry = examples/square.in2d
mesh = examples/square.vol

define constant secondorder = 0

define coefficient nu
1,

define coefficient reg
-1e-10,

define coefficient one
1,

define coefficient penalty
1e18, 1e18, 1e18, 1e18,
1,1,1,1,
1e8, 1e8, 1e8, 1e8,

define coefficient g
0, 0, 1e12, 0,

define coefficient coef_source1
( 100*(0.5-y) ),
define coefficient coef_source2
( 100*(x-0.5) ),

define fespace v -stokes  -taylorhood
# -mini
# -taylorhood
# -p2p0

define gridfunction up -fespace=v -nested
define gridfunction up2 -fespace=v 

define bilinearform a -fespace=v  -symmetric
stokes nu -order=6
mass reg -comp=3
robin penalty -comp=1
robin penalty -comp=2

define bilinearform norm -fespace=v  -symmetric
laplace one -comp=1
laplace one -comp=2
mass one -comp=3



define linearform f -fespace=v
# neumann g -comp=1
source coef_source1 -comp=1
source coef_source2 -comp=2

# nur fr Multigrid-lser
define linearform constraint -fespace=v
source one -comp=3

define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=5 -smoother=block -cycle=2 -constraint=constraint  -coarsetype=direct

# numproc teststokes npt

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=up -preconditioner=c -maxsteps=100 -qmr -prec=1e-8

define bilinearform evalu -fespace=v -symmetric -nonassemble 
stokesu 

define bilinearform evalp -fespace=v -symmetric -nonassemble 
mass one -comp=3 

numproc drawflux np2 -bilinearform=evalu -solution=up -label=velocity
# numproc drawflux np2a -bilinearform=evalu -solution=up2 -label=velocity2
numproc drawflux np2b -bilinearform=evalp -solution=up -label=pressure
# numproc drawflux np2c -bilinearform=evalp -solution=up2 -label=pressure2





