# geometry = ngusers/mechanics/wrench2.geo
# mesh = ngusers/mechanics/wrench2.vol
# geometry = examples/shaft.geo
# mesh = examples/shaft.vol
# geometry = examples/cube.geo
# mesh = examples/cube.vol

geometry = tutorials/fichera.geo
mesh = tutorials/fichera.vol


define constant geometryorder = 1
# define constant hpref = 2

# geometry = ngusers/etc/lshapeprism.geo
# mesh = ngusers/etc/lshapeprisml4.vol



define coefficient lam
1,

define coefficient penalty

0, 1e10, 0, 0, 0, 0, 0, 

define coefficient coef_neumann
0, 0, 1, 0, 0, 0, 0, 0, 

define coefficient coef_f
(1)


# define fespace v  -order=3 -stdoptext -noaugmented=1
define fespace v  -order=3 -stdext -augmented=0
define gridfunction u -fespace=v

# define fespace vp -order=3 -dim=3
# define gridfunction p -fespace=vp


define bilinearform a -fespace=v -symmetric
laplace lam
robin penalty

define linearform f -fespace=v
source coef_f
# neumann coef_neumann

# define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block
define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -test -smoother=block

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=500

numproc drawflux np2 -bilinearform=a -solution=u -label=flux

# numproc testho np3
numproc evaluate np3a -linearform=f -gridfunction=u
numproc evaluate np3b -bilinearform=a -gridfunction=u -gridfunction2=u
numproc calcflux np2a -bilinearform=a -solution=u -flux=p

# numproc shapetester npst -gridfunction=u -bilinearform=a -dof=1

# fichera
# p=3,ref=0  N=162,  0.02 sec    0.01748
# p=3,ref=1  N=2834,   2 sec,    0.017640459
# p=3,ref=2                      0.01764056848
# p=3,ref=3                      0.01764056857

# p=4,ref=0, N=                  0.0176039
# p=4,ref=1, N=6162,  10 sec,    0.01764680177
# p=4,ref=2  N=15966, 43 sec,    0.0176468122

# p=5,ref=1, N=11468, 35 sec,    0.01764736456
# p=5,ref=2, N=29816, 143 sec,   0.01764736658704554

# p=6,ref=1, N=19209, 120 sec,   0.0176474337
# p=6,ref=2, N=50085, 503 sec,   0.01764743418687381

# Dir corner
# p=3,ref=1, 0.01239154343023472
# p=3,ref=2, 0.01241243401304397
# p=3,ref=3, 0.0124136469060257

# p=4,ref=1, 0.0124220268383156
# p=4,ref=2, 0.01243256588306495

# p=5,ref=1, 0.0124296911917533
# p=5,ref=2  0.01243575808997

# iteration numbers with edge-block, stdext, augmented=1
# p=3, ref=0, NE = 18, N=81, 1 its, 
# p=3, ref=1, NE = 264, N=2834, 57 its, 3.1 sec
# p=3, ref=2, NE = 477, N=7316, 69 its, 11.6 sec
# p=3, ref=3, NE = 772, N=14514, 72 its, 28.3 sec
# p=3, ref=4, NE = 1149, N=24438, 94 its, 40.2 sec


