geometry = examples/cube.geo
mesh = examples/cube.vol
# geometry = examples/tet.geo
# mesh = examples/tet.vol
# mesh = examples/square.vol

define constant geometryorder = 1
define constant heapsize = 350000000

define coefficient coef_f
(sin (3.1415*x)*sin(3.1415*y)), 1,

define coefficient one
1,

define coefficient alpha
1e30, 1e30, 1e30, 1e30, 1e30, 1e30, 1e30, 1e30,

define fespace v -h1ho -order=18 -eliminate_internal -augmented=1 -fast

define gridfunction u -fespace=v -novisual 

define linearform f -fespace=v
# source coef_f -fast -nocheckfast


define bilinearform a -fespace=v -symmetric -linearform=f -eliminate_internal -noprintelmat -noelmatev
# mass one -nofast -nocheckfast 
# fastmass one -checkfast
fastlaplace one -nocheckfast
# laplace one
# robin alpha


define fespace v2 -h1ho -order=24 -noeliminate_internal -augmented=0 -fast

define linearform f2 -fespace=v2
source coef_f -nofast -nocheckfast -order=1

define bilinearform a2 -fespace=v2 -symmetric -linearform=f2 -noeliminate_internal -noprintelmat -noelmatev -nonassemble -timing -precompute
# mass one -nofast -checkfast
# laplace one -nofast -nocheckfast
# fastmass one -nocheckfast
laplace one -fast -nocheckfast

define gridfunction u2 -fespace=v2

# define preconditioner c2 -type=multigrid -bilinearform=a2 -notest -smoother=block
# define preconditioner c2 -type=direct -bilinearform=a2 -notest
# numproc bvp np1 -bilinearform=a2 -gridfunction=u2 -linearform=f2 -preconditioner=c2 -maxsteps=500

# numproc evaluate np2 -linearform=b -gridfunction=u

# p=6:
# 0.00487559    // mit Jacobi
# 0.00487553    // mit Legendre (instable)
# 0.00489608    // original

# p=8
# 0.00487679    // scaled mit Jacobi
# 0.00489996    // scaled mit legendre
# 0.00489963    // unscaled mit legendre

# p=10
# 0.00487627
# 0.00487612     // mit Legendre (instable scaled)
# 0.00489996233407  // original

# p=15
# 0.00490003013361


# p=10:  12.5 %
# p=15:   9.1 %
# p=20:   5.8 %
# p=30:   3.8 %

# p=64: 8.49 sec,  ohne inner: 6.6 sec
#
# sonntag: p=64: 6.09 sec,  p=100: 25.5
# 
# eval gird shape, p=20: 5ms,  p=40: 80 ms,  p=80: 650 ms
#
#
# p=15, ndof = 816, nip = 6859
# time = c*p*nip = c * 100000 
# time = 2 ms / EvalGrid
# c = 2e-8 sec/(p*nip)
