# geometry = examples/cube.geo
# mesh = examples/cube.vol
# geometry = square.in2d
mesh = square.vol
# mesh = triangle.vol

define constant geometryorder = 2

define constant heapsize = 5000000

define coefficient coef_f
(x)

define coefficient one
1,

define coefficient rho
1,

define fespace v -h1ho -order=30 -fast
define fespace vc -h1ho -order=1 -fast

define gridfunction u -fespace=v 

define linearform f -fespace=v
source coef_f -fast -nocheckfast


define bilinearform a -fespace=v -symmetric  -nonassemble -precompute
mass rho -fast
laplace one -fast 

define bilinearform ac -fespace=vc -symmetric  
mass rho
laplace one


define preconditioner c -type=refelementasm -bilinearform=a -fespace=v -bilinearformc=ac -test

numproc bvp np1 -bilinearform=a -gridfunction=u -linearform=f -preconditioner=c -maxsteps=500 -noprint 



# p=8:   59 its
# p=16: 112 its, N=2401, t=7.28
# p=24: 158 its, N=5329, t=32 sec
# p=32: 202 its, N=9409, t=103 sec, 


# kappa, inner
#  3:  1.26
#  4:  2.69
#  8:  6.59
# 12:  7.91
# 24:  8.78
# 32:  8.86

# inner + edge
#  8: 89
# 12: 133
# 16: 190
# 24: 356
# 32: > 500


# all edges:
# p=12: 287     (0.072 / 20.90)
# p=16: 578     (0.060 / 35.03)
# p=24: 1538,   (0.048 / 74.15)

# 20 edges:
# p=12: 47.1
# p=16: 55
# p=24: 69.10   (0.092 / 6.40)
# p=32: 79.14   (0.082 / 6.52)
# p=48: 94.11   (0.071 / 6.65)

# triangle
# p=8   34.33   (0.0617 / 2.11)   
# p=16  58.50   (0.0378 / 2.21)
# p=32  89.24   (0.0254 / 2.27)