geometry = examples/cube.geo
mesh = examples/cube.vol
# mesh = examples/square.vol

define constant geometryorder = 1

define constant heapsize = 200000000

define coefficient coef_f
(sin (x*y)), 1,


define coefficient one
1,

define coefficient alpha
0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 
1e30, 1e30, 1e30, 1e30, 1e30, 1e30, 1e30, 1e30,


define fespace v -h1ho -order=20 -eliminate_internal -augmented=0

define gridfunction u -fespace=v -novisual 

define linearform f -fespace=v
source coef_f -fast -nocheckfast

define linearform b -fespace=v
# source one -fast

define gridfunction u -fespace=v


define bilinearform a -fespace=v -symmetric -eliminate_internal -linearform=f -noprintelmat -ho
fastlaplace one -nocheckfast
# laplace one
robin alpha

# define preconditioner c1 -type=direct -bilinearform=a -notest
# define preconditioner c -type=multigrid -bilinearform=a -notest

define preconditioner c -type=wirebasket -bilinearform=a -test

numproc bvp np1 -bilinearform=a -gridfunction=u -linearform=f -preconditioner=c -maxsteps=500 -noprint 

numproc evaluate np2 -linearform=b -gridfunction=u

# p=6:
# 0.00487559    // mit Jacobi
# 0.00487553    // mit Legendre (instable)
# 0.00489608    // original

# p=8
# 0.00487679    // scaled mit Jacobi
# 0.00489996    // scaled mit legendre
# 0.00489963    // unscaled mit legendre

# p=10
# 0.00487627
# 0.00487612     // mit Legendre (instable scaled)
# 0.00489996233407  // original

# p=15
# 0.00490003013361


# p=10:  12.5 %
# p=15:   9.1 %
# p=20:   5.8 %
# p=30:   3.8 %

# p=64: 8.49 sec,  ohne inner: 6.6 sec
#
# sonntag: p=64: 6.09 sec,  p=100: 25.5
# 
# eval gird shape, p=20: 5ms,  p=40: 80 ms,  p=80: 650 ms