geometry = examples/fichera.geo
mesh = ngusers/fastint/ficheral1.vol

# geometry = examples/cube.geo
# mesh = examples/cube_f.vol

# geometry = examples/shaft.geo
# mesh = examples/shaft.vol



define constant common_integration_order = 20
define constant geometryorder = 1

define constant heapsize = 50000000
define constant hpref = 0

define coefficient lam
1,

define coefficient penalty
1e6, 0,

define coefficient coef_force
( 1 ),

define fespace v -dim=1 -h1ho -order=10 -noeliminate_internal -augmented=0 -stdext -fast -dirichlet=[1]
define fespace v1 -dim=1 -h1ho -order=10 -noeliminate_internal -augmented=0 -stdext -fast -orderface=1 -orderinner=1 -orderedge=1   -dirichlet=[1]

define gridfunction u -fespace=v

define linearform f -fespace=v
source  coef_force -fast -nocheckfast -const


define bilinearform a2 -fespace=v -symmetric -no_elmatev -noeliminate_internal -linearform=f -nonassemble -precompute -notiming
fastlaplace lam -fast -nofast  -const
# robin penalty -fast  -const


define bilinearform a -fespace=v1 -symmetric -no_elmatev -noeliminate_internal -linearform=f 
laplace lam  -nocheckfast -nofast  -order=4
robin penalty -nofast -nocheckfast


define preconditioner c -type=refelementasm -fespace=v  -bilinearform=a2  -bilinearformc=a -notest

numproc bvp np1 -bilinearform=a2 -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000 -prec=1e-8



# numproc evp np1 -bilinearforma=a -bilinearformm=m  -gridfunction=u -preconditioner=c
# numproc calcflux np2 -bilinearform=a -solution=u -flux=stress
numproc drawflux np2b -bilinearform=a -solution=u -label=flux
# numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -flux=p -minlevel=0

# numproc shapetester nptest -gridfunction=u -bilinearform=a


# p=5 .. 130    .. 70
# p=10 ..227    .. 115  94   95
# p=15 ..315    .. 154  124  115
# p=20                       135



# appy element matrix
# p = 2:  0.090 ms
# p = 4:  0.191 ms
# p = 8:  1.039 ms
