geometry = examples/fichera.geo
mesh = ficheral1.vol

# geometry = examples/cube.geo
# mesh = examples/cube.vol

# geometry = examples/shaft.geo
# mesh = examples/shaft.vol

define constant common_integration_order = 10

define constant geometryorder = 3

define constant heapsize = 150000000
define constant hpref = 0

define coefficient lam
1,

define coefficient penalty
0, 1, 0, 0, 0, 0, 0, 0, 1e12, 1e12, 1e12, 1e12, 1e12, 1e12, 1e12, 1e12, 1e12,
0.001, 0.001, 0.001, 0.001, 0.001, 

define coefficient coef_force
( 1 ),

define fespace v -dim=1 -h1ho -order=5 -noeliminate_internal -augmented=1 -minext -fast 
define fespace v1 -dim=1 -h1ho -order=5 -noeliminate_internal -augmented=1 -minext -fast -orderface=1 -orderinner=1 -orderedge=1
#  -orderface=1 -orderinner=1 -orderedge=1

define gridfunction u -fespace=v

define linearform f -fespace=v
source  coef_force -fast -nocheckfast

define bilinearform a -fespace=v1 -symmetric -no_elmatev -noeliminate_internal -linearform=f 
laplace lam  -nocheckfast -nofast 
robin penalty -nofast -nocheckfast

define bilinearform a2 -fespace=v -symmetric -no_elmatev -noeliminate_internal -linearform=f -assemble -noprecompute
laplace lam -nofast -nofast 
robin penalty -nofast

# define preconditioner c -type=direct -bilinearform=a -notest
# define preconditioner c -type=multigrid -bilinearform=a  -smoother=block -test 
# define preconditioner c -type=local -bilinearform=a2 -block -notest 
define preconditioner c -type=refelementasm -fespace=v  -bilinearform=a -notest


numproc bvp np1 -bilinearform=a2 -linearform=f -gridfunction=u -preconditioner=c -maxsteps=1000 -prec=1e-8

# numproc evp np1 -bilinearforma=a -bilinearformm=m  -gridfunction=u -preconditioner=c
# numproc calcflux np2 -bilinearform=a -solution=u -flux=stress
# numproc drawflux np2b -bilinearform=a -solution=u -label=drawstress
# numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -flux=p -minlevel=0

# numproc shapetester nptest -gridfunction=u -bilinearform=a


# p=5 .. 130    .. 70
# p=10 ..227    .. 115  94   95
# p=15 ..315    .. 154  124  115
# p=20                       135
