#############################
#                           # 
#   #ifdef PARALLEL :-)     # 
#                           #
#############################


# geometry = coil.geo
# mesh = coil.vol

geometry = coil2.geo
mesh = coil2.vol

# mesh = lshape3d.vol



define constant geometryorder = 4
define constant heapsize = 500000000

# define constant hpref = 1

# nu = 1/mu with mu permittivity
define coefficient nu
1, 1, 

define coefficient sigma
1e-6, 1e-6,

define coefficient cs1
( x2), 0,
define coefficient cs2
( -x1 ), 0,
define coefficient cs3
0, 0, 0

define coefficient penalty
0, 0, 0, 0, 0, 0

define coefficient magx
0, 0, 0, 

define coefficient magy
0, 0, 0, 

define coefficient magz       
( 1 ), 0, 0,

define fespace v -hcurlho -order=4 -eliminate_internal -nograds -noprint -fast

#define fespace v -hcurl -order=0 

define gridfunction u -fespace=v #-novisual

define linearform f -fespace=v -noprintelvec 
sourceedgetp cs1 cs2 cs3 -definedon=1 
# curledgetp magx magy magz  -definedon=1


define bilinearform a -fespace=v -symmetric -linearform=f -eliminate_internal -noprintelmat  -noelmatev
curlcurledgetp nu 
massedge sigma  -order=2
# robinedge penalty


define bilinearform acurl -fespace=v -symmetric -nonassemble
curlcurledge nu 

# define preconditioner c -type=direct -bilinearform=a  
define preconditioner c -type=multigrid -bilinearform=a  -smoother=block
# define preconditioner c -type=multigrid -bilinearform=a -cylce=1 -smoother=block -blocktype=1 -coarsetype=direct -coarsesmoothingsteps=5  -notest
#define preconditioner c -type=local -bilinearform=a -test 


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c  -prec=1.e-9

numproc drawflux np5 -bilinearform=acurl -solution=u  -label=flux


numproc visualization vis -scalarfunction=flux -clipsolution=scalar -clipvec=[0,1,0] -clipdist=0.0 -subdivision=1



# define fespace vf -type=facet -order=3
# numproc measurejump jumps




# 2 x 2156 tets:
# 
#                 no grads            grads
#            std         fast      std      fast
# p=3        0.64        1.05      0.99     1.40
# p=4        4.75        3.00      11.76    4.65
# p=5       18.13        8.30      52.50    12.51
# p=6       63.11       17.77
# p=7      203.12       38.09
# p=8      560.83       80.86
# p=9                  193.88
# p=10                 342.86


# per tet (ms):
#            std         fast      std      fast
# p=3        0.14        0.24      0.22     0.32
# p=4        1.1         0.69      2.74     1.08
# p=5        4.2         1.92      12.2     2.90
# p=6       14.64        4.12
# p=7       47.10        8.83
# p=8      130.0        18.75
# p=9                   44.96
# p=10                  79.51

