# geometry = cylinder.geo
# mesh = cylinderf.vol

geometry = lshape3d.geo
mesh = lshape3d.vol

# geometry = cube.geo
# mesh = cube-hex.vol

define constant heapsize = 200000000
define constant geometryorder = 1
define constant hpref = 3

define coefficient lam
1,

define coefficient rho
10, 

define coefficient penalty
1e15, 1e15, 1e15, 1e15, 1e15, 1e15, 1e15, 1e15, 

define coefficient coef_source
1,

define fespace v -order=5 -eliminate_internal -fast


define gridfunction u -fespace=v -nested

define linearform f -fespace=v
source coef_source

define bilinearform a -fespace=v -symmetric  -eliminate_internal -linearform=f
laplacetp lam
# mass rho
robin penalty

define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -cycle=1 -stdsmoother=block 
# define preconditioner c -type=direct -bilinearform=a

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=100 -prec=1e-8


define bilinearform ag -fespace=v -symmetric -nonassemble
laplace lam

numproc drawflux np3 -bilinearform=ag -solution=u -noapplyd -label=grad

numproc visualization vis -scalarfunction=u -clipsolution=scalar -clipvec=[0,0,-1] -clipdist=0.0 -subdivision=3
