# geometry = cylinder.geo
# mesh = cylinderf.vol

geometry = lshape3d.geo
mesh = lshape3d.vol
# mesh = lshape3d-prism.vol

# geometry = cube.geo
# mesh = cube-hex.vol

define constant heapsize = 500000000
define constant geometryorder = 1
define constant hpref = 2

define coefficient lam
1,

define coefficient rho
10, 

define coefficient penalty
0, 1e15, 1e15, 1e15, 0, 1e15, 1e15, 1e15, 
1, 1, 1, 1, 1, 1, 


define coefficient coef_source
1, 

define fespace v -h1ho -order=10 -eliminate_internal -fast


define gridfunction u -fespace=v -nested

define linearform f -fespace=v -noprint -noprintelvec
sourcetp coef_source 


define bilinearform a -fespace=v -symmetric  -eliminate_internal -linearform=f -noprint -noprintelmat -noelmatev
# mass lam
laplacetp lam
# laplace lam
# mass rho
robin penalty

define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -cycle=1 -smoother=block -blocktype=20
# define preconditioner c -type=direct -bilinearform=a

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=400 -prec=1e-12

define bilinearform ag -fespace=v -symmetric -nonassemble
laplace lam

numproc drawflux np3 -bilinearform=ag -solution=u -noapplyd -label=grad

numproc visualization vis -scalarfunction=u -clipsolution=scalar -clipvec=[0,0,-1] -clipdist=0.0 -subdivision=3



# 1208 call
#            large mem,    low mem     std
# p=2        0.033 
# p=3        0.099         0.0902      0.1082
# p=4        0.2736        0.2556      0.9038
# p=5        0.5631        0.5667      3.1196


# 24 calls
# p=5        0.0115
# p=6        0.0283
# p=8        0.0901
# p=10       0.2905        0.2601      5.4936