#############################
#                           # 
#   #ifdef PARALLEL :-)     # 
#                           #
#############################


# geometry = coil.geo
mesh = cube.vol

# geometry = lshape3d.geo
# mesh = prism-prism.vol

# geometry = ngsolve/pde_tutorial/coil.geo
# mesh = ngsolve/pde_tutorial/coil.vol


define constant geometryorder = 2
define constant heapsize = 500000000

# nu = 1/mu with mu permittivity
define coefficient nu
1, 1, 

define coefficient sigma
1e-6, 1e-6,

define coefficient cs1
( sin(x*y*z+1)), 0,
define coefficient cs2
( sin(2*y+x*z) ), 0,
define coefficient cs3
( sin(z+2*y*x) ), 0, 0

define coefficient penalty
0, 0, 0, 0, 0, 0

define coefficient magx
(sin (x) ), 0, 0, 

define coefficient magy
(sin (y) ), 0, 0, 

define coefficient magz
(sin (z) ), 0, 0, 


define fespace v -hcurlho -order=10 -eliminate_internal -nograds -noprint -fast

define linearform f -fespace=v -printelvec 
# sourceedgetp cs1 cs2 cs3 -definedon=1
curledgetp cs1 cs2 cs3 -definedon=1

define bilinearform a -fespace=v -symmetric -linearform=f -eliminate_internal -noprintelmat 
curlcurledgetp nu 
massedgetp sigma
#  -order=2


define fespace v1 -h1ho -order=2 -eliminate_internal -noprint -nofast

define linearform f1 -fespace=v1 -noprintelvec 
source cs1

define bilinearform a1 -fespace=v1 -symmetric -linearform=f1 -eliminate_internal -noprintelmat 
laplacetp nu 








# 2 x 2156 tets:
# 
#                 no grads            grads                  mass
#            std         fast      std      fast            std      fast
# p=2                              0.21     0.49           0.49     0.62
# p=3        0.64        1.05      0.99     1.12           5.00     2.05
# p=4        4.75        3.00      11.76    3.75(4.73)    23.36     4.58
# p=5       18.13        7.47      52.50    9.45(13.3)    87.42    13.89
# p=6       63.11       17.77                   (30.35)            28.78  
# p=7      203.12       38.09
# p=8      560.83       80.86
# p=9                  193.88
# p=10                 342.86


# per tet (ms):
#            std         fast      std      fast
# p=3        0.14        0.18      0.22     0.20
# p=4        1.1         0.58      2.74     1.08
# p=5        4.2         1.47      12.2     2.90
# p=6       14.64        3.50
# p=7       47.10        8.83
# p=8      130.0        18.75
# p=9      320.0        44.96    1280.0    70.00
# p=10     780.0        79.51    2160.0   130.00



# geomorder = order
# per tet (ms, 25. Aug)
# p=2       0.03         0.07      0.06     0.07        0.11      0.15
# p=3       0.14         0.16      0.30     0.21        1.07      0.41
# p=4       1.14         0.43      2.40     0.54        4.60      1.05
# p=5       4.22         1.20     10.51     1.79       17.67      2.85
# p=6      13.83         3.00     38.16     4.27       58.90      5.65

# p=10                  50.00   1640.00    55.00     2180.00    100.00


