geometry = ngusers/laser/waveguide_square.in2d
mesh = ngusers/laser/waveguide_square.vol


define constant geometryorder = 1
define constant pml_x = 0.5

define constant pml_alpha = 0.05

define constant omega2 = 10000

define coefficient lam
1, 1, 1, 1, 1,

define coefficient rho
(-2*omega2), (-2*omega2), (-1*omega2), (-1*omega2), (-2*omega2),

# Quelle in Domain 1
define coefficient coef_source
1, 0, 0, 0, 0,

define fespace v -complex -order=6

define gridfunction u -fespace=v

define bilinearform a -fespace=v -symmetric
PML_laplace lam
PML_mass rho

define linearform f -fespace=v
source coef_source


define preconditioner c -type=direct -bilinearform=a

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c
