geometry = benchmark1.geo
mesh = benchmark1.vol


define constant geometryorder = 1
define constant heapsize = 10000000

define coefficient nu material
matcoil 1e7
air 1e7
iron 1e7

define coefficient kappa material
matcoil 1e3 
air 1e3
iron 1e3


define coefficient kappasurf
0,0,0,1e9

define coefficient cs1 material
matcoil ( x2 )
air 0
iron 0

define coefficient cs2 material
matcoil ( -x1 )
air 0
iron 0

define coefficient cs3 material
matcoil 0
air 0
iron 0




define fespace v -hcurlho -order=2
#define fespace v -hcurl -order=3 


define gridfunction u -fespace=v

define linearform f -fespace=v
sourceedge cs1 cs2 cs3

define bilinearform a -fespace=v -symmetric
curlcurledge nu 
massedge kappa 
robinedge kappasurf 


define bilinearform acurl -fespace=v -symmetric -nonassemble
curlcurledge nu 

define bilinearform aeddy -fespace=v -nonassemble
massedge kappa

define bilinearform aeddys -fespace=v -nonassemble 
robinedge kappasurf

define preconditioner c -type=multigrid -bilinearform=a -cylce=1 -smoother=block -blocktype=2 -coarsetype=direct -coarsesmoothingsteps=5  -test



numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c  -prec=1.e-10 -maxsteps=1000 


numproc drawflux npa -bilinearform=acurl -solution=u  -label=flux
numproc drawflux npb -bilinearform=aeddy -solution=u -label=draw_eddy -applyd
numproc drawflux npc -bilinearform=aeddys -solution=u -label=draw_eddys -applyd









