#
#
geometry = ngusers/mechanics/crankshaft.stl
mesh = ngusers/mechanics/crankshaft.vol

# define constant secondorder = 0
define constant geometryorder = 1

define coefficient E
210000,

define coefficient nu
0.23,

define coefficient rho
7800

define coefficient penalty
0, 1e4, 0, 0, 

define coefficient coef_forcey
0, 0, (step(-275-z)*step(290+z)),

define coefficient coef_bearing1
(1e5*step(-410-z)*step(430+z)), 0, 0,

define coefficient coef_bearing3
(1e5*step(-230-z)*step(245+z)), 0, 0,



define fespace v -dim=3 -order=3
define fespace vp -dim=6  -order=2

define gridfunction u -fespace=v
define gridfunction stress -fespace=vp

define linearform f -fespace=v
neumann coef_forcey -comp=2

define linearform cntb1x -fespace=v
neumann coef_bearing1 -comp=1
define linearform cntb1y -fespace=v
neumann coef_bearing1 -comp=2

define linearform cntb3x -fespace=v
neumann coef_bearing3 -comp=1
define linearform cntb3y -fespace=v
neumann coef_bearing3 -comp=2

define linearform cntx -fespace=v
neumann penalty -comp=1
define linearform cnty -fespace=v
neumann penalty -comp=2
define linearform cntz -fespace=v
neumann penalty -comp=3



define bilinearform a -fespace=v -symmetric  
elasticity E nu
robin penalty  -comp=1
robin penalty  -comp=2
robin penalty  -comp=3

define preconditioner c -type=multigrid -bilinearform=a -test

numproc constrainedbvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=100  -constraints=[cntx,cnty,cntz,cntb1x,cntb1y,cntb3x,cntb3y]

# numproc evp np1 -bilinearforma=a -bilinearformm=m  -gridfunction=u -preconditioner=c
numproc calcflux np2 -bilinearform=a -solution=u -flux=stress
numproc drawflux np2b -bilinearform=a -solution=u -label=drawstress

# define fespace verr -l2 -order=0
# define gridfunction err -fespace=verr
# numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -error=err -minlevel=0
# numproc markelements np4 -error=err -minlevel=1 -factor=0.5
