geometry = examples/thinc.geo
mesh = examples/thinc.vol

# mesh = examples/rectangle.vol

define coefficient coef_source
100,

define coefficient coef_source1
100, 100, 100,
# 0, (10*((x2)-40)), 0, 

define coefficient coef_source2
0, ((-600)*((x2)-40)), 0, 

define coefficient coef_source3
0, ((-800)*((x2)-40)), 0, 


define coefficient coef_e
210000, 
define coefficient coef_nu
0.2,
define coefficient coef_penalty
1e12, 0, 0,  

define fespace v -order=1 -dim=3
define fespace vstress -order=0 -dim=6

define gridfunction u -fespace=v
define gridfunction ugood -fespace=v
define gridfunction stress -fespace=vstress

define linearform f1 -fespace=v
neumann coef_source1 -comp=2

define linearform f -fespace=v
source coef_source -comp=2

define linearform f3 -fespace=v
neumann coef_source3 -comp=3

define bilinearform a -fespace=v
nonlinearelasticity coef_e coef_nu
robin coef_penalty -comp=1
robin coef_penalty -comp=2
robin coef_penalty -comp=3

#
# define preconditioner c -bilinearform=a -type=multigrid -coarsetype=direct -cycle=1
define preconditioner c -bilinearform=a -type=local
# define preconditioner c -bilinearform=a -type=direct
# define preconditioner c -bilinearform=a -type=amg
#
# numproc bvp np1 -bilinearform=a -linearform=f1 -gridfunction=u -preconditioner=c -print

numproc setvisual npvis -mminval=-0.02 -mmaxval=0.02 -autoscale=0 -scalfunction=stress.1 -vecfunction=ugood -deformation=1

numproc nonlinelast np2 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -loadsteps=1 -newtonsteps=60

#numproc nonlinelast np2  -bilinearform=a -linearform=f1 -gridfunction=u -preconditioner=c -loadsteps=10 -newtonsteps=60

#numproc nonlinelast np3  -bilinearform=a -linearform=f2 -gridfunction=u -preconditioner=c -loadsteps=10 -newtonsteps=60

#numproc nonlinelast np4  -bilinearform=a -linearform=f3 -gridfunction=u -preconditioner=c -loadsteps=10 -newtonsteps=100


# numproc calcflux np2a -bilinearform=a -solution=u -flux=p0
# numproc calcflux np2b -bilinearform=a -solution=u -flux=p1
# numproc calcflux np2c -bilinearform=a -solution=u -flux=p2
