# mesh = examples/twobody.vol
# mesh = examples/scale.vol
mesh = ngusers/mechanics/balls.vol


define coefficient coef_source
0.1, 0, 0, 0, 
# 0, (-1), 0, (-0.1),

define coefficient coef_e
200, 200, 200, 200, 
# 1000, 10, 10, 10, 210000, 210000,
define coefficient coef_nu
0.495, 0.495, 0.495, 0.495, 
#0.3, 0.3, 0.3, 0.3, 
define coefficient coef_rho
5, 5, 5, 5, 
# 0.01, 1, 100, 1, (7.8e-6), (7.8e-6), 
define coefficient coef_penalty
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 

define fespace v -order=1 -dim=2

define gridfunction u -fespace=v
define gridfunction ugood -fespace=v

define fespace vstress -order=0 -l2 -dim=3
define gridfunction stress -fespace=vstress
define gridfunction strain -fespace=vstress


define fespace vdist 
define gridfunction dist -fespace=vdist


define linearform f -fespace=v
source coef_source -comp=1

define bilinearform a -fespace=v -symmetric
nonlinearelasticity coef_e coef_nu
robin coef_penalty -comp=1
robin coef_penalty -comp=2

define bilinearform m -fespace=v -symmetric
mass coef_rho -comp=1
mass coef_rho -comp=2

#
# define preconditioner c -bilinearform=a -type=multigrid -coarsetype=direct -cycle=1
define preconditioner c -bilinearform=a -type=local
# define preconditioner c -bilinearform=a -type=direct
# define preconditioner c -bilinearform=a -type=amg
#
# numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c


numproc setvisual npvis -mminval=-0.02 -mmaxval=0.02 -autoscale=0 -scalfunction=stress.1 -vecfunction=ugood -deformation=1

numproc nonlinelast np2  -bilinearform=a -mass=m -linearform=f -gridfunction=u -preconditioner=c -loadsteps=10 -newtonsteps=3 -tend=500 -dt=2 -dynamic -contact

# numproc calcflux np2a -bilinearform=a -solution=u -flux=p0
# numproc calcflux np2b -bilinearform=a -solution=u -flux=p1
# numproc calcflux np2c -bilinearform=a -solution=u -flux=p2

# 17 min, t = 14.3672
