# mesh = examples/twobody.vol
# mesh = examples/scale.vol
geometry = ngusers/mechanics/pendel_cont.in2d
mesh = ngusers/mechanics/pend_cont5.vol

define constant secondorder = 1

define coefficient coef_source
0, (-0.01),
define coefficient coef_e
10, 10,
define coefficient coef_nu
0.3, 0.3,
define coefficient coef_rho
0.1, 0.1,
define coefficient coef_penalty
1e6, 1e6, 1e6, 1e6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
#0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

define fespace v -order=2 -dim=2

define gridfunction u -fespace=v 
define gridfunction ugood -fespace=v

define fespace vstress -order=0 -l2 -dim=3
define gridfunction stress -fespace=vstress
define gridfunction strain -fespace=vstress


define fespace vdist
define gridfunction dist -fespace=vdist


define linearform f -fespace=v
source coef_source -comp=2

define bilinearform a -fespace=v -symmetric
nonlinearelasticity coef_e coef_nu
robin coef_penalty -comp=1
robin coef_penalty -comp=2

define bilinearform m -fespace=v -symmetric
mass coef_rho -comp=1
mass coef_rho -comp=2

# define preconditioner c -bilinearform=a -type=local
define preconditioner c -bilinearform=a -type=direct


# numproc setvisual npvis -mminval=-1 -mmaxval=1 -autoscale=0 -scalfunction=stress.2 -vecfunction=ugood -deformation=1 -autoredraw=1 -autoredrawtime=0.3

numproc nonlinelast np2  -bilinearform=a -mass=m -linearform=f -gridfunction=u -preconditioner=c -loadsteps=10 -newtonsteps=3 -tend=500 -dt=0.1 -dynamic -contact
