geometry = ngusers/mechanics/pendelf.geo
mesh = ngusers/mechanics/pendelf.vol


define coefficient coef_source
(-0.01), (0),
# (-78000), (-78000),

define coefficient coef_rho
1, 1, 
# (7800), (7800),

define coefficient coef_e
10000, 10000, 
# 2.1e8, 2.1e8,
define coefficient coef_nu
0.2, 0.2,
define coefficient coef_penalty
0, 0, 1e24, 0, 0,  

define fespace v -order=1 -vec
define fespace vstress -order=0 -l2 -symtensor

define gridfunction u -fespace=v
define gridfunction ugood -fespace=v
define gridfunction stress -fespace=vstress
define gridfunction strain -fespace=vstress

define linearform f -fespace=v
source coef_source -comp=3


define bilinearform a -fespace=v -symmetric
nonlinearelasticity coef_e coef_nu
dirichletpenalty coef_penalty -comp=1
dirichletpenalty coef_penalty -comp=2
dirichletpenalty coef_penalty -comp=3

define bilinearform m -fespace=v -symmetric
mass coef_rho -comp=1
mass coef_rho -comp=2
mass coef_rho -comp=3



#
# define preconditioner c -bilinearform=a -type=multigrid -coarsetype=direct -cycle=1
# define preconditioner c -bilinearform=a -type=local
define preconditioner c -bilinearform=a -type=direct
# define preconditioner c -bilinearform=a -type=amg
#
# numproc bvp np1 -bilinearform=a -linearform=f1 -gridfunction=u -preconditioner=c -print

numproc setvisual npvis -mminval=-0.02 -mmaxval=0.02 -autoscale=0 -scalfunction=stress.1 -vecfunction=ugood -deformation=1

numproc nonlinelast np2 -bilinearform=a -mass=m -linearform=f -gridfunction=u -preconditioner=c -loadsteps=1 -newtonsteps=4 -dynamic -dt=0.1 -tend=500 -contact


# numproc calcflux np2a -bilinearform=a -solution=u -flux=p0
# numproc calcflux np2b -bilinearform=a -solution=u -flux=p1
# numproc calcflux np2c -bilinearform=a -solution=u -flux=p2
