geometry = ngusers/mechanics/plate.geo
mesh = ngusers/mechanics/plate.vol

define constant secondorder = 0
define constant geometryorder = 3

define coefficient e
1e7,

define coefficient nu
0.3,

define coefficient rho
7.8e3,

define coefficient penalty
0, 0, 0, 0, 0,

define coefficient coef_load
(-76518),

define coefficient one
1,

# bei order>1 -hb bei v und vscal anfuegen!

define fespace v -dim=3 -order=3 -hb
define fespace vscal -dim=1 -order=3 -hb
define fespace vp -dim=6 -order=1 

define gridfunction u -fespace=v
define gridfunction u0 -fespace=v
define gridfunction usmall -fespace=v
define gridfunction v -fespace=v
define gridfunction veca -fespace=v
define gridfunction stress -fespace=vp

define bilinearform a -fespace=v
elasticity e nu


define bilinearform m -fespace=v
mass rho -comp=1
mass rho -comp=2
mass rho -comp=3



define bilinearform hmat -fespace=v

define linearform f -fespace=v
source coef_load -comp=2


define bilinearform aid -fespace=v -nonassemble
mass one

numproc drawflux npdraw1 -bilinearform=a -solution=usmall -applyd -label=stress2


#define preconditioner c -type=multigrid -bilinearform=a

#numproc setvisual npvis -mminval=-4000000 -mmaxval=4000000 -autoscale=0 -vecfunction=u -deformation=1

#funktioniert:
#numproc mbs np1 -bilinearforma=a -bilinearformm=m  -gridfunctionu=u -gridfunctionv=v -gridfunctionusmall=usmall -gridfunctionstress=stress -dt=0.0025 -te=10 -connections=[1,0,2,0]

numproc mbs np1 -bilinearforma=a -bilinearformm=m  -gridfunctionu=u -gridfunctionv=v -gridfunctionusmall=usmall -gridfunctionstress=stress -dt=0.01 -te=1000 -TI=R2 -connections=[1,0,2,0]
