#
#
geometry = ngusers/mechanics/proe_to_STEP.stp
mesh = ngusers/mechanics/proe_to_STEP.vol

# define constant secondorder = 0
define constant geometryorder = 1

define coefficient E
210000,

define coefficient nu
0.23,

define coefficient rho
7800

define coefficient penalty
0, 1e10, 0, 0, 

define coefficient coef_forcez
0, 0, 1e5, -1e5,

define fespace v -dim=3 -order=3
define fespace vp -dim=6  -order=2

define gridfunction u -fespace=v
define gridfunction stress -fespace=vp

define linearform f -fespace=v
neumann coef_forcez -comp=3

define bilinearform a -fespace=v -symmetric  
elasticity E nu
robin penalty  -comp=1
robin penalty  -comp=2
robin penalty  -comp=3

# define bilinearform m -fespace=v  -symmetric
# mass rho -comp=1
# mass rho -comp=2
# mass rho -comp=3


# define preconditioner c -type=direct -bilinearform=a -notest
define preconditioner c -type=multigrid -bilinearform=a -notest -smoother=block
# define preconditioner c -type=local -bilinearform=a -block


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=200

# numproc evp np1 -bilinearforma=a -bilinearformm=m  -gridfunction=u -preconditioner=c
numproc calcflux np2 -bilinearform=a -solution=u -flux=stress
numproc drawflux np2b -bilinearform=a -solution=u -label=drawstress

# define fespace verr -l2 -order=0
# define gridfunction err -fespace=verr
# numproc zzerrorestimator np3 -bilinearform=a -linearform=f -solution=u -error=err -minlevel=0
# numproc markelements np4 -error=err -minlevel=1 -factor=0.5
