#
## Kurbelwelle + Pleuel
#
algebraic3d

# cut cylinder by planes:

solid p1 = plane (-15, 0, 0; -1, 0, 0) -bc=1;
solid p2 = plane (45, 0, 0; 1, 0, 0) -bc=2;
solid p3 = cylinder (9, 0, 20; 21, 0, 20; 3.5) -bc=3;

solid shaft1 = cylinder ( -15, 0, 0; 1, 0, 0; 5)
	and p1
	and plane (1, 0, 0; 10, 0, 0);

solid shaft2 = 
	    plane (0, 0, 0; -1, 0, 0)
	and plane (10, 0, 0; 1, 0, 0)
	and (cylinder (0, 0., 0.; 10, 0., 0.; 11)
	     or cylinder (0, 0, 20; 10, 0, 20; 6)
	     or (    plane (0, 5, 0; 0, 1, 0)
	    	 and plane (0, -5, 0; 0, -1, 0)
		 and plane (0, 0, 0; 0, 0, -1)
		 and plane (0, 0, 20; 0, 0, 1)));  

solid shaft3 = p3
	and plane (9, 0, 0; -1, 0, 0)
	and plane (21, 0, 0; 1, 0, 0);

solid shaft4 = 
	    plane (20, 0, 0; -1, 0, 0)
	and plane (30, 0, 0; 1, 0, 0)
	and (cylinder (20, 0., 0.; 30, 0., 0.; 11)
	     or cylinder (20, 0, 20; 30, 0, 20; 6)
	     or (    plane (0, 5, 0; 0, 1, 0)
	    	 and plane (0, -5, 0; 0, -1, 0)
		 and plane (0, 0, 0; 0, 0, -1)
		 and plane (0, 0, 20; 0, 0, 1)));  

solid shaft5 = cylinder ( 29, 0, 0; 45, 0, 0; 5)
	and plane (29, 0, 0; -1, 0, 0)
	and p2;
	
solid shaft = shaft1 or shaft2 or shaft3 or shaft4 or shaft5 -bc=11;


solid p4 = cylinder (12, 0, 20; 18, 0, 20; 3.6) -bc=4;
solid p5 = cylinder (12, 0, 80; 18, 0, 80; 3.6) -bc=5;
solid p9 = plane (0, -4, 24; 0, -1, 0) -bc=9;
solid p10 = plane (0,  4, 24; 0,  1, 0) -bc=10;

solid pl1 = cylinder (10.1, 0, 20; 19.9, 0, 20; 7)
	and not p4
	and plane (10.1, 0, 0; -1, 0, 0)
	and plane (19.9, 0, 0;  1, 0, 0);

solid pl2 = cylinder (9.1, 0, 80; 20.9, 0, 80; 7)
	and not p5
	and plane (9.1, 0, 0; -1, 0, 0)
	and plane (20.9, 0, 0;  1, 0, 0);

solid pl3 = p9
	and p10
	and plane (0,  4, 24.5; 0,  0,-1)
	and plane (0,  4, 75.5; 0,  0, 1)
	and plane (13, 0, 0; -1, 0, 0)
	and plane (17, 0, 0;  1, 0, 0);
	
solid pleuel = (pl1 or pl2 or pl3) -bc=11;


solid p6 = cylinder (-1, 0, 80; 31, 0, 80; 3.5) -bc=6;
solid p7 = plane (0., -15, 70; 0, -1, 0) -bc=7;
solid p8 = plane (30., 15, 95; 0, 1, 0) -bc=8;
solid p12 = plane (30., 15, 95;  0, 0, 1) -bc=12;

solid cub1 = 
	    plane (0., -15, 70; -1, 0, 0)
	and p7
	and plane (0., -15, 70; 0, 0, -1)
	and plane (30., 15, 95;  1, 0, 0)
	and p8
	and p12;
	
solid cub2 = 
	    plane (9, -12, 60; -1, 0, 0)
	and plane (9, -12, 60; 0, -1, 0)
	and plane (9, -12, 60; 0, 0, -1)
	and plane (21, 12, 90;  1, 0, 0)
	and plane (21, 12, 90;  0, 1, 0)
	and plane (21, 12, 90;  0, 0, 1);
	
solid cyl3 = p6
	and plane (1, 0, 80; -1, 0, 0)
	and plane (29, 0, 80; 1, 0, 0);

solid cyl = cub1 and not cub2 or cyl3 -bc=11;

solid brick1 = orthobrick(-15,-35,-10; -0.1,10,10);
solid brick2 = orthobrick(30.1,-35,-10; 45,10,10);
solid brick3 = orthobrick(-15,-35,-10; 45,-30,10);

solid fix1 = brick1
      	or brick2
	or brick3
	and not cylinder ( -15, 0.1, 0; -0.1, 0.1, 0; 5.1)
	and not cylinder ( 30.1, 0.1, 0; 45, 0.1, 0; 5.1) -bc=13;
	
solid cub3 = 
	    plane (-3, -20, 40; -1, 0, 0)
	and plane (-3, -20, 40; 0, -1, 0)
	and plane (-3, -20, 40; 0, 0, -1)
	and plane (33, 20, 105;  1, 0, 0)
	and plane (33, 20, 105; 0, 1, 0)
	and plane (33, 20, 105;  0, 0, 1);
	
solid cub4 = 
	    plane (-10.1, -15.1, 30; -1, 0, 0)
	and plane (-10.1, -15.1, 30; 0, -1, 0)
	and plane (-10.1, -15.1, 30; 0, 0, -1)
	and plane (40.1, 15.1, 100;  1, 0, 0)
	and plane (40.1, 15.1, 100;  0, 1, 0)
	and plane (40.1, 15.1, 100;  0, 0, 1);

solid fix2 = cub3 and not cub4 -bc=14;

tlo shaft -transparent;
tlo pleuel -col=[0,1,0];
tlo cyl -col=[1,0,0];
# tlo fix1 -col=[0.6,0.6,0] -transparent;
# tlo fix2 -col=[0.6,0.6,0] -transparent;

