geometry = ngusers/mechanics/slider-crank.geo
mesh = ngusers/mechanics/slider-crank.vol


define coefficient coef_source
(-0.05), (0), (0), (0), (0),
#(-50), (-50), (-50), (0), (0),

define coefficient coef_rho
7.8e-6, 7.8e-6, 7.8e-6, 1, 1,
#7.8, 1, 1, 0.1, 0.1,

define coefficient coef_e
2.1e5, 2.1e5, 2.1e5, 2.1e5, 2.1e5, 
#1e6, 1e6, 1e6, 1e6, 1e6,

define coefficient coef_nu
0.3, 0.3, 0.3, 0.3, 0.3,
#0.3, 0.3, 0.3, 0.3, 0.3,

define coefficient coef_penalty
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1e6, 1e6,

define fespace v -order=1 -vec
define fespace vstress -l2 -order=0 -symtensor

define gridfunction u -fespace=v
define gridfunction ugood -fespace=v
define gridfunction stress -fespace=vstress
define gridfunction strain -fespace=vstress

define linearform f -fespace=v
source coef_source -comp=2


define bilinearform a -fespace=v -symmetric
nonlinearelasticity coef_e coef_nu
dirichletpenalty coef_penalty -comp=1
dirichletpenalty coef_penalty -comp=2
dirichletpenalty coef_penalty -comp=3

define bilinearform m -fespace=v -symmetric
mass coef_rho -comp=1
mass coef_rho -comp=2
mass coef_rho -comp=3

#
# define preconditioner c -bilinearform=a -type=multigrid -coarsetype=direct -cycle=1
# define preconditioner c -bilinearform=a -type=local
define preconditioner c -bilinearform=a -type=direct
# define preconditioner c -bilinearform=a -type=amg
#
# numproc bvp np1 -bilinearform=a -linearform=f1 -gridfunction=u -preconditioner=c -print

numproc setvisual npvis -mminval=-20 -mmaxval=20 -autoscale=0 -scalfunction=ugood.2 -vecfunction=ugood -deformation=1

numproc nonlinelast np2 -bilinearform=a -mass=m -linearform=f -gridfunction=u -preconditioner=c -loadsteps=1 -newtonsteps=4 -dynamic -dt=0.001 -tend=500 -contact



# numproc calcflux np2a -bilinearform=a -solution=u -flux=p0
# numproc calcflux np2b -bilinearform=a -solution=u -flux=p1
# numproc calcflux np2c -bilinearform=a -solution=u -flux=p2
