geometry = square_hp.in2d
mesh = square_sing.vol

# define constant hpref = 3
define constant geometryorder = 1
define constant heapsize = 10000000


define coefficient lam
1,  1,

define coefficient penalty_u
0, 0, 0, -1e15, 

define coefficient penalty_sigma
1e15, 1e15, 1e15, 0,


define coefficient zero
0, 0, 0, 

define coefficient one
1, 1, 

define coefficient small
1, 1, 1e-4, 1e-4, 

define coefficient vsmall
0, 0, 

define coefficient g
0, (y*(1-y)), 0, 0, 


define coefficient reg
-1e-8, 

define coefficient nu
0.3, 

define coefficient ddstab
1e-3

define coefficient alpha
0.5


define fespace v -mixedmech -order=1 -facetorder=1   -curlorder=2 -orderedge=2  -noeliminate_internal
# define fespace v -mixedmech -order=2 -facetorder=2   -curlorder=2 -orderedge=2  -noeliminate_internal
define gridfunction u -fespace=v

define linearform f -fespace=v
# sourceedge zero one -comp=2
neumannedge g g -comp=2 

define bilinearform a -fespace=v -symmetric  -noprintelmat -noeliminate_internal -linearform=f -noprint   -noelmatev
mixedmechjumps
mixedmech one nu 
# mixedmechstab one nu alpha
robinedge penalty_u -comp=2
robinhdivsym penalty_sigma -comp=1
# divdivhdivsym small -comp=1
massedge reg -comp=2
# divdivdivdivhdivsym ddstab -comp=1

define preconditioner c -type=direct -bilinearform=a
numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=5





define fespace vref -mixedmech -order=2 -facetorder=2 -curlorder=3 -orderedge=3 -noeliminate_internal
define gridfunction uref -fespace=vref

define linearform fref -fespace=vref
neumannedge g g -comp=2 
# sourceedge zero one -comp=2


define bilinearform aref -fespace=vref -symmetric  -noprintelmat -noeliminate_internal -linearform=fref
mixedmechjumps
mixedmech one nu 
# mixedmechstab one nu alpha
robinedge penalty_u -comp=2
robinhdivsym penalty_sigma -comp=1
# divdivhdivsym small -comp=1
massedge reg -comp=2


define preconditioner cref -type=direct -bilinearform=aref
numproc bvp np1ref -bilinearform=aref -linearform=fref -gridfunction=uref -preconditioner=cref -maxsteps=5 -noprint






define bilinearform aid -fespace=v -nonassemble
masshdivsym lam -comp=1

define bilinearform adiv -fespace=v -nonassemble
divdivhdivsym lam -comp=1

define bilinearform adisp -fespace=v -nonassemble
massedge zero -comp=2

define bilinearform acurldisp -fespace=v -nonassemble
curlcurledge zero -comp=2


define bilinearform astab -fespace=v -nonassemble
mixedmechstab one nu alpha



define fespace verr -l2 -order=0
define gridfunction diffs -fespace=verr
define gridfunction diffu -fespace=verr
define gridfunction diffcurlu -fespace=verr

numproc difference npdiff -bilinearform1=aid -solution1=u -bilinearform2=aid -solution2=uref -diff=diffs -filename=l2sigma.err

numproc difference npdiff2 -bilinearform1=adisp -solution1=u -bilinearform2=adisp -solution2=uref -diff=diffu -filename=l2u.err

numproc difference npdiff3 -bilinearform1=acurldisp -solution1=u -bilinearform2=acurldisp -solution2=uref -diff=diffcurlu -filename=curlu.err




numproc drawflux np2 -bilinearform=a -solution=u -label=sigma
numproc drawflux np3 -bilinearform=adiv -solution=u -label=div_sigma
numproc drawflux np4 -bilinearform=adisp -solution=u -label=disp
numproc drawflux np5 -bilinearform=acurldisp -solution=u -label=curl


numproc drawflux np6 -bilinearform=astab -solution=uref -label=stab
numproc drawflux np7 -bilinearform=astab -solution=uref -label=stabd -applyd


numproc drawflux np2ref -bilinearform=a -solution=uref -label=sigmaref
numproc drawflux np3ref -bilinearform=adiv -solution=uref -label=div_sigmaref
numproc drawflux np4ref -bilinearform=adisp -solution=uref -label=dispref
numproc drawflux np5ref -bilinearform=acurldisp -solution=uref -label=curlref



# orig
# nu = 0.99
# total difference = 0.00996482
# total difference = 0.000306474
# total difference = 0.0286468

# nu = 0.3
# total difference = 0.00523342
# total difference = 0.000226864
# total difference = 0.0166565


# orig, p = 2,3,2
# total difference = 0.000648987
# total difference = 6.41362e-06
# total difference = 0.00114682

# alpha = 0.1, ddstab = 1
# total difference = 0.000576406
# total difference = 1.32468e-05
# total difference = 0.00183361

# alpha = 0.01, ddstab = 0.001
# total difference = 0.000685746
# total difference = 3.32879e-05
# total difference = 0.00380834

# alpha = 0.001, ddstab = 0.001
# total difference = 0.000801754
# total difference = 4.97107e-05
# total difference = 0.00622161

# Oslo
# orig  1,2,1
#  0.00589107
#  0.000273365
#  0.0193041


# no stab:
# 0.0135246
# 0.00568484
# 0.219665

# no stab, p=1,1; 1,1, source
# total difference = 0.0383618
# total difference = 0.00576502
# total difference = 0.0833829
# level=2
# total difference = 0.020909
# total difference = 0.00160832
# total difference = 0.0418672

# no stab, p=2,1; 2,2
# total difference = 0.00537841
# total difference = 0.000247292
# total difference = 0.0176672

# total difference = 0.00309637
# total difference = 3.70029e-05
# total difference = 0.00722781

# no stab, p=2,2; 2,2
# total difference = 0.00287035
# total difference = 7.35303e-05
# total difference = 0.00585698




# no stab, p=1,1; 1,1, neumann:
# total difference = 0.0196568
# total difference = 0.00308639
# total difference = 0.0437247

# total difference = 0.0104613
# total difference = 0.000856588
# total difference = 0.0217653

# p=2,1; 2,2
# total difference = 0.00173741
# total difference = 6.84085e-05
# total difference = 0.00500156

# total difference = 0.000920318
# total difference = 1.11062e-05
# total difference = 0.00205547




# no stab, p=2,2; 2,2, neumann:
# total difference = 0.00107314
# total difference = 2.35289e-05
# total difference = 0.00202679

# total difference = 0.000791883
# total difference = 4.97395e-06
# total difference = 0.00148773


# non-conforming, p=1,1,1,1:  
# total difference = 0.0181918
# total difference = 0.0013773
# total difference = 0.0427481

# total difference = 0.0093833
# total difference = 0.000355461
# total difference = 0.022684

# non-conforming, p=2,1,2,2
# total difference = 0.00175837
# total difference = 7.29856e-05
# total difference = 0.00511629




# non-conforming, p=2,2,2,2:  
# total difference = 0.00103546
# total difference = 2.33657e-05
# total difference = 0.00189894
