geometry = shell_thin.geo
mesh = shell_thin.vol

define constant heapsize = 500000000

define constant geometryorder = 3



define coefficient penalty_u
-1e25, 0, 0, 0,

define coefficient penalty_sigma
0, 1e35, 1e35, 1e35, 1e35, 

define coefficient fx
1, 


define coefficient gx
0, 1, 1, 1, 1, 1, 


define coefficient gz
0, 0, 0, 0, 1, 0, 0, 0, 

define coefficient zero
0, 0, 0, 0, 0, 0, 



define coefficient E
1, 

define coefficient stab
1, 

define coefficient vstab
0,


define coefficient reg
-1e-6, 

define coefficient nu
0.3,

define coefficient alpha
0.5,




define fespace v -mixedmech -order=1 -curlorder=2 -noeliminate_internal
define gridfunction u -fespace=v
define gridfunction u2 -fespace=v


define linearform f -fespace=v
sourceedge zero zero fx   -comp=2 -order=6
# neumannedge zero zero gz  -comp=2 -order=8


define bilinearform a -fespace=v -symmetric    -noeliminate_internal -linearform=f -noprintelmat
mixedmechjumps
mixedmech E nu -order=8
mixedmechstab E nu alpha -order=8
robinedge penalty_u -comp=2 -order=8
robinhdivsym penalty_sigma -comp=1 -order=8
massedge reg -comp=2 -order=2



define preconditioner c -type=direct -bilinearform=a
numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=3 -noprint




define bilinearform asigma -fespace=v -nonassemble
masshdivsym E -comp=1

define bilinearform adiv -fespace=v -nonassemble
divdivhdivsym E -comp=1

define bilinearform adisp -fespace=v -nonassemble
massedge E -comp=2
robinedge E -comp=2



numproc drawflux np2 -bilinearform=asigma -solution=u -label=sigma
numproc drawflux np3 -bilinearform=adiv -solution=u -label=div_sigma
numproc drawflux np4 -bilinearform=adisp -solution=u -label=disp


# numproc shapetester st -bilinearform=asigma -gridfunction=u2
# numproc drawflux np4 -bilinearform=asigma -solution=u2 -label=shapetester



define fespace vdisp -order=3 -dim=3 -h1ho
define gridfunction displacement -fespace=vdisp

numproc calcflux npcf1 -bilinearform=adisp -solution=u -flux=displacement




define fespace vsigma -order=3 -dim=6 -h1ho
define gridfunction stress -fespace=vsigma

numproc calcflux npcf2 -bilinearform=asigma -solution=u -flux=stress