geometry = ngusers/etc/infinite2.in2d
mesh = ngusers/etc/infinite2f.vol

define constant geometryorder = 3
define constant heapsize = 10000000

define constant k = 20

define coefficient lam
1, 1, 

define coefficient rho
(-k*k), (-k*k),

define coefficient rho_boundary
(-k*k), (-k*k),


define coefficient coef_k
(k), (k),

define coefficient coef_r
1, 1, 

define coefficient coef_fac_laplace
1, 1, 

define coefficient coef_s0r
10, 10, 

define coefficient coef_s0i
50, 50, 




define coefficient coef_source
1e7, 0, 

define coefficient absorb
0, (-k), 

define coefficient absorb_re
0, 0.5, 


define fespace v -infinitefe -complex -order=3 -inf_per_node=39 -inf_bound=2
define fespace vabs  -complex -order=1

define gridfunction u -fespace=v
define gridfunction uabs -fespace=vabs

define bilinearform a -fespace=v -noprint -noprintelmat
laplace lam
mass rho
# robin absorb -imag
# cut_ieq coef_k coef_r -definedon=2
hardysymmetric rho_boundary coef_fac_laplace coef_r coef_s0r coef_s0i    -definedon=2
# axis_ode coef_k coef_r -definedon=2

define bilinearform aabs -fespace=vabs 
laplace lam
mass rho
robin absorb -imag
robin absorb_re

define linearform f -fespace=v
source coef_source

define linearform fabs -fespace=vabs
source coef_source

define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -coarsetype=smoothing

define preconditioner cabs -type=direct -bilinearform=aabs 

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=10000 -noprint -cg -prec=1e-10

# numproc polecond np2  -bilinearform=a -linearform=f -gridfunction=u -maxsteps=50

