geometry = ngusers/pml/infinite_sphere.geo
mesh = ngusers/pml/infinite_sphere.vol

define constant k = 10

define constant geometryorder = 3

define coefficient lam
1, 1, 

define coefficient rho
(-k*k), (-k*k),

define coefficient coef_k
(k), (k),

define coefficient coef_r
1, 1, 

define coefficient coef_source
1e6, 0, 

define coefficient absorb
0, (-k), 

define coefficient absorb_re
0, 0.5, 


define fespace v -infinitefe -complex -order=3 -inf_per_node=6

define gridfunction u -fespace=v

define bilinearform a -fespace=v -nonsym -noprint
laplace lam
mass rho
cut_ieq coef_k coef_r -definedon=2
# axis_ode coef_k coef_r -definedon=2

define linearform f -fespace=v
source coef_source


define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -coarsetype=smoothing

# define preconditioner cabs -type=direct -bilinearform=aabs 

numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=10000 -noprint -qmr -prec=1e-10

# numproc polecond np2  -bilinearform=a -linearform=f -gridfunction=u -maxsteps=50

