geometry = ngusers/etc/circles.in2d
mesh = ngusers/etc/circles.vol

define constant k = 20

define coefficient lam
1, 1, 1,

define coefficient nu
0.3, 0.3, 0.3

define coefficient rho
(-k*k), (-k*k), (-k*k),

define coefficient coef_source
0, 0, 1, 

define coefficient coef_penalty
0, 1e5,

define coefficient coef_absorb
0, (k),

define fespace v -complex -dim=2
define gridfunction u -fespace=v

define bilinearform a -fespace=v
PML_elasticity lam nu
PML_mass rho -comp=1
PML_mass rho -comp=2
robin coef_penalty -comp=1
robin coef_penalty -comp=2

define linearform f -fespace=v
source coef_source -comp=2

define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -coarsetype=smoothing


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=10000  -qmr

