geometry = ngusers/etc/pml_laser.geo
mesh = ngusers/etc/pml_laser.vol

define constant geometryorder = 3
define constant k = 20

define coefficient nu
1, 1, 1, 1, 

define coefficient eps
(-k*k), (-k*k), (-k*k), (-k*k), 

define coefficient epsplus
(k*k), (k*k), (k*k), (k*k), 

define coefficient coef_source
1e5, 0, 0, 0, 

define coefficient sigma
(-k), (-k), (-k), (-k),



define coefficient coef_null
0, 0, 0, 0, 



define fespace v -hcurlho -complex -order=4
define gridfunction u -fespace=v

define bilinearform a -fespace=v -symmetric
PML_curlcurledge nu
PML_massedge eps
massedge sigma -imag

define bilinearform apre -fespace=v -symmetric
PML_curlcurledge nu
PML_massedge epsplus

define linearform f -fespace=v
curledge coef_null coef_null coef_source

# define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block
define preconditioner c -type=multigrid -bilinearform=apre -smoothingsteps=1 -smoother=block -coarsetype=direct


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=5000

