# geometry = ngusers/etc/circles.in2d
# mesh = ngusers/etc/circles.vol

geometry = ngusers/pml/rect.in2d
mesh = ngusers/pml/rect.vol

define constant k = 30

define coefficient lam
1, 1, 1,

define coefficient rho
(-k*k), (-k*k), (-k*k),

define coefficient coef_source
0, 0, 1e5, 

define coefficient coef_penalty
0, 1e5,


define fespace v -complex -order=4
define gridfunction u -fespace=v

define bilinearform a -fespace=v
PML_laplace lam
PML_mass rho 

define linearform f -fespace=v
source coef_source

define preconditioner c -type=direct -bilinearform=a
# define preconditioner c -type=local -bilinearform=a -block
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -coarsetype=smoothing


numproc bvp np1 -bilinearform=a -linearform=f -gridfunction=u -preconditioner=c -maxsteps=10000  -qmr

