geometry = ngusers/etc/infinite2.in2d
mesh = ngusers/etc/infinite2.vol


define constant k = 50

define coefficient lam
1, 1, 

define coefficient rho
(-k*k), (-k*k),

define coefficient damp
(-k), (-k),

define coefficient coef_k
(k), (k),

define coefficient coef_r
1, 1, 

define coefficient coef_source
1e6, 0, 




define fespace v -infinitefe -complex -order=4 -inf_per_node=6

define gridfunction u -fespace=v


define bilinearform a -fespace=v -nonsym -noprint
laplace lam
mass rho
cut_ieq coef_k coef_r -definedon=2


define bilinearform a2 -fespace=v -nonsym -noprint
laplace lam
mass rho
mass damp -imag
cut_ieq coef_k coef_r -definedon=2



define linearform f -fespace=v
source coef_source


# define preconditioner c -type=direct -bilinearform=a2
define preconditioner c -type=local -bilinearform=a2 -block
# define preconditioner c -type=multigrid -bilinearform=a -smoothingsteps=1 -smoother=block -coarsetype=smoothing

numproc bvp np1 -bilinearform=a2 -linearform=f -gridfunction=u -preconditioner=c -maxsteps=10000 -noprint  -prec=1e-10 -qmr



