# geometry = diode0_ref.in2d
# mesh = diode0_ref.vol

geometry = diode0.in2d
mesh = diode0c.vol

# define constant geometryorder = 1

define coefficient one
1, 1, 


define coefficient pot
1000, 0, 0, 0, 

define coefficient densityn
-0.1, -1000, 0, 0, 0, 

define coefficient densityp
-1000, -0.1, 0, 0, 


define coefficient rho
1000, -1000, 

define coefficient outerboundn
0, 0, 1e18, 0, 

define coefficient outerboundp
0, 0, 1e18, 0, 

define coefficient outerboundphi
0, 0, 1e18, 0, 


# upwind factor
define coefficient fac
1, 1, 


define fespace v -mixedDD -order=-1

define bilinearform a -fespace=v -noprintelmat
mixedDD
mixedDDjumps fac
robinhdiv outerboundphi -comp=1
robinhdiv outerboundn -comp=3
robinhdiv outerboundp -comp=5

define bilinearform arhs -fespace=v
mixedDDrhs

define linearform f -fespace=v -noprintelvec
source rho -comp=2
neumannhdiv pot -comp=1
neumannhdiv densityn -comp=3
neumannhdiv densityp -comp=5


define gridfunction u -fespace=v -nested
define gridfunction w -fespace=v -nested

numproc mixedDD np1 -dt=0.1 -taurec=1 -b=0.1 -te=100 -maxnewton=8
# numproc mixedDD np1 -dt=0.003 -taurec=0 -b=0 -te=0.2


define fespace verr -l2
define gridfunction err -fespace=verr

numproc markelements np4 -error=err -minlevel=1 -factor=0.5 


define bilinearform compe -fespace=v -nonassemble
masshdiv one -comp=1

define bilinearform compphi -fespace=v -nonassemble
mass one -comp=2

define bilinearform compjn -fespace=v -nonassemble
masshdiv one -comp=3

define bilinearform compn -fespace=v -nonassemble
mass one -comp=4

define bilinearform compjp -fespace=v -nonassemble
masshdiv one -comp=5

define bilinearform compp -fespace=v -nonassemble
mass one -comp=6



numproc drawflux df1 -bilinearform=compe -solution=u -label=E
numproc drawflux df2 -bilinearform=compphi -solution=u -label=phi
numproc drawflux df3 -bilinearform=compjn -solution=u -label=jn
numproc drawflux df4 -bilinearform=compn -solution=u -label=n
numproc drawflux df5 -bilinearform=compjp -solution=u -label=jp
numproc drawflux df6 -bilinearform=compp -solution=u -label=p

numproc drawflux df4w -bilinearform=compn -solution=w -label=dndt