geometry = diode.in2d
mesh = diode.vol

# geometry = diodehp.in2d
# mesh = diodehp.vol
# define constant hpref = 2


define constant electroncharge = 1e-19
define constant nd = 1e22
define constant na = 1e22


# define constant voltage = 0.3

define coefficient one
1, 1, 

define coefficient penalty
1e20, 1e20, 0, 0,

define coefficient pot
-1e-9, 0, 0, 0, 

define coefficient densityn
0, -1000, 0, 0, 0, 

define coefficient densityp
-1000, 0, 0, 0, 


# define coefficient zeta_bound
# ( (voltage-0.119161)*1e20), (0.119161*1e20), 0, 0,

define coefficient rho
(electroncharge*nd), (-electroncharge*na)

define coefficient outerboundn
1e18, 0, 1e18, 0, 

define coefficient outerboundp
0, 1e18, 1e18, 0, 

define coefficient outerboundphi
0, 0, 1e18, 0, 


# upwind factor
define coefficient fac
1, 1, 1, 1, 


define fespace v -mixedDD -order=-1

define bilinearform a -fespace=v -printelmat
mixedDD
mixedDDjumps fac
robinhdiv outerboundphi -comp=1
robinhdiv outerboundn -comp=3
robinhdiv outerboundp -comp=5

define bilinearform arhs -fespace=v -nonassemble 
mixedDDrhs


define linearform f -fespace=v -printelvec
source rho -comp=2
neumannhdiv pot -comp=1
neumannhdiv densityn -comp=3
neumannhdiv densityp -comp=5
# neumann pot -comp=1
# neumann zeta_bound -comp=2
# neumann zeta_bound -comp=3


define gridfunction u -fespace=v



numproc mixedDD np1 -dt=1e-13 -taurec=0.01 -b=1e10 -te=10






define bilinearform compe -fespace=v -nonassemble
masshdiv one -comp=1

define bilinearform compphi -fespace=v -nonassemble
mass one -comp=2

define bilinearform compjn -fespace=v -nonassemble
masshdiv one -comp=3

define bilinearform compn -fespace=v -nonassemble
mass one -comp=4

define bilinearform compjp -fespace=v -nonassemble
masshdiv one -comp=5

define bilinearform compp -fespace=v -nonassemble
mass one -comp=6


numproc drawflux df1 -bilinearform=compe -solution=u -label=E
numproc drawflux df2 -bilinearform=compphi -solution=u -label=phi
numproc drawflux df3 -bilinearform=compjn -solution=u -label=jn
numproc drawflux df4 -bilinearform=compn -solution=u -label=n
numproc drawflux df5 -bilinearform=compjp -solution=u -label=jp
numproc drawflux df6 -bilinearform=compp -solution=u -label=p