# geometry = diode.in2d
# mesh = diode.vol

geometry = diodehp.in2d
mesh = diodehp.vol

define constant hpref = 2


define constant electroncharge = 1e-19
define constant nd = 1e21
define constant na = 1e21


define constant voltage = 0.3



define coefficient penalty
1e20, 1e20, 0, 0,

define coefficient pot
(voltage*1e20), 0, 0, 0,

define coefficient zeta_bound
( (voltage-0.119161)*1e20), (0.119161*1e20), 0, 0,


define coefficient rho
(electroncharge*nd), (-electroncharge*na)


define fespace v -semiconductor -order=4


define bilinearform a -fespace=v -symmetric
semiconductor
robin penalty -comp=1
robin penalty -comp=2
robin penalty -comp=3




define linearform f -fespace=v
source rho -comp=1
neumann pot -comp=1
neumann zeta_bound -comp=2
neumann zeta_bound -comp=3



define bilinearform a2 -fespace=v -nonassemble
semiconductor

define linearform f2 -fespace=v
source rho -comp=1



define gridfunction u -fespace=v

# define preconditioner c -type=direct -bilinearform=a


numproc semiconductor np1 -prec1=1e-16 -n1=100 -tau2=0.5 -n2=20 -n=500 -prec2=1e-12



define bilinearform aeval -fespace=v -nonassemble
evalsemiconductor
numproc drawflux npdf -bilinearform=aeval -solution=u  -applyd